There are several versions of the atom files used to build the comp-type atoms.

if just e.g. atom_fe13-- it is what Phil Judge gave me in 2024 (and which appear to have been created in DIPER in 2020). 
(note the old files FORWARD used to use live in PHIL_OLD_2006)

For three ions, fe13, si10, and si9 -- I have updates from Alin Parashiv (e.g. alin_atom_fe13) which appear to have been written in 2020 at the same time as the ones Phil sent me -- and include "** Line to account for Sascha's calculation." and also appear to have maximum wavelenght (in units of QNORM) of 10 instead of 30

For these same three ions, I have updated the abundances to the most recent Chromospheric and photospheric abundances, to be consistent with the latest in FORWARD (otherwise, Phil's code outputs a very old version of chianti abundances). These are identified with the prefixes C_ and P_.  ***The default in FORWARD is to use the abundance-updated versions for these three atoms***

Note that FORWARD has had fe11,fe13,fe14,si9, and si10 for a while.

FE10 was added more recently. And then at the same time I requested some non Iron lines for comparison to UCoMP, AR13, S9, S11. Notes on these updates can be found in the emails from Phil below.

**Note that I have *not* checked/updated abundances for fe10, fe11, fe14, ar13, s9, s11, and FORWARD defaults to the versions sent to me by Phil in 2024 .**

Finally, Phil creates "input" files (which are in the directory PHIL_INPUT_FILES) -- this information is incorporated within the FORWARD code, for_compdefaults.pro in the DEFAULTS directory.





Below are emails from Phil
---------------------

Here is also S IX included along with all available atoms and input files now.

S IX is not easy to model to get intensities and polarization correct with a 
smaller atom and my fudge factor approach.

I will probably not build something for S XIII later because this is 
Be- like (I missed the "e" in my earlier email), the M1 transitions lie between 
the 3P states some 250 eV above the ground 1S state.  It's  in the triplet system
like He 10830 but while 10830 is E1 transitions,   these are transitions between the 
2s 2p 3PO metastable levels. Only the J=0, 2 levels are metastable of this excited term.
The J=1 level decays fast to the ground level via relativistic effects so
it will have a small population.   S XIII will therefore have almost no polarization 
because it will be populated only by collisions.   It is going to be dim, about 0.001 of the resonance
line at 256.68 Angstrom. 

so I think my job is done.


On Mon, Feb 26, 2024 at 6:04 PM Sarah Gibson <sgibson@ucar.edu> wrote:
Thanks, Phil!

On Mon, Feb 26, 2024 at 5:23 PM Philip Judge <judge@ucar.edu> wrote:

Here are atomic/input  models for Ar XIII.  Formed near 10^6.4 K, there is little 
contribution from cascades from the higher levels, nor any need for 
cecoeff > 0.

Also for isolectronic S XI, where I added some depolarizing transitions to mimic
depolarization from E1 lines.  

The files appended with "big" are large multi-level atoms including the strongest E1
transitions which decay to the upper levels of the smaller atoms, and should include 
all depolarization rates and collisional excitations needed,   I matched output of
one with the other to make the smaller files.    For the runs use the not big files





On Thu, Feb 22, 2024 at 5:16 PM Philip Judge <judge@ucar.edu> wrote:

Fe X attached, it will take a little while to build the other non-Fe ions, 
one morning should be enough, I have to add in special energy level to mimic
collisions from tens of real levels.

On Thu, Feb 22, 2024 at 1:39 PM Sarah Gibson <sgibson@ucar.edu> wrote:
Thanks, Phil! This is helpful.

In addition to the Fe13 and Si10 bold-faced below, FORWARD currently has Fe11, Fe14, and Si9. So I think the only one missing from your current list is Fe10. Could you send me your CLE files (atom, input) for Fe10?

And then, any other lines you build I'd be happy to add.

cheers
Sarah


On Thu, Feb 22, 2024 at 10:51 AM Philip Judge <judge@ucar.edu> wrote:


Here are the atomic ions for which I have built suitable small numbers of
levels to make them tractable for production work with cle.

atom.fe10 (i.e. Fe X)
atom.fe11
atom.fe13
atom.fe14
 atom.si10
 atom.si9

so nothing so far but Fe and Si.   

Ar XIII is isoelectronic with C and so 
will have a ^3P_{0,1,2} ground level structure (like Fe XIII).  

S XIII is isoelectronic with B and so has a ^1S_0 ground state.
The transition at 1083 nm will be between metastable ^3P levels at 24 eV
(in this sense it is a bit like He I 1083 but with n=2 instead of n=1)

S XI is isoelectronic with C just like Ar XIII
S IX is isoelectronic with O so has ^3P_{2.1.0} like Fe XI with J=2 lowest level
(Hund's rule).  

I would expect the S XIII line to be relatively weak based on the 
isoelectronic line of Si XI at 1933 nm computed in my 1998 paper

I'll build suitable models for the other ions including the usual 
equivalent level to include cascades from levels excited by E1 
transitions








On Wed, Feb 21, 2024 at 8:50 AM Sarah Gibson <sgibson@ucar.edu> wrote:
Hi Phil -- I heard from Jenna Samra that these are the lines she'll be observing for the eclipse. I'm wondering if you know which of these could be modeled in CLE? The bold-faced are the ones already in FORWARD, but if the others are possible and you could provide atom and input files I could add them.

Also cc'ing Roberto and  Momo since they are working with Hanle RT including 10830.

Jenna is on an ISSI team that I am also on (also Supriya who gave the colloquium a week or so ago). Our intention is to set up some benchmark solar corona to forward model and compare results.

===lines in the ACES passband:

1014nm Ar XIII
1030nm S XIII
1075nm Fe XIII
1080nm Fe XIII
1083nm He I
1252nm S IX
1393nm S XI
1430nm Si X

cheers
Sarah
--

C
C PURPOSE: ADMINISTERS CALLING FOR SYNTHESIS OF M1 LINES ALONG ONE LOS
C
C INPUTS: IY, IZ: INDICES OF POINTS IN X AND Y GRID
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE M1SYNTH(IY,IZ)
C
C  SUBROUTINE FOR THE SYNTHESIS OF FORBIDDEN LINE STOKES 
C  PARAMETERS, ALONG A GIVEN LOS. 
C
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CGRID'
	INCLUDE 'CATOM'
	INCLUDE 'CATMOS'
	INCLUDE 'CATMO2'  
	INCLUDE 'CSLINE'
	INCLUDE 'CORON'
	INCLUDE 'CCONST'
	INCLUDE 'CINPUT'
	INCLUDE 'CINTS'
	INCLUDE 'CLU'
C
     	DIMENSION AA(MJTOT,MJTOT),BB(MJTOT)
     	DIMENSION T0(0:3,0:2)
	LOGICAL DISK,IGNORE
C
	CALL CPTIME('M1SYNT',0,0,2)
	DO KR=1,NLINE
	   DO M=0,4
	      DO NY=1,NQ(KR)
		 EMERGE(KR,M,NY)=ZERO
	      END DO
	   END DO
	END DO
C
C  SKIP IF LOS INTERSECTS THE DISK
C
	DISK=.FALSE.
	RRR=GZ*GZ+GY*GY
	IF(RRR .LE. ONE) DISK= .TRUE.
C
C  LOOP OVER THE LOS COORDINATE
C
	GXSTEP = (GXMAX-GXMIN)/(NGX-1)
	DO I=1,NGX
	   DO KR=1,NLINE
	      DO M=0,4
		 DO NY=1,NQ(KR)
		    EMISS(KR,M,NY)=ZERO
		 END DO
	      END DO
	   END DO
	   GX=FLOAT(I-1)*GXSTEP+GXMIN
	   WTX=RSUNCM*GXSTEP
	   IF(I .EQ. 1 .OR. I .EQ. NGX) WTX=0.5*WTX
C       
C       CALCULATE SOLAR PARAMETERS (HEIGHT, DENSITY, TEMPERATURE, 
C  MICROTURBULENCE, MAGNETIC FIELD IN CORONA)
C       
	   CALL CORONA
C       
C       IGNORE THOSE LOCATIONS WHERE LINE OF SIGHT IS EITHER
C       1. ON THE DISK
C       2. HAS ELECTRON DENSITY BELOW SMALL N
C       3. HAS SMALL ION FRACTIONS 
C       
	   IGNORE= DISK .OR. (ED .LT. SMALLN) .OR. 
     *      (TOTN .LT. 10.**(ABND-12.)*SMALLN)
	   CALL WATMOS(I,IY,IZ,IGNORE)
	   IF(.NOT. IGNORE) THEN 
	      CALL PROFIL
C       
C       LTE POPULATIONS AND COLLISIONAL RATES TO BE STORED
C       
	      IF(ICOLL .NE. 0) THEN 
		 CALL LTEPOP
		 CALL COLCAL
	      ENDIF
C       
C       BUILD AND SOLVE STATISTICAL EQUILIBRIUM EQUATIONS
C       
	      CALL SE0_BUILD(NDIM)
	      CALL SOLVE(NDIM,AA,BB)
	      IF(IDEBUG.EQ.1) WRITE(LOUT,100) 'M1SYNTH: TEMP, ED',TEMP,ED
 100	      FORMAT(A,1P,2(1X,E9.2))
	      CALL SE0_COPY(NDIM,BB)
C       
C       SOLVE FOR EMERGENT STOKES PROFILES
C       
	      CALL T0TENS(T0)
C       
	      DO KR=1,NLINE
		 IF ((ALAMB(KR).GE.WLMIN).AND.(ALAMB(KR).LE.WLMAX))
     *               CALL EMISSION(KR,T0)
	      END DO
	      CALL TRAP(WTX)
	      CALL WDEBUG
	   ENDIF
	END DO
 	CALL CPTIME('M1SYNT',0,1,2)
	RETURN
	END

C
C PURPOSE: LEFT JUSTIFIES THE STRING TEXT
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE LJUST(TEXT)
C
C  LEFT JUSTIFIES THE STRING TEXT
C
      INCLUDE 'PREC'
      CHARACTER*(*) TEXT
C
      L=LEN(TEXT)
      DO 100 J=1,L
        IF(TEXT(J:J).NE.' ') GOTO 200
  100 CONTINUE
  200 CONTINUE
      DO 300 I=1,L
        IF(J.LE.L) THEN
          TEXT(I:I)=TEXT(J:J)
        ELSE
          TEXT(I:I)=' '
        ENDIF
        J=J+1
  300 CONTINUE
C
      RETURN
      END
C
C************************************************************************
C

C
C PURPOSE: COMPUTE ELASTIC COLLISION RATES CE FOR EQN (20) OF 
C          CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539
C          THE COMPLETE COEFFICIENT NEEDED FOR EQ. (20) IS 
C          BUILT BY SUMMING OUTSIDE OF THIS ROUTINE IN ROUTINE
C          SE0_BUILD
C INPUTS:
C          IJ       INDEX OF LEVEL.  
C          K        MULTIPOLAR COEFFICIENT
C OUTPUTS:
C          CE 
C COMMON:
C          CSE, SGNM
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	FUNCTION CE(IJ,K)
C  THIS FUNCTION CALCULATES THE ELASTIC COLLISIONAL RATES C_E(IJ,K)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
C
	RJ=AJ(IJ)
	RK=FLOAT(K)
	JJ=2*NINT(RJ)
	CETMP=ZERO
C  note the step by 2 was added in Phil's 6jul22 version
	DO K1=0,JJ,2
	  RK1=FLOAT(K1)
     	  CETMP=SG(K1)*FUN6J(RJ,RJ,RK,RJ,RJ,RK1)*GAMMAE(IJ,K1)
     /	  +CETMP
	END DO
	CE=SG(JJ-K)*(FLOAT(JJ)+ONE)*CETMP
	RETURN
	END

C
C PURPOSE: Calculates the rotation matrix	d[rJ,rM1,rM](thet)
c       for -180 < thet < 180
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: October 6, 1999, P. JUDGE
C 
	function rdmat(rJ,rM1,rM,thet)
	include 'PREC'
	include 'PARAM'
	include 'CCONST'
	include 'SGNM'
	include 'FACT'

	Th=thet*PI/.18d3

	cc=dcos(.5d0*Th)
	ss=dsin(.5d0*Th)

	ifs=idnint(rJ+rM)
	ifd=idnint(rJ-rM)
	ifs1=idnint(rJ+rM1)
	ifd1=idnint(rJ-rM1)
	imd=idnint(rM1-rM)
	imdf2=idnint(rJ+rJ)-imd

	imax=min0(ifs,ifd1)
	imin=max0(0,-imd)

	tmp=.0d0

	do i=imin,imax

	  i2=i+i

	  k1=imdf2-i2
	  k2=imd+i2

	  ecc=.0d0
	  ess=.0d0

	  if(dabs(thet).ne..18d3) then
	    ecc=cc**k1
	  else
	    if(k1.eq.0) ecc=.1d1
	  end if

	  if(dabs(thet).ne..0d0) then
	    ess=ss**k2
	  else
	    if(k2.eq.0) ess=.1d1
	  end if

	  k=imd+i

	  tmp=sg(k)*dexp(-fl(k)-fl(ifs-i)-fl(ifd1-i)-fl(i))*ecc*ess+tmp

	end do

	rdmat=dexp(.5d0*(fl(ifs)+fl(ifd)+fl(ifs1)+fl(ifd1)))*tmp

	return
	end

C
C PURPOSE: COMPUTE INELASTIC MULTIPOLAR COLLISIONAL RATE
C
C INPUTS:
C       I    UPPER LEVEL INDEX
C       IL   LOWER LEVEL INDEX
C       K     MULTIPOLAR INDEX
C OUTPUTS:
C       GAMMAI
C COMMON:
C       CATOM CLU
C RESTRICTIONS:  THE TOTAL COLLISIONAL RATES C(I,I) ARE ASSUMED
C       TO BE THE RESULT OF 1 MULTIPOLE COMPONENT.  THIS MAY NOT BE 
C       CONSISTENT WITH THE INPUT DATA. SEE THE README FILE WITH THIS PROGRAM. 
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C EDITED: JULY 26 2019 P. JUDGE
C       CHANGED TO INTEGER DO-LOOP VARIABLES
C       CHANGED C(I,J) TO MEAN COLLISIONS FROM J TO I
C 
C ---Sept 2022 replaced pre 6jul22 version
C	
	FUNCTION GAMMAI(I,IL,K)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'CLU'
	INCLUDE 'CATMOS'
	INCLUDE 'CATOM'
	INCLUDE 'CINPUT'
	INCLUDE 'CINTS'
	DATA ICALL /0/
	SAVE ICALL
	GAMMAI=ZERO
	IF(ICOLL .EQ. 0 .OR. IL.GE.I) RETURN
	IF(ICALL.EQ.0) THEN 
	   WRITE (LJOBLO,80)
 80	   FORMAT('GAMMAI AND GAMMAS:'/
     *     'E1 AND E2 TRANSITIONS, NO EXCHANGE OR STRONG COUPLING'/
     *     'OTHERS, STRONG COUPLING IS ASSUMED')
	   ICALL=ICALL+1
	ENDIF
	IF(ITTYPE(IL,I) .EQ. 1 .AND. K .EQ. 1) GAMMAI=C(I,IL)
	IF(ITTYPE(IL,I) .EQ. 2 .AND. K .EQ. 2) GAMMAI=C(I,IL)
	F=AJ(I) 
	FL=AJ(IL)
	FK=FLOAT(K)
C
C HERE WE ASSUME FOR SPIN-CHANGING AND STRONG COUPLING CASES
C THAT C(JL,I,N1,N) = C(JL,I)/(2*JL+1)
C CORRECTION 2019 June 3 PGJ, 
C THAT C(JL,I,N1,N) = C(JL,I)/(2*J+1)
C THIS IS FLAGGED FOR LEVELS JL AND J WHEN ITTYPE(JL,I) < ZERO
C 6 JUNE 2019: ADDED OPTION FOR ITTYPE=3
C
C       DIVIDE BY FINAL STATE 2J+1
C	TO CONSERVE PROBABILITY
C
	CASSUME=ZERO
	IF((ITTYPE(IL,I) .LT. 0 .OR. ITTYPE(IL,I) .GE. 3)
     *     .AND. ICOLL .NE. 2) 
     *    CASSUME=C(I,IL)/G(I)
C
C
C SKIP FURTHER CALCULATIONS IF NO MORE COLLISIONS ARE TO BE ADDED
C	
	IF(CASSUME .EQ. 0. .AND. ICOLLMM .EQ. 0) RETURN
C
C  CMM FORMALISM
C
C	THE VALUE OF CASSUME CONSERVES PROBABILITY WHEN THE COLLISION
C       CROSS SECTIONS ARE IDENTICAL BETWEEN SUBSTATES OF JUPPER AND JLOWER.
C	THE NOTATION IS ALWAYS C(A,B,M) ~ PROBABILITY OF MAKING A TRANSITION
C	** FROM LEVEL  B TO LEVEL A **
C
C       THIS IS THE EQUATION AFTER EQ (A4.2) OF LANDI DEGL'INNOCENTI
C	AND LANDOFI'S BOOK, FOR THE DIAGONAL CASE (NO COHERENCES, 
C       N=N', N''=N''').  THIS MEANS THAT THE GAMMAI COEFFICIENT
C	IS IDENTICALLY THE SUM OF COLLISION RATES C(JN,I'N') I.E.
C	TRANSFER OF *POPULATION* BETWEEN M-STATES
C
	NLO=INT(G(IL)-ONE)
	NUP=INT(G(I)-ONE)
	DO NL=-NLO,NLO,2
	   AL=FLOAT(NL)/2.
	   DO NU=-NUP,NUP,2
	      AU=FLOAT(NU)/2.
C
C EQUATION AFTER EQ (A4.2) OF LANDI DEGL'INNOCENTI, bottom page 800
C
	      DO M=0,K
		 P=FLOAT(M)
		 F3=FUN3J(FJ,FJL,FK,-AU,AL,P)
c 		 write(*,*) 'gammai ',K, M,F3 
		 GAMMAI=GAMMAI + (CMM(I,IL,NU/2,NL/2)+CASSUME) *F3*F3
     *                 * (TWO*FK+ONE)/G(IL)
	      ENDDO
	   ENDDO
	ENDDO
	IF(IDEBUG .NE. 0 .AND. GAMMAI .NE. 0.) THEN 
           WRITE(LOUT,*)
     *     'GAMMAI I,IL, K ',GAMMAI, I, IL, K
	   WRITE(LOUT,*)'ITTYPE  CASSUME ',ITTYPE(IL,I),CASSUME,C(IL,I)
	ENDIF
	RETURN
	END

C
C PURPOSE: COMPUTE RADIATIVE RATES R(1) FOR EQN (20) OF 
C          CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539
C          R1 IS INITIALIZED TO ZERO AND COMPUTED.
C INPUTS:
C       IJ
C OUTPUTS:
C       R1COEFF
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE R1(IJ,R1COEFF)
C
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'CINTS'
C
	R1COEFF=ZERO
C
	DO IJ1=1,IJ-1
	  R1COEFF=ECOEFF(IJ,IJ1)+R1COEFF
	END DO
C
	RETURN
	END

C
C PURPOSE: CONVERT FROM DELTA LAMBDA IN Q UNITS TO DELTA LAMBDA IN ANGSTROM
C
C INPUTS:
C     QQ DELTA LAMBDA IN TYPICAL DOPPLER WIDTH UNITS
C     KR RADIATIVE TRANSITION INDEX
C
C OUTPUTS:
C     DLAMB
C COMMON:
C     CATOM CCONST
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      FUNCTION DLAMB(QQ,KR)
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CCONST'
C
      QN=QNORM*1.E5/CC
      DLAMB=-ALAMB(KR)*QQ*QN/(1.0+QQ*QN)
      RETURN
      END
C
C************************************************************************
C

C
C PURPOSE: COMPUTE SIMPLE INELASTIC COLLISION RATES BETWEEN BOUND LEVELS ONLY
C
C INPUTS:
C
C OUTPUTS:
C     C(I,J)    INELASTIC COLLISION RATES BETWEEN LEVELS I AND J
C
C COMMON:
C        CATOM COLL CATMOS CATMO2 CCONST CINPUT CLU
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C
C MODIFICATIONS: PGJ JANUARY 11, 2006. CORRECTED RELATIONSHIP BETWEEN 
C                UPWARD AND DOWNWARD RATES FOR CPMM DATA.
C
C*********************************************************************
C
      SUBROUTINE COLCAL
C
C  GENERAL ROUTINE FOR COMPUTING COLLISIONAL RATES 
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'COLL'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CATMO2'
      INCLUDE 'CCONST'
      INCLUDE 'CINPUT'
      INCLUDE 'CLU'
      COMMON /COLCALC/ ICALL,TOLD,EDOLD,HDOLD(6)
      DATA ICALL,SMALL /0,-1.E-6/
      LOGICAL REDO
C
C  LOCAL VARIABLES: UP TO MTGRD POINTS IN TEMPERATURE GRID ALLOWED
C
      DIMENSION TGRID(MTGRD),CGRID(MTGRD)
      CHARACTER *20 KEY
C
      IF(ICALL .EQ. 0) THEN 
         TOLD=TEMP
         EDOLD=ED
         DO 303 I=1,6 
            HDOLD(I)=HD(I)
 303     CONTINUE
         ICALL=ICALL+1
      ENDIF
C
      REDO=(ABS(TOLD-TEMP)/TEMP .GT. SMALL)
C
C  RE-CALCULATE ALL
C
      IF(REDO) THEN BEGIN 
C
C  INITIALIZE COLLISIONAL RATES TO ZERO
C
      DO 300 J=1,NK
         DO 400 I=1,NK
            C(I,J)=0.0
            DO 401 L=-MJMAX,MJMAX
               DO 402 M=-MJMAX,MJMAX
                  CMM(I,J,L,M)=0.0
 402           CONTINUE
 401        CONTINUE
 400     CONTINUE
 300  CONTINUE
C
C  LOOP OVER COLLISIONS
C
      DO 100 ICOL=1,NCOL
C
C  IDENTIFY THE UPPER AND LOWER LEVELS:
C
         KEY=CKEY(ICOL)
         IL=ILC(ICOL)
         IH=IHC(ICOL)
         NTEMP=NTC(ICOL)
         NINTEP=NTEMP
         DO 200 IT=1,NTEMP
            TGRID(IT)=CTEMP(IT,ICOL)
            CGRID(IT)=CDATA(IT,ICOL)
 200     CONTINUE
         NINTEP=MIN(ISPLIN,NINTEP) 
         ILO=MIN( IL, IH )
         IHI=MAX( IL, IH )
C
C  OMEGAS ARE GIVEN (+VE IONS)
C
         IF(KEY(1:3) .EQ. 'OHM') THEN
             CT=SPLIN(TEMP,TGRID,CGRID,NTEMP,NINTEP)
C            CT=ALIN(TEMP,TGRID,CGRID,NTEMP,NINTEP)
            CDN = 8.63E-06 * CT * ED / ( G(IHI)*SQRT(TEMP) )
            CUP = CDN * PSTAR(IHI) / PSTAR(ILO)
            C(IHI,ILO) = CDN + C(IHI,ILO)
            C(ILO,IHI) = CUP + C(ILO,IHI)
C     
C     CPMM VALUES ARE GIVEN (M-M' COLLISIONS WITH PROTONS)
C     
         ELSE IF (KEY(1:4) .EQ. 'CPMM')THEN
            DO 201 IT=1,NTEMP
               CGRID(IT)=CDATA(IT+2,ICOL)
 201        CONTINUE
            M=INT(CDATA(1,ICOL))
            MP=INT(CDATA(2,ICOL))
            TTP=TEMP*TP2TE
            CT=SPLIN(TTP,TGRID,CGRID,NTEMP,NINTEP)
C            CT=ALIN(TTP,TGRID,CGRID,NTEMP,NINTEP)
            CDN = HD(6) * CT 
            CUP= CDN * PSTAR(IHI)/G(IHI) / (PSTAR(ILO)/G(ILO))
            CMM(IHI,ILO,M,MP) = CDN + CMM(IHI,ILO,M,MP)
            CMM(ILO,IHI,M,MP) = CUP + CMM(ILO,IHI,M,MP)
C     
C     RECIPROCAL RELATION (EQ 7A OF LANDMAN 1975 A+A 43, 285)
C     
            CMM(IHI,ILO,-M,-MP) = CDN + CMM(IHI,ILO,-M,-MP)
            CMM(ILO,IHI,-M,-MP) = CUP + CMM(ILO,IHI,-M,-MP)
         ENDIF
C     
 100  CONTINUE
C
C  NOT RE-DONE
C
      ELSE 
C         write(*,*)'No re-calculation, just scaling'
      DO 330 J=1,NK
         DO 430 I=1,NK
            C(I,J)=C(I,J)*ED/EDOLD
            DO 431 L=-MJMAX,MJMAX
               DO 432 M=-MJMAX,MJMAX
                  CMM(I,J,L,M)=CMM(I,J,L,M)*HD(6)/HDOLD(6)
 432           CONTINUE
 431        CONTINUE
 430     CONTINUE
 330  CONTINUE
      ENDIF
      TOLD=TEMP
      EDOLD=ED
      DO 304 I=1,6 
         HDOLD(I)=HD(I)
 304  CONTINUE
      RETURN
      END
      

C
C PURPOSE: CALCULATES THE B-FRAME IRRED. TENSOR COMPONENTS OF AVG RADN FIELD
C          FROM THE PHOTOSPHERE IN THE "B" FRAME (SEE FIG 5 OF 
C          CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539)
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C       CATOM CCONST CORON CSE
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE FIELDB(KR)

C  THIS SUBROUTINE CALCULATES IRREDUCIBLE TENSOR COMPONENTS
C  OF THE AVERAGE RADIATION FIELD FROM THE PHOTOSPHERE IN THE B
C  FRAME

	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CATOM'
	INCLUDE 'CCONST'
	INCLUDE 'CORON'
	INCLUDE 'CSE'

	AMU_B=COS(THETAB)

	CALL FIELD_INT(KR,RADJ_0,RADJ_1,RADJ_2)

	RADJ(0,KR)=RADJ_0
	RADJ(1,KR)=RADJ_1
	RADJ(2,KR)=0.5*(3.0*AMU_B*AMU_B-1.0)*RADJ_2

	RETURN
	END

C
C PURPOSE: BUILD STATISTICAL EQUILIBRIUM MATRIX
C
C INPUTS: NDIM (pretty sure this is an output!! SG)
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE SE0_BUILD(NDIM)

C  THIS SUBROUTINES BUILDS THE COEFFICIENT MATRIX OF THE STATISTICAL
C  EQUILIBRIUM EQUATIONS IN THE B-FRAME, ONCE THE B-DIRECTION IN THE
C  S-FRAME, AND THE HEIGHT OVER THE LIMB OF THE SCATTERER ARE GIVEN.
C  A CYLINDRICALLY SYMMETRIC, UNPOLARIZED RADIATION FIELD IS ASSUMED.
C  QUANTUM COHERENCES ARE NEGLECTED.

	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CATOM'
	INCLUDE 'CSE'
	INCLUDE 'CINTS'
C added next 6jul22
	INCLUDE 'CINPUT'
	INCLUDE 'CLU'
C       
C	DIMENSION DUM(MJTOT,MJTOT)
	LOGICAL LEQK
C       
C       CALCULATE TENSORS OF RADIATION FIELD FOR ALL POSSIBLE TRANSITIONS
C       
C	WRITE (LOUT,*) 'RADIATION TENSORS'
C       
C	CALL CPTIME('SE0_BUILD',0,0,1)
C	CALL CPTIME('SE0:FIELDB',0,0,1)
	DO IJ=1,NK
	   DO IJ1=1,NK
C       
C       ENUMERATE RADIATIVELY
C       PERMITTED TRANSITIONS
C       
	      KR=KRAD(IJ,IJ1)				
	      IF (KR.NE.0) THEN 
		 CALL FIELDB(KR)
	      END IF
	   END DO
	END DO
C	CALL CPTIME('SE0:FIELDB',0,1,1)
C       
C       BUILD COEFFICIENT MATRIX  SCOEFF(I,I1)
C       
C	CALL CPTIME('SE0:R&C',0,0,1)
	I=0
	IZ=0
	DO IJ=1,NK
	   CALL R1(IJ,R1COEFF)
	   C1TMP0=CE(IJ,IZ)
	   CALL C2(IJ,C2COEFF)
	   CALL C6(NK,IJ,C6COEFF)
C Note stepping by 2 added with 6jul22 version
	   DO K=0,NINT(TWO*AJ(IJ)),2
C       
C       ROW NUMBER
C       
	      I=I+1
	      IF (K.NE.0) THEN
		 WEIGHT(I)=ZERO
	      ELSE
		 WEIGHT(I)=SQRT(TWO*AJ(IJ)+ONE)
	      END IF			
	      C1TMPK=CE(IJ,K)
	      C1COEFF=C1TMP0-C1TMPK
	      I1=0
	      DO IJ1=1,NK
		 KR=KRAD(IJ,IJ1)
		 CALL R4(IJ,IJ1,K,R4COEFF)
		 IF (IJ1.LT.IJ) CALL C3(IJ,IJ1,K,C3COEFF)
		 IF (IJ1.GT.IJ) CALL C5(IJ,IJ1,K,C5COEFF)
C Note stepping by 2 added with 6jul22 version
		 DO K1=0,NINT(TWO*AJ(IJ1)),2
		    LEQK=K1.EQ.K
C       
C       COLUMN NUMBER
C       
		    I1=I1+1					
		    SCOEFF(I,I1)=ZERO
C       
C       R(1,2,6), C(1,2,6),
C       -> IJ1=IJ
C       
		    IF (IJ1.EQ.IJ) THEN			
		       IZ=0
		       CALL R2(IJ,K,K1,IZ,R2COEFF)
		       CALL R6(NK,IJ,K,K1,IZ,R6COEFF)
		       SCOEFF(I,I1)=-R2COEFF-R6COEFF+SCOEFF(I,I1)
		       IF (LEQK) SCOEFF(I,I1)=-R1COEFF-C1COEFF-C2COEFF-C6COEFF
     * 		    +SCOEFF(I,I1)
      
		    END IF
		    IF (IJ1.LT.IJ) THEN
		       IF (KR.NE.0) THEN
			  IZ=0
			  CALL R3(KR,IJ,IJ1,K,K1,IZ,R3COEFF)
			  SCOEFF(I,I1)=R3COEFF+SCOEFF(I,I1)
		       END IF
		       IF (LEQK) SCOEFF(I,I1)=C3COEFF+SCOEFF(I,I1)
		    END IF
		    IF (IJ1.GT.IJ) THEN
		       IF (KR.NE.0) THEN
			  IZ=0
			  CALL R5(KR,IJ,IJ1,K,K1,IZ,R5COEFF)
			  SCOEFF(I,I1)=R5COEFF+SCOEFF(I,I1)
		       END IF
		       IF (LEQK) SCOEFF(I,I1)=R4COEFF+C5COEFF+SCOEFF(I,I1)
		    END IF
		 END DO
	      END DO
	   END DO
	END DO
C debug statement added 6jul22
	if(IDEBUG .GT. 0) WRITE(LOUT,*)' SE0_BUILD MADE A  ',I,' X ',I1, 'MATRIX'
	IF (I.NE.I1) CALL STOP('SE_BUILD: SCOEFF IS NOT SQUARE')
	NDIM=I
C	CALL CPTIME('SE0:R&C',0,1,1)
C	CALL CPTIME('SE0_BUILD',0,1,1)
	RETURN
	END

C
C PURPOSE: CALCULATES 6J VALUE
C
C INPUTS:
C       RJ11,RJ12,RJ13  REAL J QUANTUM NUMBERS IN 1ST ROW OF 6J
C       RJ21,RJ22,RJ23  REAL J QUANTUM NUMBERS IN 2ND ROW OF 6J
C
C OUTPUTS:
C       FUN6J
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	FUNCTION FUN6J(RJ11,RJ12,RJ13,RJ21,RJ22,RJ23)
C   CALCULATES 6J	VALUE, EACH RJ IS REAL
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
	INCLUDE 'FACT'
C
	IJ1=NINT(RJ11+RJ11)
	IJ2=NINT(RJ12+RJ12)
	IJ3=NINT(RJ13+RJ13)
	IJ4=NINT(RJ21+RJ21)
	IJ5=NINT(RJ22+RJ22)
	IJ6=NINT(RJ23+RJ23)
	IJM1=(IJ1+IJ2+IJ3)/2
	IJM2=(IJ1+IJ5+IJ6)/2
	IJM3=(IJ4+IJ2+IJ6)/2
	IJM4=(IJ4+IJ5+IJ3)/2
	IJM=IJM1
	IF(IJM2.GT.IJM) IJM=IJM2
	IF(IJM3.GT.IJM) IJM=IJM3
	IF(IJM4.GT.IJM) IJM=IJM4
	IJX1=(IJ1+IJ2+IJ4+IJ5)/2
	IJX2=(IJ2+IJ3+IJ5+IJ6)/2
	IJX3=(IJ3+IJ1+IJ6+IJ4)/2
	IJX=IJX1
	IF(IJX2.LT.IJX) IJX=IJX2
	IF(IJX3.LT.IJX) IJX=IJX3
	FUN6J=ZERO
	IF(IJM.LE.IJX) THEN
	  TERM=ZERO
	  TERM1=FN2(IJ1,IJ2,IJ3)+FN2(IJ1,IJ5,IJ6)
     /	  +FN2(IJ4,IJ2,IJ6)+FN2(IJ4,IJ5,IJ3)
	  DO I=IJM,IJX
	    TERM2=FL(I+1)-FL(I-IJM1)-FL(I-IJM2)-FL(I-IJM3)
     /	    -FL(I-IJM4)-FL(IJX1-I)-FL(IJX2-I)-FL(IJX3-I)
	    TERM=SG(I)*EXP(TERM1+TERM2)
	    FUN6J=FUN6J+TERM
	  END DO
	END IF
	RETURN
	END

C
C PURPOSE: CALCULATES RADIATION FIELD INTENSITY IN THE DIRECTION THETA=ARCOS(X)
C
C INPUTS:
C       KR  TRANSITION INDEX
C	X   COS THETA
C       XM  COS THETAM
C           YMU IS MU= COS ZETA IN EQUATION 29 OF CASINI & JUDGE 1999
C OUTPUTS:
C       FLIMB
C COMMON:
C
C RESTRICTIONS:
C       
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	FUNCTION FLIMB(KR,X,XM)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CATOM'
	INCLUDE 'CCONST'
	INCLUDE 'CINTS'
	YMU=SQRT((X+XM)*(X-XM)/(ONE-XM*XM))
C
C  LAMBDA IS IN ANGSTROMS
C  XNU IS ANGULAR FREQUENCY OF TRANSITION
C
	WL=ALAMB(KR)
	WM=WL/1.E4
	XNU=1.E8*(TWO*PI)*(CC/WL)
C
C XT IS DISK CENTER RADIATION TEMPERATURE FOR I (ALLEN 1973, SEC 80)
C
	XT=6050.
C
C ALLEN'S (1973) LIMB DARKENING (P 170, TOP)
C
	CALL UV(WM,U,V)
	FLIMB=PLANCK(XNU,XT)*(ONE-U-V+(U+V*YMU)*YMU)
	RETURN
	END

C
C PURPOSE: FUNCTION NEEDED IN 6J CALCULATION
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	FUNCTION FN2(IJ1,IJ2,IJ3)
C   USED IN 6J CALCULATION
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'FACT'
	L1=(IJ1+IJ2-IJ3)/2
	L2=(IJ2+IJ3-IJ1)/2
	L3=(IJ3+IJ1-IJ2)/2
	L4=(IJ1+IJ2+IJ3)/2+1
	FN2=.5*(FL(L1)+FL(L2)+FL(L3)-FL(L4))

	RETURN
	END

C
C PURPOSE: GET GRID OF X Y Z 
C
C INPUTS:
C     NONE
C OUTPUTS:
C       
C COMMON:  GRID
C    
C COMMENTS: AUGUST 24, 2000, P. JUDGE
C
C 
	SUBROUTINE GRID
	INCLUDE 'PREC'
        INCLUDE 'GRDPAR'
        INCLUDE 'CGRID'
	INCLUDE 'CINPUT'
        INCLUDE 'CLU'
C
        CALL CSTRIP(LGRID,'GRID.DAT')
        READ(LDUMS,*)GXMIN,GXMAX,GYMIN,GYMAX,GZMIN,GZMAX,NGX
C     
        DELTA=(GXMAX-GXMIN)/FLOAT(NGX-1)
        NGY= INT((GYMAX-GYMIN)/DELTA) +1
        NGZ= INT((GZMAX-GZMIN)/DELTA) +1
        IF(NGX .GT. MX) THEN 
           WRITE(LJOBLO,1000) ' GRID: NGX = ',NGX,' MX = ',MX
           CALL STOP('GRID: NGX .GT. MX') 
        ENDIF
C
        IF(NGY .GT. MY) THEN 
           WRITE(LJOBLO,1000) ' GRID: NGY = ',NGY,' MY = ',MY
           CALL STOP('GRID: NGY .GT. MY') 
        ENDIF
C
        IF(NGZ .GT. MZ) THEN 
           WRITE(LJOBLO,1000) ' GRID: NGZ = ',NGZ,' MZ = ',MZ
           CALL STOP('GRID: NGZ .GT. MZ') 
        ENDIF
C
 1000   FORMAT(2(A,I4))
C
C  OUTPUT TO OUTPUT FILE
C	
	   WRITE(LOUT,2000)
 2000	   FORMAT('1 GRID (UNITS ARE SOLAR RADII)'//
     *     'DIRECTION               MIN        MAX            NPTS')
	   WRITE(LOUT,2001) GXMIN,GXMAX,NGX
	   WRITE(LOUT,2002) GYMIN,GYMAX,NGY
	   WRITE(LOUT,2003) GZMIN,GZMAX,NGZ
 2001	   FORMAT(1P,'X (LINE OF SIGHT)   : ',2(1X,E10.3),1X,I8,0P)
 2002	   FORMAT(1P,'Y (PLANE OF SKY E-W): ',2(1X,E10.3),1X,I8,0P)
 2003	   FORMAT(1P,'Z (PLANE OF SKY N-S): ',2(1X,E10.3),1X,I8,0P//)
C
C  OUTPUT TO ATMOS FILE
C	
	IF(IWATMO .NE. 0) THEN 
	   WRITE(LATMOS) GXMIN,GXMAX,NGX
	   WRITE(LATMOS) GYMIN,GYMAX,NGY
	   WRITE(LATMOS) GZMIN,GZMAX,NGZ
	ENDIF
 200	   FORMAT(A)
 203	   FORMAT(A,A)
 204	   FORMAT(1P,2(E11.4,1X),0P,I4)
      IF(NGX .LE. 1) WRITE(LJOBLO,301)
 301	FORMAT(' GRID: WARNING, NGX .LE. 1')
      IF(NGY .LE. 1) WRITE(LJOBLO,302)
 302	FORMAT(' GRID: WARNING, NGY .LE. 1')
      IF(NGZ .LE. 1) WRITE(LJOBLO,303)
 303	FORMAT(' GRID: WARNING, NGZ .LE. 1')
	RETURN
	END

C
C PURPOSE: CALCULATES 3J VALUE, EACH RJ/RM IS REAL
C
C INPUTS:
C       RJ1,RJ2,RJ3  REAL J QUANTUM NUMBERS IN 1ST ROW OF 3J
C       RM1,RM2,RM3  REAL M QUANTUM NUMBERS IN 2ND ROW OF 3J
C OUTPUTS:
C       FUN3J
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	FUNCTION FUN3J(RJ1,RJ2,RJ3,RM1,RM2,RM3)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
	INCLUDE 'FACT'
C
	IJ1=NINT(RJ1+RJ1)
	IJ2=NINT(RJ2+RJ2)
	IJ3=NINT(RJ3+RJ3)
	IM1=NINT(RM1+RM1)
	IM2=NINT(RM2+RM2)
	IM3=NINT(RM3+RM3)
	FUN3J=ZERO
	IF(IJ1+IJ2-IJ3.LT.0) GOTO 1
	IF(IJ2+IJ3-IJ1.LT.0) GOTO 1
	IF(IJ3+IJ1-IJ2.LT.0) GOTO 1
	IF(IM1+IM2+IM3.NE.0) GOTO 1
	IF(IABS(IM1).GT.IJ1) GOTO 1
	IF(IABS(IM2).GT.IJ2) GOTO 1
	IF(IABS(IM3).GT.IJ3) GOTO 1
	KMIN=(IJ3-IJ1-IM2)/2
	KMIN1=KMIN
	KMIN2=(IJ3-IJ2+IM1)/2
	IF(KMIN2.LT.KMIN) KMIN=KMIN2
	KMIN=-KMIN
	IF(KMIN.LT.0) KMIN=0
	KMAX=NINT(RJ1+RJ2-RJ3)
	KMAX1=KMAX
	KMAX2=NINT(RJ1-RM1)
	KMAX3=NINT(RJ2+RM2)
	IF(KMAX2.LT.KMAX) KMAX=KMAX2
	IF(KMAX3.LT.KMAX) KMAX=KMAX3
	IF(KMIN.LE.KMAX) THEN
	  TERM=ZERO
	  TERM1=FN1(RJ1,RJ2,RJ3,RM1,RM2,RM3)
	  SGN=SG((IJ1-IJ2-IM3)/2)
	  DO I=KMIN,KMAX
	    TERM2=FL(I)+FL(KMIN1+I)+FL(KMIN2+I)
     /	    +FL(KMAX1-I)+FL(KMAX2-I)+FL(KMAX3-I)
	    TERM=SGN*SG(I)*EXP(TERM1-TERM2)
	    FUN3J=FUN3J+TERM
	  END DO
	END IF
 1	RETURN
	END

C
C ****************************************************************
C
        FUNCTION SPLIN(T, X, Y, N, NNN)
C
C  SPLINE INTERPOLATION OF T IN A GIVEN TABLE OF POINTS(X(I),Y(I)).
C
C Y(I) IS A FUNCTION OF X(I) - X(N)>X(N-1)>....X(1) -OR- X(1)> X(2)
C > ....> X(N) - WHEN X IS NORMALISED X(MIN) = 0, XMAX=1,
C NORM(ABS(X(I+1)-X(I))) < 1.0E-8,(I=1,N-1). THE ARRAY X IS DIVIDED
C INTO OVERLAPPING INTERVALS. EACH INTERVAL CONSISTS OF NNN POINTS,
C THE OVERLAP IS INT(LOG(NNN)+3) POINTS. ( 3<=NNN<=100,N).
C EACH TIME AFTER A CALL WHEN T CHANGES OF INTERVAL OR AFTER A CALL
C WITH ANOTHER SET OF POINTS, A NEW CUBIC SPLINE OF NNN POINTS HAS
C TO BE COMPUTED, THEREFORE THE COMPUTING TIME DEPENDS STRONGLY OF
C THE SUCCESSION OF CALLS.
C FOR EXAMPLE: SUCCESSIVE CALLS, WHERE T IS RANDOMLY CHOSEN WILL COST
C A LOT OF COMPUTING TIME - (T OFTEN CHANGES OF INTERVAL) --->
C TAKE NNN THEN AS LARGE AS POSSIBLE. SUCCESSIVE CALLS WHERE T CHANGES
C SLIGHTLY COST LESS COMPUTING TIME, SO IT WILL BE CLEAR THAT YOUR
C CHOICE OF NNN DEPENDS HEAVILY UPON ITS WAY OF USEAGE.
C
C COMPUTING TIME:   FOR THE COMPUTATION OF SPLINE COEFFICIENTS
C        THIS ROUTINE NEEDS ABOUT 21*N MULTIPLICATIONS OR DIVISIONS
C        FOR THE INTERPOLATION BY MEANS OF THE SPLINE COEFFICIENTS
C        THE ROUTINE NEEDS 9 MULTIPLICATIONS OR DIVISIONS.
C
C EXTRAPOLATION: IF T IS NOT IN [X(1),X(N)] T IS LINEAR EXTRAPOLATED
C
C A PART OF THE ALGORITM FOR THE COMPUTATION OF A NATURAL SPLINE
C IS TAKEN FROM T.N.E. GREVILLE, THE LINEAR SYSTEM IS SOLVED BY
C THE METHOD OF SUCCESSIVE OVERRELAXATION. (ERROR = 1.0E-6)
C
C REF: T.N.E. GREVILLE, MATHEMATICS RESEARCH CENTER, U.S. ARMY,
C        UNIVERSITY OF WISCONSIN. MATHEMATICAL METHODS.
C
C THIS ROUTINE WAS IMPLEMENTED BY E.B.J. VAN DER ZALM, STERRENWACHT
C UTRECHT (MAY 7TH 1981). ADAPTED FOR VAX\11 BY PAUL KUIN AT OXFORD.
C WRITTEN IN REAL*4 BY P.G. JUDGE, OXFORD
C MODIFIED SO THAT IF THE ARGUMENT IS OUTSIDE THE RANGE OF X-VALUES
C THEN THE FIRST (OR LAST) Y-VALUE IS TAKEN
C
C INPUT:         T        ARGUMENT   (REAL)
C                X        ARRAY OF ARGUMENTS        (REAL)
C                Y        ARRAY OF FUNCTION VALUES (REAL)
C                N        LENGTH OF THE ARRAYS X,Y
C                        IF N = 2 ---> LINEAR INTERPOLATION
C                NNN        NUMBER OF POINTS OF THE CUBIC SPLINE
C                        IF NNN > N   ---> NNN = N
C                        IF NNN > 100 ---> NNN = 100
C                        IF NNN = 2 LINEAR INTERPOLATION ADOPTED.
C
C                        IF NNN IS ZERO NNN=7  (ALTERED BY P JUDGE)
C                       (USED TO BE IF NNN OMITTED )
C OUTPUT:        SPLIN INTERPOLATED VALUE AT T
C
      INCLUDE 'PREC'
        DIMENSION X(N), Y(N), S2(100), S3(100), DELY(100), H(100),
     * H2(100), DELSQY(100), C(100), B(100), XX(100), YY(100)
        LOGICAL SEARCH, FOUND
        CHARACTER*4 INIT
        DATA INIT/'NOTO'/
        SAVE
C
C  NN = NUMBER OF POINTS OF THE SPLINE INTERVAL
C
        NN = MIN(7,N)
        IF (NNN .EQ. 0) GO TO 10
C PGJ        IF (%LOC(NNN).EQ.0) GO TO 10
        NN = NNN
        NN = MIN(N,NNN,100)
C
C           IF T IN [X(K)-ERROR,X(K)+ERROR] T = X(K)
C
 10        ERROR = 1.0E-12
        IF (T.NE.0) ERROR = ABS(1.0E-12*T)
        FOUND = SEARCH(X,T,1,N,K,ERROR)
        IF (.NOT.FOUND) GOTO 20
        SPLIN = Y(K)
        RETURN
 20        IF (N.NE.2.AND.NN.NE.2) GOTO 30
C
C           IF N=2 OR NNN=2 LINEAR INTERPOLATION IS ADOPTED
C
        SPLIN = (Y(K+1)-Y(K))*(T-X(K))/(X(K+1)-X(K)) + Y(K)
        RETURN
 30        IF (N.NE.1) GOTO 40
        SPLIN = Y(1)
        RETURN
C
C           INTERVAL OF THE SPLINE IS COMPUTED
C
 40        IOVER = LOG10(FLOAT(NN))*3
        INT = (K-IOVER)/(NN-2*IOVER) + 1
        I1 = (INT-1)*(NN-2*IOVER)
        I2 = I1 + NN -1
        IF (I1.GE.1) GOTO 50
        I2 = NN
        I1 = 1
 50        IF (I2.LE.N) GOTO 60
        I2 = N
        I1 = N - NN + 1
 60         ISHIFT = I1 - 1
        N1 = NN - 1
C
C           INITIALIZATION CHECK
C
        IF (INIT.NE.'OKAY') GOTO 80
C
C           INTERVAL CHECK
C
        DO 70 I=1,NN
        IF (XX(I).NE.X(I+ISHIFT)) GOTO 90
        IF (YY(I).NE.Y(I+ISHIFT)) GOTO 90
 70   CONTINUE
      GOTO 200
 80   INIT = 'OKAY'
C     
C     START OF THE COMPUTATION OF SPLINE COEFFICIENTS
C     
 90   RMIN = 1.0E37
      RMAX = -1.0E37
      DO 100 I=1,NN
        IF (Y(I+ISHIFT).LT.RMIN)  RMIN = Y(I+ISHIFT)
        IF (Y(I+ISHIFT).GT.RMAX)  RMAX = Y(I+ISHIFT)
 100  CONTINUE
C
C           COMPUTATION OF THE NORM FACTORS XNORM AND YNORM
C
        XNORM = 1/(X(NN+ISHIFT)-X(1+ISHIFT))
        YNORM = RMAX - RMIN
        IF (YNORM.EQ.0) YNORM = RMAX
        IF (YNORM.EQ.0) YNORM = 1
        YNORM = 1 / YNORM
        DO 110 I=1,N1
           H(I) = (X(I+1+ISHIFT)-X(I+ISHIFT))*XNORM
           DELY(I) = ((Y(I+1+ISHIFT)-Y(I+ISHIFT))/H(I))*YNORM
 110        CONTINUE
        DO 120 I=2,N1
           H2(I) = H(I-1) + H(I)
           B(I) = 0.5*H(I-1)/H2(I)
           DELSQY(I) = (DELY(I)-DELY(I-1))/H2(I)
           S2(I) = 2.*DELSQY(I)
           C(I) = 3.*DELSQY(I)
 120        CONTINUE
        S2(1) = 0
        S2(N1+1) = 0
C
C        SOLUTION OF THE LINEAR SYSTEM OF THE SPLINE COEFFICIENTS
C        BY SUCCESSIVE OVERRELAXATION.
C        CONSTANTS: EPS = ERROR CRITERION IN THE ITERATIVE SOLUTION.
C                   OMEGA = RELAXATION COEFFICIENT.
C
        EPSLN = 1.0E-8
        OMEGA = 1.0717968
 130    ETA = 0.
        DO 160 I=2,N1
           W = (C(I)-B(I)*S2(I-1)-(0.5-B(I))*S2(I+1)-S2(I))*OMEGA
           IF ((ABS(W)-ETA) .GT. 0.) ETA = ABS(W)
           S2(I) = S2(I) + W
 160    CONTINUE
        IF ((ETA-EPSLN) .GE. 0.) GOTO 130
        DO 180 I=1,N1
           S3(I) = (S2(I+1)-S2(I))/H(I)
 180    CONTINUE
C     
C     X AND Y STORED IN XX AND YY FOR INTERVAL CHECK
C     
        DO 190 I=1,NN
           XX(I) = X(I+ISHIFT)
           YY(I) = Y(I+ISHIFT)
 190    CONTINUE
 200    I = K - I1 + 1
        HT1 = (T-X(I+ISHIFT))*XNORM
        HT2 = (T-X(I+ISHIFT+1) )*XNORM
        IF ((T-X(1))*XNORM.GT.0) GOTO 210
C     
C     EXTRAPOLATION   T < X(1)
C     
        SPLIN = Y(1)
        RETURN
 210    IF ((T-X(N))*XNORM.GT.0) GOTO 220
C     
C     INTERPOLATION BY MEANS OF THE SPLINE COEFFICIENTS
C     
        SS2 = S2(I) + HT1*S3(I)
        PROD = HT1*HT2
        DELSQS = (S2(I)+S2(I+1)+SS2)/6.
        SPLIN = Y(I+ISHIFT) + (HT1*DELY(I)+PROD*DELSQS)/YNORM
        RETURN
C
C        EXTRAPOLATION   T > X(N)
C
 220        SPLIN =  Y(N)
        RETURN
        END
C
C **********************************************************************
C
      LOGICAL FUNCTION SEARCH(ARR,X,IA,IB,K,ERR)
C
C * SEARCHES THE POINT X WITHIN AN ERROR BOUND -ERR- IN ARRAY ARR      *
C * IF THAT POINT IS NOT FOUND, IT GIVES THE                           *
C * INTERVAL IN THE ARRAY, WHERE THAT POINT FITS.                      *
C * THE INTERVAL K IF X IN [ARR(K),ARR(K+1)), INTERVAL 1 IF X IN       *
C * (-INF,ARR(2)), INTERVAL N-1 IF X IN [ARR(N-1),INF)-(ARR INCREASING)*
C * INTERVAL 1 IF X IN (INF,ARR(2)),INTERVAL N-1 IF X IN [ARR(N-1),    *
C * -INF)-(ARR DECREASING)                                             *
C * IN THE WORST CASE A SEARCH COSTS 2*LOG2(N) CYCLES.                 *
C * THIS ROUTINE IS VERY ECONOMIC, WHEN IN A SEQUENCE OF SEARCHES,     *
C * THE DIFFERENCES BETWEEN THE POINTS WHICH ARE TO BE SEARCHED ARE    *
C * SMALL.                                                             *
C * FOR EXAMPLE: A SEQUENCE OF SEARCHES WHICH GOES ALONG THE ARRAY,    *
C * OR A SEQUENCE OF SEARCHES WHICH REMAINS IN A SMALL AREA OF         *
C * THE ARRAY.                                                         *
C *                                                                    *
C * INPUT:     - ARR         ARRAY WITH A NON DECREASING OR A NON      *
C *                          INCREASING FUCNTION.                      *
C *            - IA,IB       LOWER AND UPPER LIMIT OF THE ARRAY WITHIN *
C *                          IS SEARCHED.                              *
C *            - X           VALUE WHICH YOU WANT TO SEARCH            *
C *            - K           LAST INDEX WHICH WAS FOUND                *
C *                          SEARCH                                    *
C *            - ERR         ERROR BOUND                               *
C *                                                                    *
C * OUTPUT:    - K           INDEX OF THE POINT OR INTERVAL OF THE     *
C *                          ARRAY WHICH IS FOUND.                     *
C *            - SEARCH      TRUE - X IS FOUND WITHIN THE ERRORBOUND   *
C *                                  -ERR-                             *
C *                          FALSE - X IS NOT FOUND.                   *
C *                                                                    *
C * SEND IN BY E.V.D.ZALM, UTRECHT, STERREWACHT, MARCH 24TH 1981       *
C **********************************************************************
      INCLUDE 'PREC'
      DIMENSION ARR(IB)
C
      ONE=1.0
      SEARCH = .TRUE.
      IF (ARR(IB)-ARR(IA).LT.0.0) GOTO 100
      IF (X.LT.ARR(IA).OR.X.GT.ARR(IB)) GOTO 25
      IF (K.LT.IA.OR.K.GT.IB-1) GOTO 25
      L = K
      IP = SIGN(ONE,X-ARR(K))
      IF (IP.LT.0.) GOTO 20
10    L = MIN(K+IP,IB)
      IF (ARR(L).GE.X) GOTO 30
      IP = IP * 2
      K = L            
      GOTO 10
20    K = MAX(L+IP,IA)
      IF (ARR(K).LE.X) GOTO 30
      IP = IP * 2
      L = K
      GOTO 20
25    K = IA
      L = IB
30    IF ((L-K).LE.1) GOTO 50
      I = INT((K+L)/2.)
      IF (ARR(I).GE.X) GOTO 40
      K = I
      GOTO 30
40    L = I
      GOTO 30
100   IF (X.LT.ARR(IB).OR.X.GT.ARR(IA)) GOTO 250
      IF (K.LT.IA.OR.K.GT.IB-1) GOTO 250
      L = K
      IP = SIGN(ONE,ARR(K)-X)
      IF (IP.LT.0.) GOTO 200
110   L = MIN(K+IP,IB)
      IF (ARR(L).LE.X) GOTO 300
      IP = IP * 2
      K = L
      GOTO 110
200   K = MAX(L+IP,IA)
      IF (ARR(K).GE.X) GOTO 300
      IP = IP * 2
      L = K
      GOTO 200
250   K = IA
      L = IB
300   IF ((L-K).LE.1) GOTO 50
      I = INT((K+L)/2.)
      IF (ARR(I).LE.X) GOTO 400
      K = I
      GOTO 300
400   L = I
      GOTO 300
50    IF (ABS(X-ARR(K)).LE.ERR) RETURN
      IF (ABS(X-ARR(L)).GT.ERR) GOTO 60
      K = L
      RETURN
60    SEARCH = .FALSE.
      RETURN
      END

C
C PURPOSE: SOLVES SE EQUATIONS
C
C INPUTS: NDIM, A, B
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE SOLVE(NDIM,A,B)
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CSE'
      INCLUDE 'CINPUT'
      INCLUDE 'CINTS'
      INCLUDE 'CLU'
C
      DIMENSION A(NDIM,NDIM),B(NDIM)
      LOGICAL NEW
      DATA NEW /.TRUE./
C     
C  COPY SCOEFF ARRAY TO ARRAY A
C
C      CALL CPTIME('SOLVE ',0,0,1)
      DO I=1,NDIM
         DO J=1,NDIM
            A(I,J)=SCOEFF(I,J)
         END DO
         B(I)=ZERO
      END DO
C
C  PARTICLE NUMBER DENSITY CONSERVATION
C
      DO I=1,NDIM
         A(ISUM,I)=WEIGHT(I)
      END DO
C      
      B(ISUM)=ONE
C
      CALL EQSYST(NDIM,NDIM,A,B,NEW)
C
C	WRITE (LOUT,10) 'ACCURACY OF SOLUTION:'
C10	FORMAT(/A)
C
C      DO I=1,NDIM
C         TMP=.0
C         DO J=1,NDIM
C            TMP=SCOEFF(I,J)*B(J)+TMP
C         END DO
C	  WRITE (LOUT,20) I,TMP
C 20      FORMAT(1X,I3,1X,1P,E10.3)
C      END DO
C      CALL CPTIME('SOLVE ',0,1,1)

      RETURN
      END

C
C PURPOSE: OPENS A FILE
C
C INPUTS:
C
C  IUNIT   UNIT NUMBER. THIS NUMBER IS FOUND BY THE ROUTINE AND
C          RETURNED
C  FILE    FILE NAME
C  IRECW   =0  SEQUENTIAL UNFORMATTED FILE
C          =1  SEQUENTIAL FORMATTED FILE
C       .GT.1  DIRECT ACCESS FILE. IRECW IS RECORD LENGTH IN WORDS
C  STAT    STATUS (= 'OLD', 'NEW' OR 'UNKNOWN')
C
C  NB. ON SOME MACHINES THE RECORD LENGTH MUST BE GIVEN IN BYTES
C
C  LU(K) IS .TRUE. IF UNIT NUMBER K CORRESPONDS TO AN OPEN FILE
C  UNIT NUMBERS FROM LU1 AND UPWARDS ARE USED. ON THE FIRST CALL
C  LU IS INITIALIZED TO .FALSE.
C OUTPUTS:
C
C COMMON:
C     COPCL CLU CBCNST
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE OPEN(IUNIT,FILE,IRECW,STAT0)
      INCLUDE 'PREC'
      INCLUDE 'COPCL'
      INCLUDE 'CLU'
      INCLUDE 'CBCNST'
C
      CHARACTER*(*) FILE,STAT0
      CHARACTER*10 STAT
      SAVE ICALL
      DATA ICALL/0/,LU1/20/
C
      ICALL=ICALL+1
C
C  INITIALIZE LU IF FIRST CALL
C
      IF(ICALL.EQ.1) THEN
        DO 100 I = 1,MAXLU
          LU(I) = .FALSE.
  100   CONTINUE
      END IF
C
C  FIND FIRST FREE UNIT NUMBER
C
      DO 200 I = LU1,MAXLU
        IF (.NOT.LU(I)) GO TO 300
  200 CONTINUE
      CALL STOP('OPEN: NO FREE UNIT NUMBER')
  300 CONTINUE
      LU(I)=.TRUE.
      IUNIT=I
C
C  TREATMENT OF STATUS='NEW'
C
      IF(STAT0.EQ.'NEW') THEN
        STAT=NEWSTA
      ELSE
        STAT=STAT0
      ENDIF        
C
      IF(IRECW.EQ.0) THEN
        OPEN(IUNIT,FILE=FILE,FORM='UNFORMATTED',STATUS=STAT)
C (note this next line from 6jul22 update)
      ELSE IF(IRECW.EQ.-1) THEN
         OPEN(IUNIT,FILE=FILE,FORM='UNFORMATTED',STATUS=STAT,
     *        ACCESS="STREAM")
      ELSE IF(IRECW.EQ.1) THEN
        OPEN(IUNIT,FILE=FILE,FORM='FORMATTED',STATUS=STAT)
      ELSE IF(IRECW.GT.1 .AND. STAT(1:3) .NE. 'OLD') THEN
        OPEN(IUNIT,FILE=FILE,ACCESS='DIRECT',RECL=IRC*IRECW,
     *  FORM='UNFORMATTED',STATUS=STAT)
      ELSE IF(IRECW.GT.1 .AND. STAT(1:3).EQ.'OLD') THEN
C
C  NB THE RESULT OF THE INQUIRE STATEMENT IS MACHINE DEPENDENT
C  ON VAX-COMPUTERS THE RECL IS RETURNED IN BYTES
C
        INQUIRE(FILE=FILE,RECL=IRECB)
        IF(IRECB.NE.0) IRECW=IRECB/4/IRC
        OPEN(IUNIT,FILE=FILE,ACCESS='DIRECT',RECL=IRC*IRECW,
     *   FORM='UNFORMATTED',STATUS=STAT)
      ELSE
        CALL STOP('OPEN: IRECW.LT.0')
      END IF
C
      RETURN
      END
C
C***********************************************************************
C

C
C PURPOSE: WRITES EMERGENT STOKES PROFILES TO unformatted FILE
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON: CSLINE, CATOM, CSLINE, CLU
C
C RESTRICTIONS:  
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 		COMMENTED CHANGES S GIBSON 
C		MOST RECENT DEC 2016 MINOR BUG IN CENTRAL WAVELENGTH
C 
	SUBROUTINE OUTU
C
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'GRDPAR'
	INCLUDE 'CSLINE'
	INCLUDE 'CATOM'
	INCLUDE 'CINPUT'
	INCLUDE 'CGRID'
	INCLUDE 'CCONST'
	INCLUDE 'CLU'
        common /udove/ ldove
        DIMENSION SUMS(MLINE,0:4)
	DATA ICALL/0/
	SAVE ICALL
C
	QN=QNORM*1.E5/CC
	IF(ICALL .EQ. 0) THEN 
	   KOUNT=0
C 
C changed to compare to CONVL(ALAMB) not ALAMB
C probably not a big difference, but cleaner
C October 2013 SG
C KOUNT counts the number of lines calculated
C in the wavelength range. 
C January 2014 SG
C
	   DO KR=1,NLINE
	      WW=CONVL(ALAMB(KR))
	      IF ((WW .GE. WLMIN) .AND. (WW .LE. WLMAX)) THEN 
		 KOUNT=KOUNT+1
	      ENDIF
	   ENDDO
	   WRITE(Ldove) KOUNT
	   DO KR=1,NLINE
	      WW=CONVL(ALAMB(KR))
	      IF ((WW .GE. WLMIN) .AND. (WW .LE. WLMAX)) THEN 
		 WRITE (Ldove)  KR
		 WRITE (Ldove)  WW
		 WRITE (Ldove) NQ(KR)
C		 WRITE (Ldove) (DLAMB(Q(NY,KR),KR),NY=1,NQ(KR))
		 WRITE (Ldove) (-ALAMB(KR)*Q(NY,KR)*QN,NY=1,NQ(KR))
	      ENDIF
	   END DO
           WRITE(Ldove) iwline
	   ICALL=ICALL+1
	ENDIF
C
C WW IS THE WEIGHT NEEDED TO INTEGRATE OVER WAVELENGTH
C
	DO KR=1,NLINE
C
C as above SG OCT 2013
C
	   WW=CONVL(ALAMB(KR))
	   AMAXINT=0.
           NCHANGE=0
	   IF ((WW .GE. WLMIN) .AND. (WW .LE. WLMAX)) THEN 
	      WW=ALAMB(KR)*QN/(1.0+QN)
	      DO IM=0,4
		 IF(IWLINE .GT. 0) WRITE (Ldove) 
     *              (EMERGE(KR,IM,NY),NY=1,NQ(KR))
		 SUMS(KR,IM)=0.
		 DO NY=1,NQ(KR)
		    SIGN=+1.
		    ADD=EMERGE(KR,IM,NY)
C
C integral over wavelengths of I, Q, U, V, Vmag
C V, Vmag are integrated unsigned
C   note this does not take into account velocity shift
C   assumes that V,Vmag antisymmetric about rest wavelength
C   will deal with in FORWARD
C
		    IF(IM .GE. 3 .AND. Q(NY,KR) .LT. 0.) SIGN=-1.
		    SUMS(KR,IM)=SUMS(KR,IM) + SIGN*ADD*WQ(NY,KR)*WW
C
C added central (maximum) intensity as output
C NOTE  IF MULTI VALUED GAUSSIAN BE CAREFUL (will address within FORWARD)
C will return first peak
C SG JAN 2014
C
		    IF(IM .EQ. 0 .AND. ADD .GE. AMAXINT) THEN 
                     AMAXINT=ADD
	             NCHANGE=NY
                    ENDIF
		 ENDDO
	      END DO
	      IF(IWLINE .GT. 0) WRITE (Ldove) 
     *              (WQ(NY,KR)*WW,NY=1,NQ(KR))
	      WRITE(Ldove) (SUMS(KR,IM),IM=0,4)
	      WRITE (Ldove) 
     *              AMAXINT,NCHANGE
C	      WRITE(*,*) AMAXINT,NCHANGE,EMERGE(KR,0,NQ(KR)/2)
	   ENDIF
	END DO
	RETURN
	END

C
C PURPOSE: CLOSE A FILE
C
C INPUTS:
C         IUNIT   UNIT NUMBER TO CLOSE
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE CLOSE(IUNIT)
C
C  CLOSES A FILE
C
C  IUNIT=UNIT NUMBER
C  LU(K) IS .TRUE. IF K CORRESPONDS TO AN OPEN FILE
C
      INCLUDE 'PREC'
      INCLUDE 'COPCL'
C
      CLOSE(IUNIT)
      LU(IUNIT)=.FALSE.
      IUNIT=0
C
      RETURN
      END
C
C***********************************************************************
C

C
C PURPOSE: COMPUTE COLLISION RATES C(6) FOR EQN (20) OF 
C          CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539
C          A SUM OF INELASTIC COLLISIONS IS MADE FOR LEVELS GREATER
C          THAN IJ, FOR THE CASE K=0 ONLY.  
C          THE COMPLETE COEFFICIENT NEEDED FOR EQ. (20) IS 
C          BUILT BY SUMMING OUTSIDE OF THIS ROUTINE IN ROUTINE
C          SE0_BUILD
C INPUTS:
C          NJ       NUMBER OF LEVELS IN ATOM
C          IJ       INDEX OF LEVEL.  
C       
C OUTPUTS:
C          C6COEFF  
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
	SUBROUTINE C6(NJ,IJ,C6COEFF)
C  THIS SUBROUTINE CALCULATES THE COLLISIONAL RATES C(6)
	INCLUDE 'PREC'
	C6COEFF=0.0
	IZ=0
	DO IJ1=IJ+1,NJ
	  C6COEFF=CI(IJ1,IJ,IZ)+C6COEFF
	END DO
	RETURN
	END

C
C PURPOSE:  WRITES DAMPING PARAMETERS TO OUTPUT LISTING
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE WDAMP(KR,DDP,GAMMA,GR,GV,GS)
C
C 
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CINPUT'
      INCLUDE 'CLU'
C
      IF(IWDAMP.EQ.0) RETURN
C
      IF(KR .EQ. 1) WRITE(LOUT,100) 
 100  FORMAT(/' DOPPLER WIDTH, ADAMP AND CONTRIBUTIONS TO ADAMP',
     *     ' IN PERCENT '/'  KR      LAMBDA     DNYD',3X,'J  I',
     *     3X,'DNYD',4X,
     *     'ADAMP',5X,'RAD',5X,'VW',5X,'STARK'/10X,'A',
     *     9X,'KM/S',10X,'MA')
      J=JRAD(KR)
      I=IRAD(KR)
      IF(GAMMA.GT.0.0) THEN
         GAM=GAMMA
      ELSE
         GAM=1.0
      ENDIF
      WRITE(LOUT,200) KR, CONVL(ALAMB(KR)),
     *     DNYD*QNORM,J,I,DDP,ADAMP(KR),GR/GAM,
     *     GV/GAM,GS/GAM
 200     FORMAT(1X,I3,1X,F13.2,1X,F7.3,2I3,F8.3,1P,E10.3,2P,3F8.3)
      RETURN
      END
C
C***********************************************************************
C

C
C PURPOSE: CALCULATES AND STORES FACTORIALS AND SIGNUM FOR 3NJ PROGRAMS
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C       SGNM, FACT
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE FCTSG
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
	INCLUDE 'FACT'
	FL(0)=ZERO
	SG(0)=ONE
	DO I=1,MSGN
	  I1=I-1
	  FL(I)=FL(I1)+LOG(FLOAT(I))
	  SG(I)=-SG(I1)
	  SG(-I)=SG(I)
	END DO
	RETURN
	END

C
C PURPOSE: SOLVES THE EQUATION  SYSTEM  A*X=B.
C
C INPUTS:
C     N      SIZE OF SYSTEM TO BE SOLVED (N,N)
C     NDIM   DECLARED SIZE OF A (NDIM,NDIM) AND B (NDIM)
C     A      MATRIX 
C     B      INPUT VECTOR
C     NEWMAT IF .TRUE. PERFORM LU DECOMPOSITION
C OUTPUTS:
C     A      MODIFIED (LU DECOMPOSED) MATRIX, CAN BE USED IN LATER CALLS
C     B      SOLUTION VECTOR
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE EQSYST(N,NDIM,A,B,NEWMAT)
C
C  
C  WHEN NEWMAT=TRUE, THE SYSTEM IS REARRANGED INTO U*X=L*B, WHERE U
C  IS UPPER AND L IS LOWER TRIANGULAR. THESE ARE THEN REUSED IN LATER
C  CALLS WITH NEWMAT=FALSE AND NEW RIGHT HAND SIDES B. THE SOLUTION
C  VECTOR IS RETURNED IN B. NO PIVOTING, I.E. THE MATRIX A IS ASSUMED
C  TO HAVE NONZERO DIAGONAL ELEMENTS.
C
C  CODED BY: A. NORDLUND (FEB-1979)
C
C  THIS IS A MODIFIED VERSION OF EQSYST WHICH TESTS FOR ZERO ELEMENTS
C  BELOW THE DIAGONAL AND ALSO STOPS AT THE LAST NON-ZERO ELEMENT ABOVE
C  THE DIAGONAL. CONSIDERABLE SAVINGS ARE OBTAINED FOR LOOSE MATRICES.
C
C  THIS IS A COLUMN ORIENTED VERSION (M. CARLSSON JAN-1986)
C  TEMPORARY SCALARS BL, ALL, ALM AND BK ARE USED TO SHOW THE COMPILER
C  THAT THERE IS NO VECTOR DEPENDENCY IN THE INNERMOST DO-LOOP
C
      INCLUDE 'PREC'
      PARAMETER (MDIM=2000)
      DIMENSION A(NDIM,NDIM),B(NDIM)
      INTEGER LASTN(MDIM)
      LOGICAL NEWMAT
      SAVE LASTN
C
      IF(NEWMAT) THEN
C
C     FIND THE LAST NON-ZERO ELEMENT IN EACH COLUMN
C
        IF(N.GT.MDIM) CALL STOP('EQSYST: N.GT.MDIM')
        DO 120 L=1,N
          DO 100 K=N,L+1,-1
            IF(A(K,L).NE.0.0) GOTO 110
  100     CONTINUE
          K=L
  110     LASTN(L)=K
  120   CONTINUE
C
C  COLUMN LOOP: ELIMINATE ELEMENTS BELOW THE DIAGONAL IN COLUMN L.
C
        DO 500 L=1,N-1
C
C  STORE -A(K,L)/A(L,L) IN ELEMENT A(K,L)
C  MULTIPLY RIGHT HAND SIDE WITH -A(K,L)/A(L,L)
C
          ALL=A(L,L)
          BL=B(L)
          DO 200 K=L+1,LASTN(L)
            A(K,L)=-A(K,L)/ALL
            B(K)=A(K,L)*BL+B(K)
  200     CONTINUE
C
C  ADD FRACTION -A(K,L)/A(L,L) OF ROW L TO ROW K.
C  IN EACH COLUMN GO THROUGH ALL ROWS
C
          DO 400 M=L+1,N
            IF(A(L,M).NE.0.0) THEN
              ALM=A(L,M)
              LASTN(M)=MAX(LASTN(L),LASTN(M))
              DO 300 K=L+1,LASTN(L)
                A(K,M)=A(K,L)*ALM+A(K,M)
  300         CONTINUE
            END IF
  400     CONTINUE
  500   CONTINUE
      ELSE
        DO 700 L=1,N-1
          BL=B(L)
          DO 600 K=L+1,LASTN(L)
            B(K)=A(K,L)*BL+B(K)
  600     CONTINUE
  700   CONTINUE
      END IF
C
C BACKSUBSTITUTE
C
      DO 900 K=N,1,-1
        BK=B(K)
        DO 800 L=K+1,N
          BK=-A(K,L)*B(L)+BK
  800   CONTINUE
        B(K)=BK/A(K,K)
  900 CONTINUE
C
      RETURN
      END
C
C**********************************************************************
C

C
C PURPOSE: GIVES LINE FREQUENCY QUADRATURE POINTS AND WEIGHTS.
C
C INPUTS:
C     KR  TRANSITION INDEX
C OUTPUTS:
C
C COMMON:
C     CSLINE
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE FREQL(KR)
C
C  GIVES  FREQUENCY QUADRATURE POINTS AND CORRESPONDING WEIGHTS.
C  ONE- OR TWO-SIDED CASES.  THE POINTS AND WEIGHTS ARE BASED ON
C  THE TRAPEZOIDAL RULE APPLIED TO A MAPPING FUNCTION  THAT MAPS
C  EQUIDISTANT  POINTS IN  X TO  EQUIDISTANT POINTS IN  Q  IN THE
C  CORE (Q .LT. Q0), AND EQUIDISTANT POINTS IN LOG(Q) IN THE WINGS
C  (Q .GT. Q0).
C
C  NQ     : TOTAL NUMBER OF QUADRATURE POINTS                (IN)
C  QMAX   : MAXIMUM VALUE OF FREQUENCY (DOPPLER UNITS)       (IN)
C  IND    : =1 FOR ONE-SIDED AND =2 FOR TWO-SIDED CASES      (IN)
C  Q0     : TRANSITION FROM CORE TO WING (DOPPLER UNITS)     (IN)
C  Q      : QUADRATURE POINTS                               (OUT)
C  WQ     : QUADRATURE WEIGHTS                              (OUT)
C
C  CODED BY: AKE NORDLUND (OCT-1981).
C
C  REVISED BY MATS CARLSSON (JAN-1984): NEW OPTIONS
C  QMAX=Q0   Q LINEAR IN FREQUENCY
C  QMAX OR Q0.LT.0  Q GIVEN AND ONLY WEIGHTS ARE CALCULATED
C
C:
C: FREQL  88-05-03  MODIFICATIONS: (MATS CARLSSON)
C:        ADDED OPTIONS GAVE INCORRECT WEIGHTS FOR IND=1
C:        THIS AFFECTED COOLING RATES FOR LINES WITH FREQUENCY
C:        QUADRATURE GIVEN WITH QMAX=Q0 OR QMAX.LT.0 OR Q0.LT.0
C:        THE CORRECTED WEIGHTS ARE TWICE THE OLD ONES
C:
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CSLINE'
C
      IF(QMAX(KR).EQ.Q0(KR)) THEN
        DQ=IND(KR)*QMAX(KR)/(NQ(KR)-1)
        Q(1,KR)=-QMAX(KR)*(IND(KR)-1)
        DO 50 NY=2,NQ(KR)
          Q(NY,KR)=Q(NY-1,KR)+DQ
          WQ(NY,KR)=DQ*2./IND(KR)
   50   CONTINUE
        WQ(1,KR)=0.5*DQ*2./IND(KR)
        WQ(NQ(KR),KR)=0.5*DQ*2./IND(KR)
      ELSE IF(QMAX(KR).GE.0.0 .AND. Q0(KR).GE.0.0) THEN
C
C CONSTANTS
C
        AL10=LOG(10.)
        A=10.**(Q0(KR)+.5)
        HALF=0.5
        XMAX=LOG10(A*MAX(HALF,QMAX(KR)-Q0(KR)-HALF))
C
C ONE-SIDED CASE
C
        IF (IND(KR).EQ.1) THEN
          DX=XMAX/(NQ(KR)-1)
          DO 100 J=1,NQ(KR)
            X=(J-1)*DX
            X10=10.**X
            Q(J,KR)=X+(X10-1.)/A
            WQ(J,KR)=2.*DX*(1.+X10*AL10/A)
  100     CONTINUE
          WQ(1,KR)=WQ(1,KR)*0.5
C
C TWO-SIDED CASE
C
        ELSE
          DX=2.*XMAX/(NQ(KR)-1)
          DO 110 J=1,NQ(KR)
            X=-XMAX+(J-1)*DX
            X10=10.**X
            Q(J,KR)=X+(X10-1./X10)/A
            WQ(J,KR)=DX*(1.+(X10+1./X10)*AL10/A)
  110     CONTINUE
        END IF
      ELSE
        DO 200 NY=2,NQ(KR)-1
          WQ(NY,KR)=0.5*(Q(NY+1,KR)-Q(NY-1,KR))
  200   CONTINUE
        WQ(1,KR)=0.5*(Q(2,KR)-Q(1,KR))
        WQ(NQ(KR),KR)=0.5*(Q(NQ(KR),KR)-Q(NQ(KR)-1,KR))
C
C  FOR ONE-SIDED CASE, MULTIPLY WEIGHTS BY 2.0
C
        IF(Q(1,KR).GE.0.0) THEN
          DO 300 NY=1,NQ(KR)
            WQ(NY,KR)=WQ(NY,KR)*2.0
  300     CONTINUE
        ENDIF
      ENDIF
C
      RETURN
      END
C
C***********************************************************************
C

C
C PURPOSE: CONVERTS VACUUM LAMBDA TO AIR (.GT.2000 A)
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C     NONE
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      FUNCTION CONVL(ALAMB)
C
C  CONVERTS VACUUM LAMBDA TO AIR (.GT.2000 A) OR VACUUM
C  (.LT.2000 A) LAMBDA
C  CONSTANTS FROM STARLINK PROGRAM IUEDR
C
      INCLUDE 'PREC'
      IF(ALAMB.LT.2000.) THEN
        CONVL=ALAMB
      ELSE
        CONVL=ALAMB/(1.0+2.735182E-4+131.4182/ALAMB/ALAMB+
     *   2.76249E8/ALAMB/ALAMB/ALAMB/ALAMB)
      ENDIF
C
      RETURN
      END
C
C**********************************************************************
C

      SUBROUTINE EQSYSI(N,NDIM,A,B,NEWMAT)
C
C  SOLVES THE EQUATION  SYSIEM  A*X=B.
C  WHEN NEWMAT=TRUE, THE SYSIEM IS REARRANGED INTO U*X=L*B, WHERE U
C  IS UPPER AND L IS LOWER TRIANGULAR. THESE ARE THEN REUSED IN LATER
C  CALLS WITH NEWMAT=FALSE AND NEW RIGHT HAND SIDES B. THE SOLUTION
C  VECTOR IS RETURNED IN B. NO PIVOTING, I.E. THE MATRIX A IS ASSUMED
C  TO HAVE NONZERO DIAGONAL ELEMENTS.
C
C  CODED BY: A. NORDLUND (FEB-1979)
C
C  THIS IS A MODIFIED VERSION OF EQSYSI WHICH TESTS FOR ZERO ELEMENTS
C  BELOW THE DIAGONAL AND ALSO STOPS AT THE LAST NON-ZERO ELEMENT ABOVE
C  THE DIAGONAL. CONSIDERABLE SAVINGS ARE OBTAINED FOR LOOSE MATRICES.
C
C  THIS IS A COLUMN ORIENTED VERSION (M. CARLSSON JAN-1986)
C  TEMPORARY SCALARS BL, ALL, ALM AND BK ARE USED TO SHOW THE COMPILER
C  THAT THERE IS NO VECTOR DEPENDENCY IN THE INNERMOST DO-LOOP
C 
C  EQSYST WITH 1 IMPROVEMENT
C
      INCLUDE 'PREC'
      PARAMETER (MDIM=2000)
      DIMENSION A(NDIM,NDIM),B(NDIM), AA(MDIM,MDIM),BB(MDIM)
     *,RESID(MDIM)
      INTEGER LASTN(MDIM)
      LOGICAL NEWMAT
      SAVE LASTN
C
      write(*,*) 'eqsysi'
      DO I=1,NDIM
         DO J=1,NDIM
            AA(I,J)=A(I,J)
         ENDDO
         BB(I)=B(I)
      ENDDO


      IF(NEWMAT) THEN
C
C     FIND THE LAST NON-ZERO ELEMENT IN EACH COLUMN
C
        IF(N.GT.MDIM) CALL STOP('EQSYSI: N.GT.MDIM')
        DO 120 L=1,N
          DO 100 K=N,L+1,-1
            IF(A(K,L).NE.0.0) GOTO 110
  100     CONTINUE
          K=L
  110     LASTN(L)=K
  120   CONTINUE
C
C  COLUMN LOOP: ELIMINATE ELEMENTS BELOW THE DIAGONAL IN COLUMN L.
C
        DO 500 L=1,N-1
C
C  STORE -A(K,L)/A(L,L) IN ELEMENT A(K,L)
C  MULTIPLY RIGHT HAND SIDE WITH -A(K,L)/A(L,L)
C
          ALL=A(L,L)
          BL=B(L)
          DO 200 K=L+1,LASTN(L)
            A(K,L)=-A(K,L)/ALL
            B(K)=A(K,L)*BL + B(K)
  200     CONTINUE
C
C  ADD FRACTION -A(K,L)/A(L,L) OF ROW L TO ROW K.
C  IN EACH COLUMN GO THROUGH ALL ROWS
C
          DO 400 M=L+1,N
            IF(A(L,M).NE.0.0) THEN
              ALM=A(L,M)
              LASTN(M)=MAX(LASTN(L),LASTN(M))
              DO 300 K=L+1,LASTN(L)
                A(K,M)=A(K,L)*ALM + A(K,M)
  300         CONTINUE
            END IF
  400     CONTINUE
  500   CONTINUE
      ELSE
        DO 700 L=1,N-1
          BL=B(L)
          DO 600 K=L+1,LASTN(L)
            B(K)=A(K,L)*BL + B(K)
  600     CONTINUE
  700   CONTINUE
      END IF
C
C BACKSUBSTITUTE
C
      DO 900 K=N,1,-1
        BK=B(K)
        DO 800 L=K+1,N
          BK=-A(K,L)*B(L)+BK
  800   CONTINUE
        B(K)=BK/A(K,K)
  900 CONTINUE
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C IMPROVE
C  

      DO NIMP=1,3
         write(*,*) 'NIMP = ',NIMP
         DO J=1,NDIM
            TMP=0.0
            DO K=1,NDIM
               TMP=AA(J,K)*B(K) +TMP
            ENDDO
            RESID(J)=TMP-BB(J)
         ENDDO
C     
C     BACKSUBSTITUTE
C     
         DO 901 K=N,1,-1
            BK=RESID(K)
            DO 801 L=K+1,N
               BK=-AA(K,L)*RESID(L)+BK
 801        CONTINUE
            RESID(K)=BK/A(K,K)
            write(*,*) K,B(K),RESID(K)
            B(K)=B(K)-RESID(K)
 901     CONTINUE
      enddo
      RETURN
      END
C     
C**********************************************************************
C

C
C PURPOSE: CAUSES A STOP WITH A TEXT WRITTEN TO UNIT LJOBLO
C     CLOSES ALL OPEN FILES
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE STOP(TEXT)
C
C  
      INCLUDE 'PREC'
      INCLUDE 'CLU'
      INCLUDE 'COPCL'
C
      CHARACTER*(*) TEXT
C
      WRITE(LJOBLO,100) TEXT
  100 FORMAT(1X,A)
      DO 200 I=1,MAXLU
        IF(LU(I)) CLOSE(I)
  200 CONTINUE
C
      STOP
      END
C
C***********************************************************************
C

        SUBROUTINE PN1(MM,N,X,PM,PD)
C
C       =====================================================
C       Purpose: Compute the associated Legendre functions 
C                Pmn(x) and their derivatives Pmn'(x)
C       Input :  x  --- Argument of Pmn(x)
C                m  --- Order of Pmn(x),  m = 0,1,2,...,n
C                n  --- Degree of Pmn(x), n = 0,1,2,...,N
C                mm --- Physical dimension of PM and PD
C       Output:  PM(m,n) --- Pmn(x)
C                PD(m,n) --- Pmn'(x)
C       =====================================================
C
        INCLUDE 'PREC'
        INCLUDE 'CINTS'
        DIMENSION PM(0:MM),PD(,0:MM)
        DO 10 I=0,N
           PM(I)=ZERO
10         PD(I)=ZERO
        PM(0)=ONE
        IF (ABS(X).EQ.ONE) THEN
           DO 20 J=1,N
                 PD(1,J)=1.0E+36
20         CONTINUE
           RETURN
        ENDIF
        LS=1
        IF (ABS(X).GT.ONE) LS=-1
        XQ=SQRT(LS*(ONE-X*X))
        XS=LS*(ONE-X*X)
        DO 30 I=1,M
30         PM(I,I)=-LS*(TWO*I-ONE)*XQ*PM(I-1,I-1)
        DO 35 I=0,M
35         PM(I,I+1)=(TWO*I+ONE)*X*PM(I,I)
        DO 40 I=0,M
        DO 40 J=I+2,N
           PM(I,J)=((TWO*J-ONE)*X*PM(I,J-1)-
     &             (I+J-ONE)*PM(I,J-2))/(J-I)
40      CONTINUE
        PD(0,0)=ZERO
        DO 45 J=1,N
45         PD(0,J)=LS*J*(PM(0,J-1)-X*PM(0,J))/XS
        DO 50 I=1,M
        DO 50 J=I,N
           PD(I,J)=LS*I*X*PM(I,J)/XS+(J+I)
     &             *(J-I+ONE)/XQ*PM(I-1,J)
50      CONTINUE
        RETURN
        END

C
C PURPOSE: MAIN PROGRAM TO COMPUTE EMISSION COEFFS OF M1 CORONAL LINES
C          INTEGRATED ALONG THE LOS, FOR A SET OF LOS'S IN AN 
C          ASSIGNED GRID OF CARTESIAN COORDINATES.
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: AUGUST 9, 2000 P. JUDGE
C 
      PROGRAM FORCOMP
C
C  MAIN PROGRAM
C
C  CALCULATES THE EMISSION COEFFICIENTS OF FORBIDDEN CORONAL
C  LINES, INTEGRATED ALONG THE LOS, FOR A SET OF LOS'S IN AN 
C  ASSIGNED GRID OF CARTESIAN COORDINATES.
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CGRID'
      INCLUDE 'CCONST'
      INCLUDE 'CBCNST'
      INCLUDE 'CDOVE'
      common /udove/ ldove
      real*8 tempry(9)
      integer nlos, nunwrap
      integer nverbose
c
C      CALL CPTIME('TOTAL ',0,0,5)
C
      CALL STARTD
c read the grid from for_intensint.pro IDL output.
      irecd=0
      call open(idove,'modelcube4comp.dat',irecd,'OLD')
      irecw=0
      call open(ldove,'F77OUTPUT',irecw,'NEW')
      read(idove) nlos,nunwrap,nverbose
      write(ldove) nlos
      write(ldove) nunwrap
      if (nverbose .eq. 1) write(*,*)
     *   'forcomp: reading data cube: nlos nunwrap= ',nlos,nunwrap
C      print*,'munwrap = ',munwrap
      if(nlos .gt. mtau) call stop('nlos .gt. mtau')
      if(nunwrap .gt. munwrap) call stop('nunwrap .gt. munwrap')
      ngx=nlos
C
C  j-LOOP OVER THE DIFFERENT LINES OF SIGHT
C
      do j=1,nunwrap
         if (nverbose .eq. 1) then
          if(mod(j-1,100) .eq. 0) WRITE(*,*)'DOING LOS INDEX=',J,'/',NUNWRAP,'...'
	 endif
         do i=1,nlos
            read(idove), tempry
            r3d(i)=real(tempry(1))
            theta3d(i) =real(tempry(2))
            phi3d(i) =real(tempry(3)) 
            dens3d(i) =real(tempry(4))
            temp3d(i) =real(tempry(5))
            br3d(i) =real(tempry(6))
            bth3d(i) =real(tempry(7))
            bph3d(i) =real(tempry(8))
            vel3d(i) =real(tempry(9))
C            if (nverbose .eq. 1) write(*,*)'r= ',r3d
         end do
 3654    format(1x,9(f8.5,1x))
         CALL M1SYNTHD
         CALL OUTU
      END DO
C      CALL CPTIME('TOTAL ',0,1,5)
      call close(idove)
      call close(ldove)
      CALL STOP('NORMAL END')
      END
      

C
C PURPOSE: GIVES THE CPU TIME FROM ONE CALL TO ANOTHER
C
C INPUTS:
C     TEXT     STRING TO BE PRINTED OUT   
C     ISTART   IF 0 ZERO THE CLOCK ON EXIT
C     IPRI     PRINT TEXT AND IPRI BLANK LINES BETWEEN THE TEXT
C     LEVEL    (BETWEEN 1 AND 5) IS AN INDEX KEEPING TRACK OF THE
C              TIME- UP TO 5 TIMES CAN BE STORED SIMULTANEOUSLY
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE CPTIME(TEXT,ISTART,IPRI,LEVEL)
C
C  GIVES THE CPU TIME FROM ONE CALL TO ANOTHER
C  IT CAN BE ACTIVATED ON UP TO 5 DIFFERENT LEVELS.
C  THE MEANINGS OF ISTART AND IPRI:
C  ISTART =  0   ZERO CLOCK ON EXIT
C  IPRI .GT. 1   WRITE TIME, IPRI-1 BLANK LINES BEFORE AND
C                AFTER PRINTOUT
C
      INCLUDE 'PREC'
      INCLUDE 'CLU'
C
      CHARACTER TEXT*6,FMT*31
      DIMENSION B(5)
      SAVE B
      DATA B/0.,0.,0.,0.,0./
C
      A=SECOND()
      CPT=A-B(LEVEL)
      IF(ISTART.EQ.0) B(LEVEL)=A
      IF(IPRI.GT.0) THEN
        DO 50 I=1,IPRI-1
          WRITE(LTIME,40)
   40     FORMAT(1X)
   50   CONTINUE
        WRITE(FMT,100) 6-LEVEL,LEVEL+2
  100   FORMAT('(',I2,'X,A6,',I2,'X,''CPU='',F10.5,'' S'')')
        WRITE(LTIME,FMT) TEXT,CPT
        DO 150 I=1,IPRI-1
          WRITE(LTIME,40)
  150   CONTINUE
      ENDIF
      RETURN
      END

C
C PURPOSE: COMPUTES THE N'TH EXPONENTIAL INTEGRAL OF X
C
C INPUTS:
C     X  INDEPENDENT VARIABLE (-100. .LE. X .LE. +100.)
C     N  ORDER OF DESIRED EXPONENTIAL INTEGRAL (1 .LE. N .LE. 8)
C
C OUTPUTS:
C     EXPINT,  THE DESIRED RESULT
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      FUNCTION EXPINT(N,X,EX)
C
C  OUTPUT - EXPINT,  THE DESIRED RESULT
C           EX,  EXPF(-X)
C  NOTE   RETURNS WITH E1(0)=0, (NOT INFINITY).
C  BASED ON THE SHARE ROUTINE NUEXPI, WRITTEN BY J. W. COOLEY,
C  COURANT INSTITUTE OF MATHEMATICAL SCIENCES, NEW YORK UNIVERSITY
C  OBTAINED FROM RUDOLF LOESER
C-----GENERAL COMPILATION OF 1 AUGUST 1967.
C
C  MODIFIED FOR STANDARD F77 BY P. JUDGE 19 MAR 2001 (OBSOLETE FEATURES REMOVED)
C
      INCLUDE 'PREC'
      DIMENSION TAB(20),XINT(7)
      DATA XINT/1.,2.,3.,4.,5.,6.,7./
      DATA TAB /.2707662555,.2131473101,.1746297218,.1477309984,
     1.1280843565,.1131470205,.1014028126,.0919145454,.0840790292,
     1.0774922515,.0718735405,.0670215610,.0627878642,.0590604044,
     1.0557529077,.0527977953,.0501413386,.0477402600,.0455592945,
     1.0435694088/
      DATA XSAVE /0./
C
      U=X
      IF(U .EQ. 0.)THEN 
         EX=1.
         IF((N-1) .LE. 0) THEN 
            EXPINT=0.
         ELSE 
            EXPINT=1./XINT(N-1)
         ENDIF
         RETURN
      ENDIF
      IF((U-XSAVE) .NE. 0.) THEN 
         XSAVE=U
         XM=-U
         EMX=EXP(XM)
C     
C  SELECT METHOD FOR COMPUTING EI(XM)
C
         IF((XM-24.5) .GE. 0.) GOTO 400
 501     IF((XM-5.) .GE. 0.) GOTO 300
 502     IF((XM+1.) .LT. 0.) THEN 
            GOTO 100
         ELSE 
            GOTO 200
         ENDIF
      ENDIF
 503  EISAVE=-ARG
      EXSAVE=EMX
C
C  NOW RECURSE TO HIGHER ORDERS
C
      IF(N .GT. 1) THEN 
 505     DO 506 I=2,N
            EISAVE=(U*EISAVE-EXSAVE)/(-XINT(I-1))
 506     CONTINUE
      ENDIF
 507  EXPINT=EISAVE
      EX=EXSAVE
      RETURN
C     
C     EI(XM) FOR XM .LT. -1.0
C     HASTINGS POLYNOMIAL APPROXIMATION
C     
  100 ARG=((((((U+8.573328740 )*U+18.05901697  )*U+8.634760893 )*U
     *+.2677737343)/XM)*EMX)/((((U+9.573322345 )*U+25.63295615  )*U
     *+21.09965308  )*U+3.958496923 )
      GOTO 503
C     EI(XM) FOR -1. .LE. XM .LT. 5.0
C     POWER SERIES EXPANSION ABOUT ZERO
  200 ARG=LOG(ABS(XM))
      ARG=((((((((((((((((.41159050E-14*XM+.71745406E-13)*XM+.76404637E-
     *12)*XM+.11395905E-10)*XM+.17540077E-9)*XM+.23002666E-8)*XM+.275360
     *18E-7)*XM+.30588626E-6)*XM+.31003842E-5)*XM+.28346991E-4)*XM+.2314
     *8057E-3)*XM+.0016666574)*XM+.010416668)*XM+.055555572)*XM+.25)*XM+
     *.99999999)*XM+.57721566)+ARG
      GOTO 503
C     
C     EI(XM) FOR 5.0 .LE. XM .LT. 24.5
C     TABLE LOOK-UP AND INTERPOLATION
C     
 300  I=XM+.5
      XZERO=I
      DELTA=XZERO-XM
      ARG=TAB(I-4)
      IF(DELTA .NE. 0.) THEN
         Y=ARG
         DELTAX=DELTA/XZERO
         POWER=1./DELTAX
         DO 304 I=1,7
            POWER=POWER*DELTAX
            Y=((Y-POWER/XZERO)*DELTA)/XINT(I)
            ARG=ARG+Y
            IF((ABS(Y/ARG)-1.E-8) .LT. 0) GOTO 305
 304     CONTINUE
      ENDIF
 305  ARG=EMX*ARG
      GOTO 503
C     EI(XM) FOR 24.5 .LE. XM
C     TRUNCATED CONTINUED FRACTION
 400  ARG=((((XM-15.)*XM+58.)*XM-50.)*EMX)/((((XM-16.)*XM+72.)*XM-96.)
     *     *XM+24.)
      GOTO 503
      END
C
C***************************************************************
C

C
C PURPOSE: COMPUTE SUPERELASTIC MULTIPOLAR COLLISIONAL RATE
C
C INPUTS:
C       IL    LOWER LEVEL INDEX
C       I     UPPER LEVEL INDEX
C       K     MULTIPOLAR INDEX
C OUTPUTS:
C       GAMMAS
C COMMON:
C       CATOM CLU
C RESTRICTIONS:  THE TOTAL COLLISIONAL RATES C(I,J) ARE ASSUMED
C       TO BE THE RESULT OF 1 MULTIPOLE COMPONENT.  THIS MAY NOT BE 
C       CONSISTENT WITH THE INPUT DATA. SEE THE README FILE WITH THIS PROGRAM. 
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C EDITED: JUNE 6 2019 P. JUDGE
C   INTEGER DO-LOOP VARIABLES
C   FIXED ERRONEOUS DENOMINATOR IN GAMMAS
C   SEE COMMENTS IN GAMMAI.F
C ---Sept 2022 replaced pre 6jul22 version
C	
	FUNCTION GAMMAS(IL,I,K)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'CLU'
	INCLUDE 'CATMOS'
	INCLUDE 'CATOM'
	INCLUDE 'CINPUT'
	INCLUDE 'CINTS'
	GAMMAS=ZERO
	IF(ICOLL .EQ. 0 .OR. I.LE.IL) RETURN
C
	IF(ITTYPE(I,IL) .EQ. 1 .AND. K .EQ. 1) GAMMAS=C(IL,I)
	IF(ITTYPE(I,IL) .EQ. 2 .AND. K .EQ. 2) GAMMAS=C(IL,I)
C
	FJL=AJ(IL) 
	FJ=AJ(I)
	FK=FLOAT(K)
C
C       DIVIDE BY FINAL STATE 2J+1
C	TO CONSERVE PROBABILITY
C
	CASSUME=ZERO
	IF((ITTYPE(I,IL) .LT. 0 .OR. ITTYPE(I,IL) .GE. 3)
     *     .AND. ICOLL .NE. 2) 
     *    CASSUME=C(IL,I)/G(IL)
C
C SKIP FURTHER CALCULATIONS IF NO MORE COLLISIONS ARE TO BE ADDED
C	
	IF(CASSUME .EQ. ZERO .AND. ICOLLMM .EQ. 0) RETURN
C
C  CMM FORMALISM, EQUATION AT MIDDLE OF P 802 OF LANDI AND LANDOLFI
C  
	NLO=INT(G(IL)-ONE)
	NUP=INT(G(I)-ONE)
	DO NL=-NLO,NLO,2
	   AL=FLOAT(NL)/2.
	   DO NU=-NUP,NUP,2
	      AU=FLOAT(NU)/2.
	      DO M=0,K
		 P=FLOAT(M)
		 F3=FUN3J(FJL,FJ,FK,-AL,AU,P)
c 		 write(*,*) 'gammas ',K, M,F3 
		 GAMMAS=GAMMAS + (CMM(IL,I,NL/2,NU/2)+CASSUME)*F3*F3*
     *                    (TWO*FK+ONE)/G(I)
	      ENDDO
	   ENDDO
	ENDDO
	IF(IDEBUG .NE. 0 .AND. GAMMAS .NE. 0.) THEN 
	   WRITE(LOUT,*)'ITTYPE  CASSUME ',ITTYPE(I,IL),CASSUME
           WRITE(LOUT,*)
     *     'GAMMAS IL,I, K, F3, C(IL,I) ',GAMMAS, IL, I, K, F3, C(IL,I)
	ENDIF
	RETURN
	END

C
C PURPOSE: REWINDS FORTRAN UNIT LU
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE REWIND(LU)
      INCLUDE 'PREC'
      REWIND LU
C
      RETURN
      END
C
C***********************************************************************
C

C
C PURPOSE: CALCULATES THE FREQUENCY QUADRATURE
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C     CATOM CSLINE CCONST
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE FREQ
C
C  CALCULATES THE FREQUENCY QUADRATURE
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CSLINE'
      INCLUDE 'CCONST'
C
C  FREQUENCY QUADRATURE IN LINES
C
      DO 200 KR=1,NLINE
        CALL FREQL(KR)
        IF(IWIDE(KR)) THEN
          KT=KTRANS(KR)
          FRQ(0,KT)=CC/ALAMB(KR)*1.E8
          DO 100 NY=1,NQ(KR)
            FRQ(NY,KT)=FRQ(0,KT)*(1.0+Q(NY,KR)*QNORM/CC*1.E5)
  100     CONTINUE
        ENDIF
  200 CONTINUE
C
C  FREQUENCY QUADRATURE IN CONTINUA
C
      DO 300 KR=NLINE+1,NRAD
        CALL FREQC(KR)
  300 CONTINUE
C
      RETURN
      END
C
C************************************************************************
C

C
C PURPOSE: ROTATES VECTOR COMPONENTS
C
C INPUTS:
C       U   VECTOR COMPONENT
C       V   ORTHOGONAL VECTOR COMPONENT
C       TH  ANGLE TO BE ROTATED
C OUTPUTS:
C       U
C       V
C COMMON: NONE
C
C COMMENTS: AUGUST 24, 2000, P. JUDGE
C
C NOTES:    
C 
      SUBROUTINE ROT(U,V,TH)
      INCLUDE 'PREC'
      C=COS(TH)
      S=SIN(TH)
      U1=U*C-V*S
      V1=U*S+V*C
      U=U1
      V=V1
      RETURN
      END

C
C PURPOSE: CALCULATES A SIMPLE DIPOLAR FIELD
C
C INPUTS:
C       RAD    RADIUS OF POINT RELATIVE TO SUN CENTER, UNITS OF SOLAR RADII
C       THET   AZIMUTHAL ANGLE, UNITS RADIANS, IN S FRAME
C       PH     POLAR ANGLE, UNITS RADIANS, IN S FRAME
C       IPRINT SET TO 1 FOR MORE VERBOSE OUTPUT
C OUTPUTS:
C       B      MAGNITUDE OF FIELD
C       T      POLAR ANGLE
C       P      AZIMUTHAL ANGLE
C       EDENS  ELECTRON DENSITY /CM3
C       HDENS  HYDROGEN NUCLEI DENSITY /CM3 
C       TEMP   ELECTRON TEMPERATURE K
C       VEL    FLOW VELOCITY ALONG LINE OF SIGHT (+VE MEANS TOWARDS OBSERVER)
C       TURBV  MICROTURBULENCE KM/S (CONTRIBUTES TO LINE PROFILE WIDTHS)
C COMMON:
C
C COMMENTS: AUGUST 24, 2000, P. JUDGE
C
C NOTES:    USER-SUPPLIED ROUTINE
C 
	SUBROUTINE DIPOLE(RAD,THET,PH,B,T,P,EDENS,HDENS,
     *    TEMP,VEL,TURBV,IPRINT)
	INCLUDE 'PREC'
	PARAMETER(MAXD=10)
        INCLUDE 'CCONST'
	INCLUDE 'CGRID'
	INCLUDE 'CINPUT'
	INCLUDE 'CLU'
	COMMON /CDIP/ XD,YD,ZD,XM,YM,ZM,DM,DELTA,BASE,NTUBE
        COMMON /ADIP/ AALP(MAXD),DALP(MAXD),AP(MAXD),DP(MAXD)
	COMMON /WATM/BX,BY,BZ
	DATA ICALL, ZER, SMALL /0,0.,1.E-20/
	SAVE ICALL
C
	IF (ICALL .EQ. 0) THEN 
	   CALL CSTRIP(LDIP,'DIPOLE.DAT')
	   READ(LDUMS,*) RD,THD,PHID
	   THD=THD*PI/180.
	   PHID=PHID*PI/180.
	   XD=RD*SIN(THD)*COS(PHID)
	   YD=RD*SIN(THD)*SIN(PHID)
	   ZD=RD*COS(THD)
	   READ(LDUMS,*) XM,YM,ZM
	   READ(LDUMS,*) DM
	   READ(LDUMS,*) DELTA
	   READ(LDUMS,*) BASE
	   READ(LDUMS,*) NTUBE
	   IF(NTUBE .GT. MAXD) CALL STOP('NTUBE .GT. MAXD') 
	   DO I=1,NTUBE
	      READ(LDUMS,*) DAA,DBB,DCC,DDD
	      AALP(I)=DAA
	      DALP(I)=DBB
	      AP(I)=DCC
	      DP(I)=DDD
	   END DO
	   CALL CLOSE(LDUMS)
	   ICALL=ICALL+1
	ENDIF
C
C   NORMALIZE TO MODULO 1
C
	TOT=SQRT(XM*XM+YM*YM+ZM*ZM)
	XM=XM/TOT
	YM=YM/TOT
	ZM=ZM/TOT
C
C  CALCULATE CARTESIAN COORDINATES OF THE POINT RAD,THET,PH
C
	X=RAD*SIN(THET)*COS(PH)
	Y=RAD*SIN(THET)*SIN(PH)
	Z=RAD*COS(THET)
        RR=SQRT(X*X+Y*Y+Z*Z)
C
C  CALCULATE THE SCALAR MAGNETIC POTENTIAL
C  DM IS DIPOLE MOMENT
C
	RX=X-XD
	RY=Y-YD
	RZ=Z-ZD
C	V=DIPOT(DM,XM,YM,ZM,RX,RY,RZ)
C
C  CALCULATE MAGNETIC FIELD AT RAD, THET, PH
C  NUMERICAL DERIVATIVES ARE USED (CENTERED)
C
	DX=DELTA
	VP1=DIPOT(DM,XM,YM,ZM,RX + DX,RY,RZ) 
	VM1=DIPOT(DM,XM,YM,ZM,RX - DX,RY,RZ) 
	BX= 0.5*(VP1-VM1)/DX
C
	DY=DELTA
	VP1=DIPOT(DM,XM,YM,ZM,RX,RY+DY,RZ) 
	VM1=DIPOT(DM,XM,YM,ZM,RX,RY-DY,RZ) 
	BY= 0.5*(VP1-VM1)/DY
C
	DZ=DELTA
	VP1=DIPOT(DM,XM,YM,ZM,RX,RY,RZ+DZ) 
	VM1=DIPOT(DM,XM,YM,ZM,RX,RY,RZ-DZ) 
	BZ= 0.5*(VP1-VM1)/DZ
C
	B=SQRT(BX*BX+BY*BY+BZ*BZ)
	T=ACOS(BZ/B)
	P=ATAN2(BY,BX)
C
C  ELECTRON DENSITY AND TEMPERATURE.
C  FILL UP A "CONSTANT ALPHA" FLUX TUBE WITH PLASMA
C  THE FLUX TUBE IS FLAGGED IN TWO WAYS:
C   1.  A VALUE OF ALPHA IS CHOSEN (THIS SPECIFIES THE 
C       "ONION SKIN" IN THE CYLINDRICALLY SYMMETRIC FIELD, AND 
C   2.  A VALUE FOR THE AZIMUTHAL ANGLE IS CHOSEN. THE DENSITY IS THEN
C       LOADED ON TO THE FLUX TUBE WITH A GAUSSIAN DISTRIBUTION CENTERED
C       ON THESE VALUES.
C
C  PP IS THE AZIMUTHAL COORDINATE IN THE REF FRAME OF THE DIPOLE
C  MUST FIRST CALCULATE COORDINATES OF THE POINT IN THE DIPOLAR REST FRAME
C
	BET=ATAN2(YM,ZM)
	ALP=-ATAN2(XM,SQRT(ZM*ZM+YM*YM))	
	RRX=COS(ALP)*RX + SIN(ALP)*SIN(BET)*RY + SIN(ALP)*COS(BET)*RZ
	RRY=COS(BET)*RY-SIN(BET)*RZ
	RRZ=-SIN(ALP)*RX + COS(ALP)*SIN(BET)*RY +COS(ALP)*COS(BET)*RZ
	PP=ATAN2(RRY,RRX)
C
C ZZ IS THE "Z COORDINATE" IN THE REF FRAME OF THE DIPOLE. 
C
	ZZ=RRZ
	R2=RRX*RRX + RRY*RRY + RRZ*RRZ
	ALPHA = DM/SQRT(R2)*(1.-ZZ*ZZ/R2)
C
C GAUSSIANS
C
	DO I=1,NTUBE
	   DA0=(ALPHA-AALP(I))/DALP(I)
	   DP0=(PP-AP(I))/DP(I)
	   EXPON=-DA0*DA0-DP0*DP0
	   IF(I .EQ. 1) THEN 
	      EDENS=MAX(BASE*EXP(EXPON),SMALL)
	   ELSE
	      EDENS=MAX(EDENS,BASE*EXP(EXPON))
	   ENDIF
	END DO
C
C HARD EDGES
C
C        EDENS=1.
C        IF(ABS(DA0) .LT. 1. .AND. ABS(DP0) .LT. 1.) EDENS=BASE
	TEMP=2.E6
	VEL=0.
	TURBV=20.
	GRAV=2.7398E4
	TEMP1=2.E6
	RHO=(1.3625*0.8*UU)
	PTOT=BK*TEMP1*1.88 + 0.5* RHO*(TURBV*TURBV)*1.E10
	HSCALE = PTOT/RHO /GRAV
	HSCALE=HSCALE/6.9599E10
	FFAC= MAX((RR-1.),ZER)
	FFAC=EXP(-FFAC/HSCALE)
C	EDENS=EDENS*FFAC
	HDENS=0.8*EDENS
C	IF(IWATMO .NE. 0 .AND. IPRINT .NE. 0) THEN 
C	   WRITE(*,*)' '
C	   WRITE(*,200)'DIPOLE: RAD THET PH ', RAD, THET, PH
C	   WRITE(*,200)'DIPOLE:  X  Y  Z      ',  X,  Y,  Z
C	   WRITE(*,200)'DIPOLE: RX RY RZ      ', RX, RY, RZ
C	   WRITE(*,200)'DIPOLE: XM YM ZM      ', XM, YM, ZM
C	   WRITE(*,200)'DIPOLE: RRX RRY RRZ   ', RRX, RRY, RRZ
C	   WRITE(*,200)'DIPOLE: VM1 VP1 V     ',VM1,VP1, V
C	   WRITE(*,200)'DIPOLE: BX BY BZ      ', BX, BY, BZ
C	   WRITE(*,200)'DIPOLE: B T P         ', B, T, P
C	   WRITE(*,201)'DIPOLE: EDENS,ALPHA,PP,DA,DP,(RR-1)/H  ', 
C     *       LOG10(EDENS),ALPHA,PP,DA0,DP0,(RR-1.)/HSCALE
C	   WRITE(*,200)'DIPOLE: ALP,BET,PP    ', ALP,BET,PP
C	ENDIF
C 200	FORMAT(A,3(2X,F8.3,1X))
C 201	FORMAT(A,6(1X,F7.2))
	RETURN
	END
C
C**********************************************************************
C
	FUNCTION DIPOT(DM,XM,YM,ZM,RX,RY,RZ)
	INCLUDE 'PREC'
C
	R=SQRT(RX*RX + RY*RY + RZ*RZ)
	DIPOT = DM*(XM*RX+YM*RY+ZM*RZ)/R/R/R
	RETURN
	END

C
C PURPOSE: COMPUTE COLLISION RATES C(2) EQN (20) OF 
C          CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539
C          A SUM OF SUPERELASTIC COLLISIONS IS MADE FOR LEVELS LOWER
C          THAN IJ, FOR THE CASE K=0 ONLY.  
C INPUTS:
C          IJ       INDEX OF LEVEL.  
C       
C OUTPUTS:
C          C2COEFF  
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE C2(IJ,C2COEFF)
C  THIS SUBROUTINE CALCULATES THE COLLISIONAL RATES C(2)
	INCLUDE 'PREC'
	C2COEFF=0.0
	IZ=0
	DO IJ1=1,IJ-1
	  C2COEFF=CS(IJ1,IJ,IZ)+C2COEFF
	END DO
	RETURN
	END

C
C PURPOSE: RETURNS CLOCK TIME FROM CPU IN SECONDS
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      FUNCTION SECOND()
      INCLUDE 'PREC'
      REAL XXX(2),ETIME
      DUMMY=ETIME(XXX)
      SECOND=XXX(1)
      RETURN
      END

C
C PURPOSE: COMPUTE RADIATIVE RATES R(4) FOR EQN (20) OF 
C          CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539
C          THE COMPLETE COEFFICIENT NEEDED FOR EQ. (20) IS 
C          BUILT BY SUMMING OUTSIDE OF THIS ROUTINE IN ROUTINE
C          SE0_BUILD
C
C INPUTS:
C       
C OUTPUTS:
C       R4COEFF
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE R4(IJ,IJ1,K,R4COEFF)
C  THIS SUBROUTINE CALCULATES THE RADIATIVE RATES R(4)  (IJ1 > IJ)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
	RJ=AJ(IJ)
	RJ1=AJ(IJ1)
	RK=FLOAT(K)
	R4COEFF=SG(INT(RJ+RJ1)+K+1)*(TWO*RJ1+ONE)*ECOEFF(IJ1,IJ)
     /	  *FUN6J(RJ,RJ,RK,RJ1,RJ1,ONE)
	RETURN
	END

C
C PURPOSE: CALCULATES PLANCK FUNCTION BNY AT ANGULAR FREQUENCY U, TEMP T
C  (NOTE- U  AND PLANCK ARE IN ANGULAR FREQUENCY UNITS)
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      FUNCTION PLANCK(Y,T)
C
      INCLUDE 'PREC'
      INCLUDE 'CCONST'
C
      U=Y*0.5/PI
      X=HH*U/BK/T
      IF(X.LT.80.) THEN
        PLANCK=2.0*HH*U/CC*U/CC*U/(EXP(X)-1.0)
      ELSE
        PLANCK=2.0*HH*U/CC*U/CC*U*EXP(-X)
      ENDIF
C
C CONVERT TO ANGULAR FREQUENCIES
C
      PLANCK=PLANCK*0.5/PI
C
      RETURN
      END
C
C**********************************************************************
C

C
C PURPOSE: CALCULATES THE (COMPLEX) SPHERICAL COMPONENTS OF GEOMETRIC TENSOR 
C       T_0^K(I) IN THE B-FRAME, FOR K=0,1,2
C
C INPUTS: T0
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C           EQUATION NUMBERS REFER TO 
C           CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539
C 
	SUBROUTINE T0TENS(T0)
C
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CORON'
	INCLUDE 'CCONST'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
	INCLUDE 'CLU'
C
	DIMENSION T0(0:3,0:2)
	PARAMETER (SQRT2=.14142135623730950488E1)
	PARAMETER (SQRT3=.17320508075688772935E1)
	STH=SIN(THETA)
	CTH=COS(THETA)
	S2G=SIN(TWO*PGAMMA)
	C2G=COS(TWO*PGAMMA)
	STHB=SIN(THETAB)
	CTHB=COS(THETAB)
	SPHB=SIN(PHIB)
	CPHB=COS(PHIB)
C
C  EQ. (42)
C
	COSF=CTH*CTHB+STH*STHB*CPHB
C
C  EQ. (44)
C
	SINCOSF=STH*CTHB-CTH*STHB*CPHB
C
C   CALCULATE  T0(I,K)
C   THESE ARE ALL FROM TABLE 1 OF CASINI & JUDGE, WITH 
C   APPROPRIATE SUBSTITUTIONS 
C
	DO K=0,2
	   DO I=0,3
	      T0(I,K)=ZERO
	   END DO
	END DO
C
C   K=0
C
	T0(0,0)=ONE
C
C   K=1
C
	T0(3,1)=(SQRT3/SQRT2)*COSF
C
C   K=2
C
	T0(0,2)=(0.5/SQRT2)*(THREE*COSF*COSF-ONE)
	TMP1=-(THREE/SQRT2)*(STHB*STHB*SPHB*SPHB
     *				    -0.5*(ONE-COSF*COSF))
	TMP2=-(THREE/SQRT2)*STHB*SPHB*SINCOSF
	T0(1,2)=TMP1*C2G+TMP2*S2G
	T0(2,2)=-TMP1*S2G+TMP2*C2G
C	WRITE(LOUT,1000) 'T0 TENSOR (I,K)'
C	DO I=0,3
C	   WRITE(LOUT,'(1P,3(1X,E10.3))') (T0(I,K),K=0,2)
C	END DO
C1000	FORMAT(/A)
	RETURN
	END

C
C PURPOSE: CONVERTS "MULTI" RADIATIVE ATOMIC TRANSITION PROBABILITIES
C          TO THOSE NEEDED FOR FORMALISM OF 
C          CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539
C          
C INPUTS:
C
C OUTPUTS (COMMON):
C          AJ            REAL QUANTUM NUMBER J OF A LEVEL
C          ECOEFF(I,J)   EINSTEIN A-COEFFICIENT (I > J)
C          ECOEFF(I,J)   2*PI* B COEFFICIENT (I < J)
C COMMON:
C          CATOM, CATMOS, CSLINE, CCONST, CLU, CSE,
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE ATOM1
C
C  FILLS ARRAYS J, ECOEFF, FOR USE WITH ROBERTO'S SUBROUTINES
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CSLINE'
      INCLUDE 'CCONST'
      INCLUDE 'CLU'
      INCLUDE 'CSE'
      INCLUDE 'CINTS'
C      DIMENSION DUM(MK,MK)
C
C     SET AJ, TOTAL ANGULAR MOMENTUM QUANTUM NUMBER
C
      DO 10 I=1,NK
         AJ(I)=(G(I)-ONE)/TWO
         E(I)=EV(I)*EE/HH/CC
         DO 9 J=1,NK
            ECOEFF(I,J)=ZERO
 9       CONTINUE
 10   CONTINUE
C
C     ECOEFF
C
C      WRITE(LOUT,'(A/)') '  ECOEFF: EINSTEIN COEFFICIENTS'
C      WRITE(LOUT,'(A/)') '     I           J          ENERGY CM-1'
C      DO 15 I=1,NK
C         WRITE(LOUT,1001) I,AJ(I),E(I)
C 15   CONTINUE
C     XT=5600.
      DO 11 KR=1,NLINE
         ECOEFF(JRAD(KR),IRAD(KR))=A(KR)
         ECOEFF(IRAD(KR),JRAD(KR))=B(IRAD(KR),JRAD(KR))*TWO*PI
C         DUM(JRAD(KR),IRAD(KR))=A(KR)
C         Y=2.*PI*CC*1.E8/ALAMB(KR)
C         DUM(IRAD(KR),JRAD(KR))=B(IRAD(KR),JRAD(KR))*TWO*PI*PLANCK(Y,XT)
 11   CONTINUE
C      WRITE(LOUT,1002) (J,J=1,NK)
C      DO 13 I=1,NK
C            WRITE(LOUT,1000) I,(ECOEFF(I,J),J=1,NK)
C 13   CONTINUE
C      WRITE(LOUT,'(//A)') '  ECOEFF: RATES SEC-1'
C      WRITE(LOUT,'(A)') '     I          J        ENERGY CM-1'
C      WRITE(LOUT,1002) (J,J=1,NK)
C      DO 14 I=1,NK
C            WRITE(LOUT,1000) I,(DUM(I,J),J=1,NK)
C 14      CONTINUE
C 1000 FORMAT(4X,I2,1P,10(E14.6))
C 1001 FORMAT(3X,I3,2X,1P,2(2X,E14.6))
C 1002 FORMAT(//1X,1P,10(I14))
      RETURN
      END
C
C***********************************************************************
C

      SUBROUTINE RINPUT
C
C  READS AN INPUT FILE CONSISTING OF VARIABLE NAMES AND VALUES
C  THE VARIABLE NAMES AND VALUES MUST OCCUR IN PAIRS:
C  NAME, VALUE, NAME, VALUE, ETC.
C  IERR IS INITIALIZED TO 0.
C  IF A VARIABLE IN THE LIST IS NOT GIVE A VALUE IN THE INPUT FILE,
C  A WARNING IS ISSUED AND IERR IS SET TO 2.
C  IF A VARIABLE IN THE INPUT FILE IS NOT IN THE LIST
C  A WARNING IS ISSUED AND IERR IS SET TO 1.
C  IF IERR IS 2 AFTER THE READ OPERATION, STOP IS CALLED
C
C  LIST OF LOCAL VARIABLES:
C  MAVAR  NUMBER OF REAL-TYPE VARIABLES IN THE VARIABLE LIST
C  MIVAR  NUMBER OF INTEGER TYPE VARIABLES IN THE LIST
C  MCVAR  NUMBER OF CHARACTER TYPE VARIABLES IN THE LIST
C  VNAME  ARRAY CONTAINING THE VARIABLE NAMES
C  CVALUE CHARACTER ARRAY WHERE THE VARIABLE VALUES ARE PUT AT INPUT
C  INDV   = 1 FOR VARIABLE NAMES
C         =-1 FOR VARIABLE VALUES
C
C  IF THE INPUT LIST IS CHANGED, CHANGES HAVE TO BE MADE THREE PLACES:
C  PARAMETER (MAVAR=,MIVAR=)
C  DATA VNAME/.../
C  READ(LDUMI,*)
C
C  THE ORDER OF VARIABLES MUST BE THE SAME IN DATA VNAME AND IN
C  READ(LDUMI,*).
C
C  IN ADDITION THE OUTPUT LIST SHOULD BE CHANGED IN WINPUT
C  AND RELEVANT COMMON BLOCKS SHOULD BE CHANGED
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CSLINE'
      INCLUDE 'CINPUT'
      INCLUDE 'CLU'
C
      PARAMETER (MAVAR=6,MIVAR=8,MCVAR=1)
      CHARACTER*20 CVALUE(MAVAR+MIVAR+MCVAR)
      CHARACTER*80 TEXT
      CHARACTER VNAME(MAVAR+MIVAR+MCVAR)*6
      CHARACTER VDESCR(MAVAR+MIVAR+MCVAR)*45
      DATA VNAME/'TP2TE ','WLMIN ','WLMAX ','SMALLN','QNORM ','CECOEF',
     *  'ISUM  ','ICOLL ','ISPLIN',
     *  'IWATOM','IWLINE','IWEQI ','IDEBUG',
     *  'IWATMO','CRTN  '/
      DATA VDESCR/'RATIO OF PROTON TO ELECTRON TEMPERATURES     ',
     *            'SHORTEST WAVELENGTH OUTPUT TO FILE           ',
     *            'LONGEST  WAVELENGTH OUTPUT TO FILE           ',
     *            'CALCN IS SKIPPED FOR ELECT. DENS. < THIS     ',
     *            'NORMALIZATION FOR FREQUENCIES [KM/S]         ',
     *            'RATE COEFFICIENT FOR ELASTIC COLLISIONS      ',
     *            'LEVEL INDEX TO USE FOR CONSERVATION EQN.     ',
     *            'INCLUDE COLLISIONS                           ',
     *            'INTERPOLATION: 2=LINEAR, 3....N= SPLINE      ',
     *            'OUTPUT ATOMIC PARAMETERS TO FILE             ',
     *            'OUTPUT FREQUENCY DEPENDENT LINE DATA TO FILE ',
     *            'OUTPUT IONIZATION EQUILIBRIUM DATA           ',
     *            'OUTPUT DEBUGGING INFO.                       ',
     *            'OUTPUT CORONAL DATA TO FILE  ''ATMOS''       ',
     *            'NAME OF ROUTINE SUPPLYING MAGNETIC DATA      '/
C
      IERR=0
      INDV=-1
      DO 50 I=1,MAVAR+MIVAR+MCVAR
        CVALUE(I)=' '
   50 CONTINUE
C
C  GO THROUGH THE INPUT FILE LINE BY LINE
C
      CALL CSTRIP(LINPUT,'INPUT')
  100 CONTINUE
        K0=1
        READ(LDUMS,200,END=700) TEXT
  200   FORMAT(A)
C
C  SEARCH LINE WORD BY WORD. EVERY SECOND WORD IS CONSIDERED TO BE
C  A VARIABLE NAME, EVERY SECOND ITS VALUE.
C  = IS IGNORED. K1=0 IN GETWRD IS A FLAG THAT THERE ARE NO MORE WORDS
C  ON THE LINE
C
  300   CONTINUE
          CALL GETWRD(TEXT,K0,K1,K2)
          IF(K1.EQ.0) GOTO 600
          K0=K2+2
          IF(TEXT(K1:K2).EQ.'=') GOTO 300
          INDV=-INDV
          IF(INDV.EQ.1) THEN
C
C  INDV=1 : VARIABLE NAME
C
            DO 400 I=1,MAVAR+MIVAR+MCVAR
              IF(TEXT(K1:K2).EQ.VNAME(I)(1:K2-K1+1)) GOTO 500
  400       CONTINUE
C
C  INPUT VARIABLE IS NOT IN LIST, OUTPUT WARNING AND SKIP THE
C  FOLLOWING STRING (SUPPOSED TO BE THE VALUE OF THE VARIABLE)
C
            IERR=1
            WRITE(LJOBLO,420) TEXT(K1:K2)
  420       FORMAT(4X,A,' IS NOT IN LIST')
            CALL GETWRD(TEXT,K0,K1,K2)
            IF(K1.EQ.0) THEN
              K0=1
  450         READ(LDUMS,200,END=700) TEXT
              CALL GETWRD(TEXT,K0,K1,K2)
              IF(K1.EQ.0) GOTO 450
            ENDIF
            K0=K2+2
            INDV=-INDV
            GOTO 300
C
C  INPUT VARIABLE IS IN LIST
C
  500       CONTINUE
            IVAR=I
          ELSE
C
C  INDV = -1 : VARIABLE VALUE
C
            CVALUE(IVAR)(20-K2+K1:20)=TEXT(K1:K2)
          ENDIF
        GOTO 300
  600   CONTINUE
      GOTO 100
  700 CONTINUE
C
C  ASSOCIATE VALUE TO VARIABLE
C  FIRST WRITE VALUES TO FILE, THEN READ VALUES IN FREE FORMAT
C  OUTPUT WARNING IF NO VALUE EXISTS
C
      CALL OPEN(LDUMI,'DUMI',1,'UNKNOWN')
      DO 740 I=1,MAVAR+MIVAR+MCVAR
        IF(CVALUE(I).EQ.' ') THEN
          IERR=2
          WRITE(LJOBLO,710) VNAME(I)
  710     FORMAT(4X,A,' HAS NO VALUE')
        ENDIF
        WRITE(LDUMI,720) CVALUE(I)
  720   FORMAT(1X,A)
  740 CONTINUE
      IF(IERR.LE.1) THEN
        CALL REWIND(LDUMI)
        READ(LDUMI,*) TP2TE,WLMIN,WLMAX,SMALLN,QNORM,CECOEF,
     *   ISUM,ICOLL,ISPLIN,IWATOM,IWLINE,IWEQI, 
     *   IDEBUG, IWATMO,CRTN
        CALL CLOSE(LDUMI)
      ELSE
        CALL STOP('RINPUT: IERR=2')
      ENDIF
C
      WRITE(LOUT,53) 
 53   FORMAT('1 INPUT PARAMETERS  '//)
      DO I=1, MAVAR+MIVAR+MCVAR
         WRITE(LOUT,54)VNAME(I),CVALUE(I),VDESCR(I)
 54      FORMAT(A,1X,A,3X,A)
      ENDDO
      WRITE(LOUT,55) 
 55   FORMAT(//)
C     
      RETURN
      END
C
C**********************************************************************
C

C
C PURPOSE: COMPUTE COLLISION RATES C(5) FOR EQN (20) OF 
C          CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539
C          THE COMPLETE COEFFICIENT NEEDED FOR EQ. (20) IS 
C          BUILT BY SUMMING OUTSIDE OF THIS ROUTINE IN ROUTINE
C          SE0_BUILD
C INPUTS:
C          IJ       INDEX OF LEVEL.  
C          IJ1      INDEX OF UPPER LEVEL
C          K        MULTIPOLAR COEFFICIENT
C OUTPUTS:
C          C5COEFF  
C COMMON:
C          CSE
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE C5(IJ,IJ1,K,C5COEFF)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'CINPUT'
	INCLUDE 'CLU'
	INCLUDE 'CINTS'
	RJ=AJ(IJ)
	RJ1=AJ(IJ1)
	C5COEFF=SQRT((TWO*RJ1+ONE)/(TWO*RJ+ONE))*CS(IJ,IJ1,K)
	IF(IDEBUG.NE.0)WRITE(lout,100)IJ,IJ1,K,C5COEFF
 100	format('C5(L,U,K)',3(I4,1x),1p,e9.2,0p)
	RETURN
	END

C
C PURPOSE: WRITES EMISSION COEFFICIENTS TO FILE
C
C INPUTS:
C
C WDEBUGS:
C
C COMMON: CSE, CSLINE, CATOM, CSLINE, CATOM, CORON, CINPUT, CLU
C
C RESTRICTIONS:  NONE
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE WDEBUG
C
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'CSLINE'
	INCLUDE 'CATOM'
	INCLUDE 'CATMOS'
	INCLUDE 'CORON'
	INCLUDE 'CGRID'
	INCLUDE 'CINPUT'
	INCLUDE 'CLU'
C added 6jul22
	INCLUDE 'CINTS'
C
	IF(IDEBUG .EQ. 0) RETURN
	WRITE(LOUT,*)'GX,GY,GZ',GX,GY,GZ
        WRITE(LOUT,*)'THETAB,PHIB',THETAB,PHIB
C Note this next line moved up in 6jul22 version
	WRITE(LOUT,1004)' ELECTRON DENSITY=',ED, ' TOTAL ION POP =',TOTN
	DO KR=1,NLINE
	   IF ((ALAMB(KR) .GE. WLMIN) .AND. (ALAMB(KR) .LE. WLMAX)) THEN
	      WRITE (LOUT,*) 'LINE ', KR, ALAMB(KR)
	      WRITE (LOUT,1000) 'FREQUENCIES ',NQ(KR)
	      WRITE (LOUT,1001) (Q(NY,KR),NY=1,NQ(KR))
	      WRITE (LOUT,*) 'EMISSION COEFFICIENTS '
	      DO IM=0,3
		 WRITE (LOUT,*) 'I = ',IM
		 WRITE (LOUT,1002) (EMISS(KR,IM,NY),NY=1,NQ(KR))
	      END DO
	   ENDIF
	END DO
	WRITE(LOUT,*)'LEVEL LABEL      / POPULATIONS'
	TSUM=0.
	DO IJ=1,NK
C Note these next two lines updated in 6jul22 version
	   WRITE(LOUT,1003)IJ,LABEL(IJ),TOTN*RHO(IJ,0)*SQRT(TWO*AJ(IJ)+ONE) 
	   TSUM=TSUM+TOTN*RHO(IJ,0)*SQRT(TWO*AJ(IJ)+ONE) 
	ENDDO
C Note this next line updated in 6jul22 version
	WRITE(LOUT,1003)-1,'1 -SUMMED POP/ION POP',1.-TSUM/TOTN
 1004	format(A,1p,e9.2,a,e9.2,0p)
 1003	format(i4,1x,a25,1x,1p,e9.2,0p)
C
 1000	FORMAT(1X,A,1X,I4)
 1001	FORMAT(10(4X,F7.3))
 1002	FORMAT(4(1P,10(1X,E10.3),0P/))
	RETURN
	END

C
C PURPOSE: TRAPEZOIDAL INTEGRATION OF EMISSION COEFFICIENTS ALONG LOS
C
C INPUTS:
C
C OUTPUTS:
C  EMERGE(KR,IM,NY)  - EMERGENT STOKES PARAMETERS IN ERG/CM2/S/SR/ANGSTROM
C
C COMMON: CSLINE, CCONST, CATOM, CINPUT
C
C RESTRICTIONS:  NONE
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE TRAP(WT)
C
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CINPUT'
	INCLUDE 'CSLINE'
	INCLUDE 'CATOM'
C
	DO KR=1,NLINE
	   IF ((ALAMB(KR) .GE. WLMIN) .AND. (ALAMB(KR) .LE. WLMAX)) THEN
              DO IM=0,4
                 DO NY=1,NQ(KR)
                    EMERGE(KR,IM,NY)=EMERGE(KR,IM,NY)+
     *              EMISS(KR,IM,NY)*WT
                 END DO
              END DO
           ENDIF
        END DO
	RETURN
	END

C
C PURPOSE: FUNCTION NEEDED FOR 3J CALCULATION
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	FUNCTION FN1(RJ1,RJ2,RJ3,RM1,RM2,RM3)
C   USED IN 3J CALCULATION
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CINTS'
	INCLUDE 'FACT'
C

	L1=NINT(RJ1+RJ2-RJ3)
	L2=NINT(RJ2+RJ3-RJ1)
	L3=NINT(RJ3+RJ1-RJ2)
	L4=NINT(RJ1+RJ2+RJ3+ONE)
	L5=NINT(RJ1+RM1)
	L6=NINT(RJ1-RM1)
	L7=NINT(RJ2+RM2)
	L8=NINT(RJ2-RM2)
	L9=NINT(RJ3+RM3)
	L10=NINT(RJ3-RM3)
	FN1=0.5*(FL(L1)+FL(L2)+FL(L3)-FL(L4)+FL(L5)+FL(L6)
     /	    +FL(L7)+FL(L8)+FL(L9)+FL(L10))
	RETURN
	END

C
C PURPOSE: GET CORONAL THERMAL AND MAGNETIC DATA FOR EACH GRID POINT
C
C INPUTS: NONE
C
C OUTPUTS:
C
C COMMON:
C     CATOM,CGRID,CATMOS,CATMO2,CCONST,CORON
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C
C  FOUR DIFFERENT REFERENCE FRAMES ARE NEEDED (SEE NOTES):
C
C	1. FRAME WITH Z-AXIS AS THE LOCAL VERTICAL AT THE OBSERVED 
C	   POINT (S)
C
C	2. FRAME WITH Z-AXIS AS THE MEDIAN OF THE LOS DISTRIBUTION,
C	   AND ORIENTED AS THE REFERENCE DIR. OF POLARIZATION (S')
C
C	3. FRAME WITH Z-AXIS AS THE SUN ROTATION AXIS (S_R)
C
C	4. FRAME WITH Z-AXIS AS THE LOCAL VERTICAL THROUGH THE
C	   REFERENCE POINT M OF THE MAGNETIC-SOURCE DISTRIBUTION (S_M)
C
      SUBROUTINE CORONA
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CGRID'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CATMO2'
      INCLUDE 'CCONST'
      INCLUDE 'CORON'
      INCLUDE 'CLU'
      INCLUDE 'CINPUT'
      CHARACTER CORNAM*6
C      CALL CPTIME('CORONA',0,0,1)
C
C  SET UP PARAMETERS FOR THE GEOMETRY. ALL GEOMETRY IS SPECIFIED ON
C  INPUT IN GX, GY, GY WHICH ARE CARTESIAN (X,Y,Z) COORDINATES IN S FRAME
C
      GX2=GX*GX
      GY2=GY*GY
      GZ2=GZ*GZ
C     
      ALPHA=-ATAN2(GX,SQRT(GY2+GZ2))
C     
      SALPHA=SIN(ALPHA)
      CALPHA=COS(ALPHA)
C     
      BETA=ATAN2(GY,GZ)
C     
      SBETA=SIN(BETA)
      CBETA=COS(BETA)
C     
C     OBSERVER'S GEOMETRY IN THE "S-FRAME" (PHI=0), 
C     WITH REFERENCE DIRECTION ALWAYS PARALLEL TO Z
C     
      THETA=0.5*PI+ALPHA
      PGAMMA=BETA
C     
C     TRANSFORM TO POLAR COORDINATES FOR B-FIELD CALCULATION
C     
      RB=SQRT(GX2+GY2+GZ2)
      TB=ATAN2(SQRT(GX2+GY2),GZ)
      PB=ATAN2(GY,GX)
C     
C     COMPUTE MAGNETIC PARAMETERS
C     
C >>> USER SUPPLIED FIELD/PLASMA ROUTINES GO HERE <<<
C
      CORNAM=CRTN
      IPRINT=0
      IF(CORNAM(1:6) .EQ. 'DIPOLE') THEN 
         IPRINT=1
         CALL DIPOLE(RB,TB,PB,BS,TS,PS,PNE,TOTH,PT,PVEL,PTURBV,IPRINT)
      ELSE IF(CORNAM(1:3) .EQ. 'FFL') THEN 
         IPRINT=1
         CALL FFL(RB,TB,PB,BS,TS,PS,PNE,TOTH,PT,PVEL,PTURBV,IPRINT)
      ELSE IF(CORNAM(1:2) .EQ. 'ZL') THEN 
         IPRINT=1
         CALL ZL(RB,TB,PB,BS,TS,PS,PNE,TOTH,PT,PVEL,PTURBV,IPRINT)
      ELSE IF(CORNAM(1:5) .EQ. 'CUSER') THEN 
         IPRINT=1
         CALL CUSER(RB,TB,PB,BS,TS,PS,PNE,TOTH,PT,PVEL,PTURBV,IPRINT)
      ELSE 
         WRITE(LJOBLO,1001)CORNAM
 1001    FORMAT(' CORONA: SUBROUTINE  ',A,' IS NOT KNOWN')
         CALL STOP('CORONA: NO CORONAL DATA ROUTINE')
      ENDIF
C
C
      BFIELD=BS
      BTHETA=TS
      BPHI=PS
C     
      XB=SIN(BTHETA)*COS(BPHI)
      YB=SIN(BTHETA)*SIN(BPHI)
      ZB=COS(BTHETA)
C     
      YZB=SBETA*YB+CBETA*ZB
C     
      XXB=CALPHA*XB+SALPHA*YZB
      YYB=CBETA*YB-SBETA*ZB
      ZZB=-SALPHA*XB+CALPHA*YZB
C     
C     COMPUTE POLAR ANGLES OF B IN THE "S'-FRAME"
C     (VAN VLECK ANGLE = 54.7356103173)
C     
      THETAB=ATAN2(SQRT(XXB*XXB+YYB*YYB),ZZB)	
      PHIB=ATAN2(YYB,XXB)
C     
C     HEIGHT ABOVE LIMB
C     
      H=RB-1.0
C     
C     LARMOR FREQUENCY 
C     
      ALARMOR=(1.0E-8*(0.25E0/PI)*(EE/EM)*BFIELD)/QNORM
C     
C     THERMAL PARAMETERS
C     
      TEMP=PT
      ED=PNE
C     
      VTURB=PTURBV/QNORM
      VEL=PVEL/QNORM
C
C  NORMALIZE ATOMIC POPULATIONS
C
      TOTN=10.**(ABND-12.)*TOTH*EQION(TEMP)
C HYDROGEN POPULATIONS: ZERO IF NEUTRAL, TOTH FOR PROTONS
      DO I=1,5
         HD(I)=0.
      ENDDO
      HD(6)=TOTH
C
C      CALL CPTIME('CORONA',0,1,1)
      RETURN
      END

C
C PURPOSE: CALCULATES LINEAR INTERPOLATION
C
C INPUTS:
C       X, Y, N, X1,NNN (NNN NOT NEEDED, USED FOR COMPATIBILITY WITH SPLIN)
C OUTPUTS:
C       Y1 INTERPOLATED VALUE
C COMMON:
C
C RESTRICTIONS:
C       
C COMMENTS: JANUARY 11, 2006 P. JUDGE
C 
	FUNCTION ALIN(T,X,Y,N,NNN)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	DIMENSION X(N),Y(N)
C       
	IF (T.LT.X(1)) THEN
	   ALIN=Y(1)
	   RETURN
	END IF
C       
	IF (T.GT.X(N)) THEN
	   ALIN=Y(N)
	   RETURN
	END IF
	I=0
 1	I=I+1
	I1=I+1
	IF ((T.GE.X(I)).AND.(T.LT.X(I1))) THEN
	   DL=(T-X(I))/(X(I1)-X(I))
	   ALIN=Y(I)+(Y(I1)-Y(I))*DL
	ELSE
	   GOTO 1
	END IF
	RETURN
	END

C
C PURPOSE: CALCULATES CORONAL IONIZATION FRACTIONS
C
C INPUTS: TEMP
C
C OUTPUTS:
C
C COMMON:
C     CATOM 
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C Changes made for reading in new chianti.ioneq file June 2016
C  LXIFF now 1e-30 for all values for which XIFF = 0 up to element MXI rather than just NIN, 7-Oct-2016, TAK
C 
      FUNCTION EQION(TEMP)
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      PARAMETER (MXI=150)
      INCLUDE 'CATOM'
      INCLUDE 'CINPUT'
      INCLUDE 'CLU'
      DATA ICALL/0/
      DIMENSION TIFF(MXI), XIFF(MXI), XLIFF(MXI)
      SAVE ICALL,TIFF,XIFF,XLIFF,NIN
C     
      IF (ICALL .EQ. 0) THEN 
         ICALL=ICALL+1
C
C  FIND ELEMENT AND CHARGE
C
 
         IZ=IATOMN(ATOMID(1:2))   
         IF (IZ .LT. 1 .OR. IZ .GT. 92) 
     *      CALL STOP('EQION: ATOMIC NUMBER OUT OF RANGE')
         ISPEC=ION(1)
         I=1
         CALL OPEN(IUNIT,'IONEQ',I,'OLD') 
         READ(IUNIT,*) NIN
         IF(NIN .GT. MXI) CALL STOP('EQION: NIN .GT. MXI')
         READ(IUNIT,*) (TIFF(I),I=1,NIN)
         IEL=0
         ISP=0
         DO K=1,1000
             READ(IUNIT,'(2I3,150E10.2)', END=40), IEL,ISP,(XIFF(I),I=1,NIN)
           IF( (IEL .EQ. IZ) .AND. (ISP .EQ. ISPEC)) THEN
              CALL CLOSE(IUNIT) 
              GOTO 50
           ENDIF
         ENDDO
 40      CALL STOP('EQION: ELEMENT AND ION NOT FOUND IN THE IONEQ FILE')
 50      CONTINUE
         DO I=1,MXI
            XLIFF(I)=-30.
            IF(XIFF(I) .GT. 0.) XLIFF(I)=LOG10(XIFF(I))
         ENDDO
         IF(IWEQI .EQ. 1) THEN
            WRITE(LOUT,53) 
 53         FORMAT('1 IONIZATION EQUILIBRIUM: ',
     *             'SPLINE INTERPOLATION ON LOGARITHMIC VALUES'//
     *           ' LOG10 TE     ION FRACTION',
     *           ' (VALUES OUTSIDE TABULATED TE RANGE ARE ZERO'//)
            DO I=1, NIN
               IF(XIFF(I) .GT. 0.) WRITE(LOUT,54)TIFF(I),XIFF(I)
 54            FORMAT(1X,F9.2,3X,1P,E9.2,0P)
            ENDDO
            WRITE(LOUT,55) 
 55         FORMAT(//)
         ENDIF
      ENDIF
C
C INTERPOLATE IN LOG SPACE
C
      TLG=LOG10(TEMP)
      ZER=0.0
      NINTEP=MIN(ISPLIN,NIN) 
      EQION=10.**SPLIN(TLG,TIFF,XLIFF,NIN,NINTEP)
      EQION=MAX(EQION,ZER)
C      eqion=0.295*exp(-1.*(tlg-6.2)**2/(2.*0.1**2))
C      WRITE(*,*),'EQION,TLG,TIFF,XLIFF,NIN,NINTEP',EQION,TLG,TIFF,XLIFF,NIN,NINTEP
      RETURN
      END

C
C PURPOSE: COMPUTES INELASTIC COLLISION RATES 
C          FROM THE 
C INPUTS:
C          IJ       INDEX OF LOWER LEVEL 
C          IJ1      INDEX OF UPPER LEVEL
C          K        MULTIPOLAR COEFFICIENT
C
C OUTPUTS:
C          CS       SUPERELASTIC RATE FROM MULTIPOLAR COMPONENT K
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	FUNCTION CS(IJ,IJ1,K)
C  THIS FUNCTION CALCULATES THE INELASTIC COLLISIONAL RATES 
C  C_S(IJ,IJ1,K) (FOR IJ1 > IJ)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
	RJ=AJ(IJ)
	RJ1=AJ(IJ1)
	RK=FLOAT(K)
	JP=NINT(RJ+RJ1)
	JM=NINT(ABS(RJ-RJ1))
	CSTMP=ZERO
	DO K1=JM,JP
	  RK1=FLOAT(K1)
     	  CSTMP=SG(K1)*FUN6J(RJ,RJ,RK,RJ1,RJ1,RK1)*GAMMAS(IJ,IJ1,K1)
     /	  +CSTMP
	END DO
	CS=SG(JP-K)*SQRT((TWO*RJ+ONE)*(TWO*RJ1+ONE))*CSTMP
	RETURN
	END

C
C PURPOSE: FINDS NEXT WORD IN TEXT FROM INDEX K0
C
C INPUTS:
C     text   input string
c     k0     beginning search position
C OUTPUTS:
c     k1     index position of beginning of word
c     k2     index position of end of word
C COMMON:
C
C COMMENTS: October 6, 1999, P. JUDGE
C 
      SUBROUTINE GETWRD(TEXT,K0,K1,K2)
C
C  FINDS NEXT WORD IN TEXT FROM INDEX K0. NEXT WORD IS TEXT(K1:K2)
C  THE NEXT WORD STARTS AT THE FIRST ALPHANUMERIC CHARACTER AT K0
C  OR AFTER. IT ENDS WITH THE LAST ALPHANUMERIC CHARACTER IN A ROW
C  FROM THE START
C
      INCLUDE 'PREC'
      INTEGER MSEPAR
      PARAMETER (MSEPAR=7)
      CHARACTER*(*) TEXT
      CHARACTER SEPAR(MSEPAR)
      INTEGER K0,K1,K2,I,J
      DATA SEPAR/' ','(',')','=','*','/',','/
C
      K1=0
      DO 400 I=K0,LEN(TEXT)
        IF(K1.EQ.0) THEN
          DO 100 J=1,MSEPAR
            IF(TEXT(I:I).EQ.SEPAR(J)) GOTO 200
  100     CONTINUE
          K1=I
C
C  NOT START OF WORD
C
  200     CONTINUE
        ELSE
          DO 300 J=1,MSEPAR
            IF(TEXT(I:I).EQ.SEPAR(J)) GOTO 500
  300     CONTINUE
        ENDIF
  400 CONTINUE
C
C  NO NEW WORD. RETURN K1=K2=0
C
      K1=0
      K2=0
      GOTO 999
C
C  NEW WORD IN TEXT(K1:I-1)
C
  500 CONTINUE
      K2=I-1
C
  999 CONTINUE
      RETURN
      END
C
C***********************************************************************
C

C
C PURPOSE: WRITES EMERGENT STOKES PROFILES TO FILE
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON: CSLINE, CATOM, CSLINE, CLU
C
C RESTRICTIONS:  THIS SHOULD BE REPLACED BY UNFORMATTED OUTPUT 
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE OUTS(J,K)
C
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'GRDPAR'
	INCLUDE 'CSLINE'
	INCLUDE 'CATOM'
	INCLUDE 'CINPUT'
	INCLUDE 'CGRID'
	INCLUDE 'CCONST'
	INCLUDE 'CLU'
        DIMENSION SUMS(MLINE,0:4)
	DATA ICALL/0/
	SAVE ICALL
C
	IF(ICALL .EQ. 0) THEN 
	   KOUNT=0
	   DO KR=1,NLINE
	      IF ((ALAMB(KR) .GE. WLMIN).AND.(ALAMB(KR) .LE. WLMAX)) THEN
		 KOUNT=KOUNT+1
	      ENDIF
	   ENDDO
	   WRITE(LOUT,2004) KOUNT
 2004	   FORMAT('1 STOKES DATA OUTPUT'//
     *      ' TOTAL NUMBER OF LINES OUTPUTTED ',I8)
	   DO KR=1,NLINE
	      WW=CONVL(ALAMB(KR))
	      IF ((WW .GE. WLMIN) .AND. (WW .LE. WLMAX)) THEN 
		 WRITE (LOUT,*) 'LINE ', KR, WW
		 WRITE (LOUT,1000) 'DELTA-WAVELENGTHS [ANGSTROM]',NQ(KR)
		 WRITE (LOUT,1001) (DLAMB(Q(NY,KR),KR),NY=1,NQ(KR))
	      ENDIF
	   END DO
	   IF(IWLINE .GT. 0) THEN 
	      WRITE(LOUT,*)
     *        'FULL EMERGENT STOKES PROFILES'
	   ELSE
	      WRITE(LOUT,*)
     *        'FREQUENCY-INTEGRATED EMERGENT STOKES DATA ONLY' 
	   ENDIF
	   ICALL=ICALL+1
	ENDIF
C
C WW IS THE WEIGHT NEEDED TO INTEGRATE OVER WAVELENGTH
C
	QN=QNORM*1.E5/CC
	DO KR=1,NLINE
	   IF ((ALAMB(KR) .GE. WLMIN) .AND. (ALAMB(KR) .LE. WLMAX)) THEN 
	      WW=ALAMB(KR)*QN/(1.0+QN)
	      DO IM=0,4
		 IF(IWLINE .GT. 0) WRITE (LOUT,1002) 
     *              (EMERGE(KR,IM,NY),NY=1,NQ(KR))
		 SUMS(KR,IM)=0.
		 DO NY=1,NQ(KR)-1
		    SIGN=+1.
		    ADD=EMERGE(KR,IM,NY)
		    IF(IM .GE. 3 .AND. Q(NY,KR) .LT. 0.) SIGN=-1.
		    SUMS(KR,IM)=SUMS(KR,IM) + SIGN*ADD*WQ(NY,KR)*WW
		 ENDDO
	      END DO
	      WRITE(LOUT,1003) (SUMS(KR,IM),IM=0,4)
	   ENDIF
	END DO
 1000	FORMAT(1X,A,1X,I4)
 1001	FORMAT(10(1X,F7.3))
 1002	FORMAT(4(1P,10(1X,E10.3),0P/))
 1003	FORMAT(5(1P,1X,E10.3),0P/)
	RETURN
	END

C
C PURPOSE: CALCULATES DAMPING PARAMETERS, DOPPLER WIDTHS
C     VARIOUS DATA ARE WRITTEN TO COMMON BLOCKS
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C     CATOM CATMOS CATMO2 CORON CCONST CINPUT
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE DAMP

C
C  CALCULATES DAMPING PARAMETERS
C  INPUT: GA, GW, GS IN  ROUTINE  ATOM WHERE
C  GAMMA = GR + GV + GS AND
C  GR=GA
C  GS=GQ*NE
C  GV=GW*GVW(H)
C
C  GVW(H) = 8.08 * (1+0.41*NHE/HD) * VH**0.6 * HD * C6**0.4
C  VH**0.6 = (8*BK*T/PI*(1/MH+1/AWGT))**0.3
C  C6 = 1.01E-32 * (13.6*ION)**2 *
C       (1/(EV(CONT)-EV(UPPER))**2 - 1/(EV(CONT)-EV(LOWER))**2)
C  REFERENCE MIHALAS 1978: STELLAR ATMOSPHERES, 2ND ED
C  NHE/NH IS SET TO 0.1
C  NB: C6 SHOULD BE DIVIDED BY 2*PI WHEN COMPARED WITH GREY AND UNSOLD
C
C
C  FOR H-ALPHA GS=4.737E-7*HD(1,K), REF. LINEAR-B
C
C:
C: DAMP   88-01-19  MODIFICATIONS: (MATS CARLSSON)
C:        IF GW=0 LEVELS WITHOUT OVERLYING CONTINUUM ARE ALLOWED
C:
C:        88-05-20  MODIFICATIONS: (MATS CARLSSON)
C:        IF GQ.LT.0 IT IS ASSUMED TO BE LG(C4)
C:
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CATMO2'
      INCLUDE 'CORON'
      INCLUDE 'CCONST'
      INCLUDE 'CINPUT'
      INCLUDE 'CLU'
      DATA ICALL /0/
      SAVE ICALL
C     
      IF (ICALL .EQ. 0) THEN 
         WRITE(LJOBLO,100)' DAMP: LINE DAMPING PARAMETERS SET TO ZERO'
 100     FORMAT(A)
         ICALL=ICALL+1
      ENDIF
C
      ZER=0.
      GS=ZER
      GV=ZER
      GR=ZER
      TOTHI=ZER
C
C  CALCULATE DOPPLER WIDTH
C
      TWO=2.
      DNYD=SQRT(TWO*BK*TEMP/AWGT)*1.E-5/QNORM
C
C  INCLUDE MICROTURBULENCE
C
      DNYD=SQRT(DNYD*DNYD+VTURB*VTURB)
C
C  CALCULATE GAMMA, ADAMP
C
      DO 330 KR=1,NLINE
         I=IRAD(KR)
         J=JRAD(KR)
C     
C     FIND CONTINUUM LEVEL
C     
         IF(GW(KR).NE. ZER) THEN
            DO 200 IC=J+1,NK
               IF(ION(IC).EQ.ION(J)+1) GOTO 300
 200        CONTINUE
            CALL STOP(' DAMP: NO OVERLYING CONTINUUM')
 300        CONTINUE
            ZZ=ION(I)
            C625=1.283984E-12*ZZ**0.8*(1./(EV(IC)-EV(J))**2-
     *           1./(EV(IC)-EV(I))**2)**.4
            GV=GW(KR)*8.411*(8.*BK*TEMP/PI*(1./(1.008*UU)+
     *           1./AWGT))**0.3*TOTHI*C625
         ELSE
            GV=0.0
         ENDIF
         GR=GA(KR)
         IF(GQ(KR).GE. 0.0) THEN
            GS=GQ(KR)*ED
         ELSE
C     FORMULA FROM GRAY, P.237
            GSLG=19.4+2./3.*GQ(KR)+LOG10(ED*BK)+LOG10(TEMP)/6.
            GS=10.**GSLG
         ENDIF
C     IF(ATOMID.EQ.'H   ' .AND. J.EQ.3 .AND. I.EQ.2)
C     *     GS=4.737E-7*HD(1)
         GAMMA=GR+GV+GS
         DOP=DNYD*QNORM/ALAMB(KR)*1.E13
         ADAMP(KR)=GAMMA/(4.*PI*DOP)
         DDP=DNYD*QNORM*1.E8/CC*ALAMB(KR)
         IF(IWDAMP.GT.0) CALL WDAMP(KR,DDP,GAMMA,GR,GV,GS)
 330  CONTINUE
      RETURN
      END
C
C***********************************************************************
C

C
C PURPOSE: COPIES SOLUTION OF S.E. EQUATIONS INTO THE DENSITY-MATRIX VECTOR
C
C INPUTS:
C       NDIM
C       SOL
C OUTPUTS:
C       RHO (SET IN COMMON CSE)
C COMMON:
C       CATOM CSE CLU
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE SE0_COPY(NDIM,SOL)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CATOM'
	INCLUDE 'CSE'
	INCLUDE 'CINTS'
	INCLUDE 'CINPUT'
	INCLUDE 'CLU'
C
	DIMENSION RHONORM(0:MJTOT,0:MJTOT)
	DIMENSION SOL(NDIM)
C
	I=0
	TRACE=ZERO
C debug statement updated 6jul22
        IF(IDEBUG.EQ.1) THEN
	   WRITE(LOUT,*)'NORMALIZED DENSITY MATRIX VECTOR, RHO(J,K)'
	   WRITE(LOUT,21) 'K=',(K,K=0,INT(2*AJ(NK)),2)
	ENDIF

	DO IJ=1,NK
	   I2J=NINT(TWO*AJ(IJ))
C Note stepping by 2 added with 6jul22 version
	   DO K=0,I2J,2
	      I=I+1
	      IF (K.EQ.0) WGT=WEIGHT(I)
	      RHO(IJ,K)=SOL(I)
	      RHONORM(IJ,K)=WGT*SOL(I)
	  END DO
	  TRACE=RHONORM(IJ,0)+TRACE
C outputting by 2 added 6jul22
	  IF(IDEBUG.EQ.1) WRITE (LOUT,20)'J=',IJ,(RHONORM(IJ,K),K=0,I2J,2)
	END DO
       IF(IDEBUG.EQ.1) THEN 
	  WRITE(LOUT,30) ' TRACE =',TRACE
	  WRITE(LOUT,10) ' ALIGNMENT FACTOR, RHO(J,2)/RHO(J,0)'
	  DO IJ=1,NK
	     WRITE (LOUT,40) ' J =',IJ,RHO(IJ,2)/RHO(IJ,0)
	  END DO
	ENDIF
 10	FORMAT(/A/)
 20	FORMAT(2X,1P,A,I3,1X,12(1X,E10.3))
C next format statement added 6jul22
 21     FORMAT(1X,A,12(1X,I10))
 30	FORMAT(/2X,1P,A,E10.3)
 40	FORMAT(2X,1P,A,I3,2X,E10.3)
	RETURN
	END

C
C PURPOSE: CALCULATES A MAGNETIC FIELD ACCORDING TO ZHANG AND LOW
C
C INPUTS:
C       RAD    RADIUS OF POINT RELATIVE TO SUN CENTER, UNITS OF SOLAR RADII
C       THET   AZIMUTHAL ANGLE, UNITS RADIANS, IN S FRAME
C       PH     POLAR ANGLE, UNITS RADIANS, IN S FRAME
C       IPRINT SET TO 1 FOR MORE VERBOSE OUTPUT
C OUTPUTS:
C       B      MAGNITUDE OF FIELD
C       T      POLAR ANGLE
C       P      AZIMUTHAL ANGLE
C       EDENS  ELECTRON DENSITY /CM3
C       HDENS  HYDROGEN NUCLEI DENSITY /CM3 
C       TEMP   ELECTRON TEMPERATURE K
C       VEL    FLOW VELOCITY ALONG LINE OF SIGHT (+VE MEANS TOWARDS OBSERVER)
C       TURBV  MICROTURBULENCE KM/S (CONTRIBUTES TO LINE PROFILE WIDTHS)
C COMMON:
C
C COMMENTS: APRIL 19, 2006
C
C NOTES:    USER-SUPPLIED ROUTINE
C 
	SUBROUTINE ZL(RAD,THET,PH,BMAG,T,P,EDENS,HDENS,
     *    TEMP,VEL,TURBV,IPRINT)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
        INCLUDE 'CCONST'
	INCLUDE 'CGRID'
	INCLUDE 'CINPUT'
	INCLUDE 'CLU'
	INCLUDE 'CINTS'
	COMMON /CZL/ ACONST,B0,CI0, ALPHAX, ALPHAY,P0,T0
	COMMON /WATM/BX,BY,BZ
	DATA KCALL /0/
	DATA EPSILON, ZER, SMALL /1.E-3,0.,1.E-20/
	SAVE KCALL
C
	IF (KCALL .EQ. 0) THEN 
	   CALL CSTRIP(LDIP,'ZL.DAT')
           READ(LDUMS,*) ACONST
	   READ(LDUMS,*) B0
	   READ(LDUMS,*) CI0
	   READ(LDUMS,*) ALPHAY, ALPHAX
	   READ(LDUMS,*) P0
	   READ(LDUMS,*) T0
	   WRITE(LOUT,4001) ACONST,B0,CI0,ALPHAY,ALPHAX,P0,T0
 4001	   FORMAT('1 CORONAL ROUTINE IS ZL'/
     *     'A= ',F11.6,' B0= ',F10.4,' CI0= ',F10.4,' ALPHAY= ',F10.4,
     *     ' ALPHAX= ',F10.4/'P0= ',F10.4,' T0=',1P,E10.3,0P)
	   CALL CLOSE(LDUMS)
	   KCALL=KCALL+1
	ENDIF
C
C  CALCULATE CARTESIAN COORDINATES OF THE POINT RAD,THET,PH
C  X IS LOS
C
	X=RAD*SIN(THET)*COS(PH)
	Y=RAD*SIN(THET)*SIN(PH)
	Z=RAD*COS(THET)
        R=RAD
C
C ROTATE TO (R,THETA) PLANE IN WHICH FFL SOLUTION IS GIVEN IN TERMS
C OF STREAM FUNCTION. 
C	
C ROTATION ABOUT Y AXIS, AND THEN X-AXIS
C
	X1=X
	Y1=Y
	Z1=Z
	CALL ROT(X1,Z1,ALPHAY)
	CALL ROT(Y1,Z1,ALPHAX)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C ROTATED FRAME:
C  CALCULATE THE (R,THETA) COMPONENTS OF THE MAGNETIC FIELD IN THE ROTATED 
C  REFERENCE FRAME. 
C
	COSTH=Z1/R
	SINTH=SQRT(1.-COSTH*COSTH)
	TH=ATAN2(SINTH,COSTH)
	TANTH=SINTH/COSTH
C
	DTH=0.01
	DR=0.001*R
C
C SIMPLE CENTERED DIFFERENCE, 4 CALLS
C
C	BR=1./R/R/SINTH*(AZL(R,TH+DTH,CI0,ACONST,B0) - 
C     *     AZL(R,TH-DTH,CI0,ACONST,B0))/2./DTH
C	BTH=-1./R/SINTH * (AZL(R+DR,TH,CI0,ACONST,B0) - 
C     *     AZL(R-DR,TH,CI0,ACONST,B0))/2./DR
C ALL DONE!
C
C SIMPLE CENTERED DIFFERENCE, NR ITERATION
C
	BR=1./R/R/SINTH*DAZLDTH(R,TH,CI0,ACONST,B0)
	BTH=-1./R/SINTH*DAZLDR(R,TH,CI0,ACONST,B0)
C 
C CARTESIAN COMPONENTS IN THIS ROTATED REFERENCE FRAME
C
	BMAG=SQRT(BR*BR+BTH*BTH)
	V=SQRT(X1*X1+Y1*Y1)
	COSPH=X1/V
	SINPH=Y1/V
        BZ=  BR*COSTH - BTH*SINTH
	BX= (BR*SINTH + BTH*COSTH)*COSPH
	BY= (BR*SINTH + BTH*COSTH)*SINPH
C
C DENSITY RESTRICTION AROUND CURRENT SHEET, NARROWING WITH R
C NOT IN PRESSURE EQUILIBRIUM 
C BEGIN
C	THICK=0.1/R/R
C	TH1=ACOS(COSTH)
C       DELTA=(PI/2.-TH1)/THICK
C END
C ROTATED FRAME END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C TRANSFORM BACK, ROTATE ABOUT X AND Y AXES
C
	BX1=BX
	BY1=BY
	BZ1=BZ
	CALL ROT(BY1,BZ1,-ALPHAX)
	CALL ROT(BX1,BZ1,-ALPHAY)
C  RE-ASSIGN
	BX=BX1
	BY=BY1
	BZ=BZ1
C
C  RETURN VALUES OF B,T,P
C
	BMAG=SQRT(BX*BX+BY*BY+BZ*BZ)
	T=ACOS(BZ/BMAG)
	P=ATAN2(BY,BX)
C
C THERMAL PARAMETERS
C
C
C  ELECTRON DENSITY AND TEMPERATURE.
C
	VEL=0.
	TURBV=15.
C	DELTA=0.
C	GFAC=EXP(-DELTA*DELTA)
	GRAV=2.7398E4
	TEMP=T0
C	EDENS=P0/BK/T0/1.88*GFAC
	EDENS=P0/BK/T0/1.88
	RHO=1.3625*0.8*UU
	PTOT=BK*TEMP*1.88 + 0.5* RHO*(TURBV*TURBV)*1.E10
	HSCALE = PTOT/RHO/GRAV
	HSCALE=HSCALE/RSUNCM
	FFAC= MAX((R-1.),ZER)
	FFAC=EXP(-FFAC/HSCALE)
	EDENS=EDENS*FFAC
	HDENS=0.8*EDENS
	RETURN
	END
C
C**********************************************************************
C
	FUNCTION AZL(R, THETA, CI0, A0, B0)
	INCLUDE 'PREC'
	INCLUDE 'CCONST'
	EPS = 1.E-6
	AZL=0.0
	ST=SIN(THETA)
C   
C ABRAMOWITZ & STEGUN  EQS. 25.4.38, INTEGRAL OF F(X)/SQRT(1-X^2) DX BETWEEN
C -1 AND 1
C HERE, F(X) IS X/SQRT(A^2+R^2 - 2AR SIN(TH) SQRT(1-X^2))
C
	NMAX=40
	SUM=0.
	W = PI/NMAX
	DO 100 I=1,NMAX
	   X = COS( PI*(2.*I-1.)/NMAX )
	   F = X/SQRT(EPS+A0*A0+R*R -2.*A0*R*ST*X)
	   FIMAGE = X/SQRT(EPS+A0*A0*R*R +1. -2.*A0*R*ST*X)
	   SUM=SUM+F-FIMAGE
 100	CONTINUE
	AZL = 2.*CI0*A0*R*ST*SUM*W + B0*ST*ST/R
	RETURN
	END
C
C**********************************************************************
C BASED ON DFRIDR.F OF NUMERICAL RECIPES
C
      FUNCTION DAZLDTH(R,TH,CI0,ACONST,B0)
      INTEGER NTAB
      REAL DAZLDTH,ERR,H,X,FUNC,CON,CON2,BIG,SAFE
      PARAMETER (CON=1.4,CON2=CON*CON,BIG=1.E30,NTAB=10,SAFE=2.)
      INTEGER I,J
      REAL ERRT,FAC,HH,A(NTAB,NTAB)
      X=TH
      H=0.01
      HH=H
      A(1,1)=(AZL(R,TH+HH,CI0,ACONST,B0)-AZL(R,TH-HH,CI0,ACONST,B0))
     * /(2.0*HH)
      ERR=BIG
      DO 12 I=2,NTAB
        HH=HH/CON
        A(1,I)=(AZL(R,TH+HH,CI0,ACONST,B0)-AZL(R,TH-HH,CI0,ACONST,B0))
     *   /(2.0*HH)
        FAC=CON2
        DO 11 J=2,I
          A(J,I)=(A(J-1,I)*FAC-A(J-1,I-1))/(FAC-1.)
          FAC=CON2*FAC
          ERRT=MAX(ABS(A(J,I)-A(J-1,I)),ABS(A(J,I)-A(J-1,I-1)))
          IF (ERRT.LE.ERR) THEN
            ERR=ERRT
            DAZLDTH=A(J,I)
          ENDIF
11      CONTINUE
        IF(ABS(A(I,I)-A(I-1,I-1)).GE.SAFE*ERR) RETURN
12    CONTINUE
      RETURN
      END
C
C**********************************************************************
C
      FUNCTION DAZLDR(R,TH,CI0,ACONST,B0)
      INTEGER NTAB
      REAL DAZLDTH,ERR,H,X,FUNC,CON,CON2,BIG,SAFE
      PARAMETER (CON=1.4,CON2=CON*CON,BIG=1.E30,NTAB=10,SAFE=2.)
      INTEGER I,J
      REAL ERRT,FAC,HH,A(NTAB,NTAB)
      X=R
      H=0.01*R
      HH=H
      A(1,1)=(AZL(R+HH,TH,CI0,ACONST,B0)-AZL(R-HH,TH,CI0,ACONST,B0))
     * /(2.0*HH)
      ERR=BIG
      DO 12 I=2,NTAB
        HH=HH/CON
        A(1,I)=(AZL(R+HH,TH,CI0,ACONST,B0)-AZL(R-HH,TH,CI0,ACONST,B0))
     *   /(2.0*HH)
        FAC=CON2
        DO 11 J=2,I
          A(J,I)=(A(J-1,I)*FAC-A(J-1,I-1))/(FAC-1.)
          FAC=CON2*FAC
          ERRT=MAX(ABS(A(J,I)-A(J-1,I)),ABS(A(J,I)-A(J-1,I-1)))
          IF (ERRT.LE.ERR) THEN
            ERR=ERRT
            DAZLDR=A(J,I)
          ENDIF
11      CONTINUE
        IF(ABS(A(I,I)-A(I-1,I-1)).GE.SAFE*ERR)RETURN
12    CONTINUE
      RETURN
      END

C
C PURPOSE: CALCULATES 9J VALUE
C
C INPUTS:
C       RJ11,RJ12,RJ13  REAL J QUANTUM NUMBERS IN 1ST ROW OF 9J
C       RJ21,RJ22,RJ23  REAL J QUANTUM NUMBERS IN 2ND ROW OF 9J
C       RJ31,RJ32,RJ33  REAL J QUANTUM NUMBERS IN 3RD ROW OF 9J
C
C OUTPUTS:
C       FUN9J 9J SYMBOL
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	FUNCTION FUN9J(RJ11,RJ12,RJ13,RJ21,RJ22,RJ23,RJ31,RJ32,RJ33)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
	IJ11=NINT(RJ11+RJ11)
	IJ12=NINT(RJ12+RJ12)
C	IJ13=NINT(RJ13+RJ13)
	IJ21=NINT(RJ21+RJ21)
C	IJ22=NINT(RJ22+RJ22)
	IJ23=NINT(RJ23+RJ23)
C	IJ31=NINT(RJ31+RJ31)
	IJ32=NINT(RJ32+RJ32)
	IJ33=NINT(RJ33+RJ33)
	KMIN1=IABS(IJ11-IJ33)
	KMIN2=IABS(IJ32-IJ21)
	KMIN3=IABS(IJ23-IJ12)
	IF(KMIN2.GT.KMIN1) KMIN1=KMIN2
	IF(KMIN3.GT.KMIN1) KMIN1=KMIN3
	KMAX1=IJ11+IJ33
	KMAX2=IJ32+IJ21
	KMAX3=IJ23+IJ12
	IF(KMAX2.LT.KMAX1) KMAX1=KMAX2
	IF(KMAX3.LT.KMAX1) KMAX1=KMAX3
	FUN9J=ZERO
	IF(KMIN1.LE.KMAX1) THEN
	  DO K=KMIN1,KMAX1,2
	    FK5=0.5*FLOAT(K)
	    FUN9J=FUN9J+SG(K)*FLOAT(K+1)
     /	    *FUN6J(RJ11,RJ21,RJ31,RJ32,RJ33,FK5)
     /	    *FUN6J(RJ12,RJ22,RJ32,RJ21,FK5,RJ23)
     /	    *FUN6J(RJ13,RJ23,RJ33,FK5,RJ11,RJ12)
	  END DO
	END IF
	RETURN
	END

C
C PURPOSE: COMPUTES INELASTIC COLLISION RATES 
C          FROM THE 
C INPUTS:
C          IJ       INDEX OF UPPER LEVEL 
C          IJ1      INDEX OF LOWER LEVEL
C          K        MULTIPOLAR COEFFICIENT
C
C OUTPUTS:
C          CI       INELASTIC RATE FROM MULTIPOLAR COMPONENT K
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	FUNCTION CI(IJ,IJ1,K)
C  THIS FUNCTION CALCULATES THE INELASTIC COLLISIONAL RATES 
C  C_I(IJ,IJ1,K) (FOR IJ1 < IJ)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
C
	RJ=AJ(IJ)
	RJ1=AJ(IJ1)
	RK=FLOAT(K)
	JP=NINT(RJ+RJ1)
	JM=NINT(ABS(RJ-RJ1))
	CITMP=ZERO
	DO K1=JM,JP
	  RK1=FLOAT(K1)
     	  CITMP=SG(K1)*FUN6J(RJ,RJ,RK,RJ1,RJ1,RK1)*GAMMAI(IJ,IJ1,K1)
     /	  +CITMP
	END DO
	CI=SG(JP-K)*SQRT((TWO*RJ+ONE)*(TWO*RJ1+ONE))*CITMP
	RETURN
	END

C
C PURPOSE: COMPUTE RADIATIVE RATES R(3) FOR EQN (20) OF 
C          CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539
C          THE COMPLETE COEFFICIENT NEEDED FOR EQ. (20) IS 
C          BUILT BY SUMMING OUTSIDE OF THIS ROUTINE IN ROUTINE
C          SE0_BUILD
C
C INPUTS:
C       
C OUTPUTS:
C       R3COEFF
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE R3(KR,IJ,IJ1,K,K1,IQ,R3COEFF)
C  THIS SUBROUTINE CALCULATES THE RADIATIVE RATES R(3)  (IJ1<IJ)
C
C  THE RADIATION FIELD IS ASSUMED TO BE CYLINDRICALLY
C  SYMMETRIC IN THE REFERENCE FRAME IN WHICH THE S.E.
C  EQUATIONS ARE EXPRESSED.
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
	RJ=AJ(IJ)
	RJ1=AJ(IJ1)
	RK=FLOAT(K)
	RK1=FLOAT(K1)
	Q=FLOAT(IQ)
	R3TMP=ZERO
C Note - this next line from 6jul22 version-- should it be kept?
	DO K2=0,2,2 !PGJ TEST
	  RK2=FLOAT(K2)
	  R3TMP=SQRT(TWO*RK2+ONE)
     /	  *FUN3J(RK,RK1,RK2,Q,-Q,ZERO)
     /	  *FUN9J(ONE,RJ,RJ1,ONE,RJ,RJ1,RK2,RK,RK1)
     /        *RADJ(K2,KR)+R3TMP
	END DO
	R3COEFF=SG(K1-IQ)*SQRT(THREE*(TWO*RK+ONE)*(TWO*RK1+ONE))
     /	  *(TWO*RJ1+ONE)*ECOEFF(IJ1,IJ)*R3TMP
	RETURN
	END

C
C PURPOSE: WRITES ATOMIC PARAMETERS TO OUTPUT LISTING
C
C INPUTS: ICALL.  WRITE ONLY IF ICALL NEQ 0
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE WATOM(ICALL)
C
C  
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CSLINE'
      INCLUDE 'CCONST'
      INCLUDE 'CINPUT'
      INCLUDE 'CLU'
C
C
      KOUNT=0
      DO KR=1,NLINE
         IF ((ALAMB(KR) .GE. WLMIN).AND.(ALAMB(KR) .LE. WLMAX)) THEN
            KOUNT=KOUNT+1
         ENDIF
      ENDDO
C
      IF(IWATOM.EQ.0) RETURN
C
      WRITE(LOUT,50) ATOMID
   50 FORMAT('1 ATOMIC PARAMETERS  ',A//)
      WRITE(LOUT,100) ABND, 10.**(ABND-12.)
  100 FORMAT('  ABUNDANCE=',F7.4,1P,E11.4//7X,'E(CM-1)',
     * 4X,'G LABEL',26X,'ION S    L    J   P   LANDE G')
      WRITE(LOUT,200) (I,EV(I)/CC/HH*EE,INT(G(I)),LABEL(I),
     * ION(I),QNS(I),QNL(I),QNJ(I),IQNP(I),GLAND(I),I=1,NK)
  200 FORMAT(I2,1X,F12.3,1X,I3,1X,A,I3,1X,F4.1,
     * 1X,F4.1,1X,F4.1,1X,I1,1X,F6.2)
C
      QN=QNORM*1.E8/CC
      WRITE(LOUT,300)
  300 FORMAT(/'  RADIATIVE TRANSITIONS')
      WRITE(LOUT,400) (JRAD(KR),IRAD(KR),CONVL(ALAMB(KR)),F(KR),A(KR),
     * NQ(KR),QMAX(KR),Q0(KR),QN*ALAMB(KR),IWIDE(KR),KR=1,NLINE)
  400 FORMAT('  J  I  LAMBDA',8X,'F',10X,'A',6X,'NQ',6X,'QMAX',
     * 8X,'Q0',3X,'QNORM MA','  IWIDE'/
     * (1X,I2,I3,0P,F10.3,1P,2E11.3,I4,0P,2F10.2,F11.3,4X,L1))
      DO 550 KR=NLINE+1,NRAD
        WRITE(LOUT,500) JRAD(KR),IRAD(KR),CONVL(ALAMB(KR)),F(KR),
     *   NQ(KR),QMAX(KR),Q0(KR),QN*ALAMB(KR)
  500   FORMAT(/1X,I2,I3,0P,F10.3,1P,E11.3,11X,I4,0P,3F10.2)
        IF(Q0(KR).LT.0.0 .OR. QMAX(KR).LT.0.0) THEN
          WRITE(LOUT,540) (Q(NY,KR),ALFAC(NY,KR-NLINE),NY=1,NQ(KR))
  540     FORMAT(0P,F16.3,1P,E11.3)
        ENDIF
  550 CONTINUE
C
      IF(ICALL.EQ.1) THEN
        IF(NRFIX.GT.0) THEN
          WRITE(LOUT,600)
  600     FORMAT(/'  FIXED TRANSITIONS'/'  J  I  LAMBDA',7X,'A0',8X,
     *    'TRAD',5X,'ITRAD')
        ELSE
          WRITE(LOUT,610)
  610     FORMAT(/'  NO FIXED TRANSITIONS')
        ENDIF
C
        DO 800 KF=1,NRFIX
          CLAM=HCE/(EV(JFX(KF))-EV(IFX(KF)))
          IF(IPHO(KF).EQ.0) THEN
            WRITE(LOUT,700) JFX(KF),IFX(KF),CLAM,A0(KF),
     *                      TRAD(KF),ITRAD(KF)
  700       FORMAT(2I3,F10.3,1P,E11.3,0P,F11.3,I5,'   BOUND-BOUND')
          ELSE
            WRITE(LOUT,710) JFX(KF),IFX(KF),CLAM,A0(KF),
     *                      TRAD(KF),ITRAD(KF)
  710       FORMAT(2I3,F10.3,1P,E11.3,0P,F11.3,I5,'   PHOTOIONIZATION')
          ENDIF
  800   CONTINUE
      ENDIF
C
C TRANSITION TYPES
C
      WRITE(LOUT,*)''
      WRITE(LOUT,720)'TRANSITION TYPES'
      WRITE(LOUT,720)
     * 'E1=1, E2=2, M1=-1, E1(SPIN-F)=3, SPIN-F:-3 OTHER=0'
      WRITE(LOUT,720)'USED FOR EVALUATING COLLISION TYPES:'
      WRITE(LOUT,720)'WHEN .LE. 0, ASSUME STRONG COUPLING'
 720  FORMAT(A)
 711  FORMAT(1X,I4,'-',I4,1X,'(',A25,1X,'-',A25,')',4X,I5)
      DO 703 I=2,NK
        DO 704 J=1,I-1
           WRITE(LOUT,711)I,J, LABEL(I),LABEL(J),ITTYPE(I,J)
 704       CONTINUE
 703       CONTINUE
C
      WRITE(LOUT,900)
  900 FORMAT(////1X)
      RETURN
      END
C
C****************************************************************
C

C
C PURPOSE: READS AN ATOMIC MODEL 
C
C INPUTS: NONE
C
C OUTPUTS: SETS VARIABLES IN CATOM
C
C COMMON:
C        CATOM CSLINE CLU CATMOS
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C MODIFICATIONS:
C     JANUARY 11, 2006. CHECK ON MJMAX GE MAX(J) (PGJ)
C 
      SUBROUTINE ATOM
C
C  READS AN ATOMIC MODEL AND CALCULATES EINSTEIN A,B COEFFICIENTS.
C
C  A      : EINSTEIN A COEFFICIENT
C  B      :          B
C
C  NK     : NUMBER OF LEVELS, CONTINUUM LEVELS INCLUDED
C  NRAD   : NUMBER OF RADIATIVE TRANSITIONS
C  NLINE  : NUMBER OF BOUND-BOUND TRANSITIONS
C  NCONT  : NUMBER OF BOUND-FREE TRANSITIONS I DETAIL
C  IWIDE  : =.TRUE. FOR FREQUENCY DEPENDENT TRANSITIONS
C           (CONTINUA AND WIDE LINES)
C  KTRANS(K) TRANSITION NUMBER K IS FREQUENCY DEPENDENT
C            TRANSITION NUMBER KTRANS
C  (NOTE - NRFIX Comment not in Phil's latest 6jul22 distribution)
C  NRFIX  : NUMBER OF TRANSITIONS WITH FIXED RATES
C           FOR FIXED RATES VARIABLES SEE  ROUTINE  FIXRAD
C  IRAD(K): LOWER LEVEL FOR RADIATIVE TRANSITION K
C  JRAD(K): UPPER             ''
C  ALAMB  : VACUUM WAVELENGTH IN ANGSTROM
C           IN PRINTOUT ROUTINES IT IS PRINTED AS EITHER VACUUM OR AIR
C           DEPENDING ON THE VALUE (.LT.2000 VACUUM, .GT.2000 AIR)
C  HNY4P  : H*NY/4PI, NY IN UNITS OF A TYPICAL DOPPLER WIDTH
C  G      : STATISTICAL WEIGHT
C  F      : FOR LINES   : OSCILLATOR STRENGTH
C           FOR CONTINUA: CROSS-SECTION AT LIMIT
C           THE WAVELENGTH DEPENDENCE OF THE CROSS-SECTION IS
C           ASSUMED TO BE A=A0*(NY0/NY)**3 IF NOT GIVEN EXPLICITLY
C  EV     : ENERGY IN EV  INPUT IN CM-1
C
C  IND IS SET TO 2 FOR WIDE LINES AND 1 FOR CONTINUA
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CSLINE'
      INCLUDE 'CCONST'
      INCLUDE 'CINTS'
      INCLUDE 'CLU'
C
      CHARACTER TEXT*80
      LOGICAL SALLOW,PALLOW
C
C
C  CALL FROM START. CALCULATE CONSTANTS AND READ FILE  ATOM
C
      HCE=HH*CC/EE*1.E8
      HC2=2.*HH*CC *1.E24
      HCK=HH*CC/BK*1.E8
      EK=EE/BK
      HNY4P=HH*CC/QNORM/FOUR/PI*1.E-5
      CALL CSTRIP(LATOM,'ATOM')
C
C  READ INPUT VALUES AND LEFT JUSTIFY ATOMID
C
      READ(LDUMS,40) ATOMID
   40 FORMAT(A)
      CALL LJUST(ATOMID)
C
      READ(LDUMS,*) ABND,AWGT
      AWGT=AWGT*UU
      READ(LDUMS,*) NK,NLINE,NCONT,NRFIX
      NRAD=NLINE+NCONT
      IF(NK.GT.MK)       CALL STOP('ATOM: NK.GT.MK')
      IF(NRAD.GT.MRAD)   CALL STOP('ATOM: NRAD.GT.MRAD')
      IF(NLINE.GT.MLINE) CALL STOP('ATOM: NLINE.GT.MLINE')
      IF(NRFIX.GT.MRFIX) CALL STOP('ATOM: NRFIX.GT.MRFIX')
C
C  WHILE READING, CHECK THAT JUST ONE ION IS PRESENT
C
      JMX=0
      DO 120 I=1,NK
        READ(LDUMS,*) EV(I),G(I),LABEL(I),ION(I),
     *   QNS(I),QNL(I),QNJ(I),IQNP(I),GLAND(I)
        IF(QNJ(I) .GT. MJMAX) CALL STOP(' ATOM: MJMAX IS TOO SMALL')
        IIJ=INT((G(I)-ONE)/TWO)
        IF(JMX .LT. IIJ) JMX=IIJ
        EV(I)=EV(I)*CC *HH/EE
        IF(ION(I) .NE. ION(1)) 
     *       CALL STOP(' ATOM: MUST CONTAIN JUST ONE ION STAGE')
        CALL LJUST(LABEL(I))
C
C DEFINE MK X MK ARRAYS
C
        DO 110 J=1,NK
          KRAD(I,J)=0
          B(I,J)=0.
C (Note this changed in Phils 6jul22 dist- before was set to 0
          ITTYPE(I,J)=4
C
C  USE QUANTUM NUMBERS TO IDENTIFY THE TYPE OF TRANSITION
C  TRTYPE(I,J)=+1 : E1
C  TRTYPE(I,J)=+2 : E2
C  TRTYPE(I,J)=-1 : M1
C  TRTYPE(I,J)=+3 : E1 ALLOWED   / SPIN CHANGING
C  TRTYPE(I,J)=-3 : E1 FORBIDDEN / SPIN CHANGING
C  (note this next line was set to 0 pre 6jul22)
C  TRTYPE(I,J)= 4 : OTHERWISE
C
C  SPIN ALLOWED?
          SALLOW=QNS(I).EQ.QNS(J)
C PARITY CHANGE?
          PALLOW=(IQNP(I).NE.IQNP(J))
C  E1:
          ISUMM=NINT(QNJ(I)+QNJ(J))
          IDIFF=NINT(ABS(QNJ(I)-QNJ(J)))
          IF(SALLOW .AND. PALLOW .AND. ISUMM.NE.0 .AND. IDIFF.LE.1) 
     *       ITTYPE(I,J)=1
C  E2:
          IF(SALLOW.AND.(.NOT. PALLOW).AND.ISUMM.GE.2 
     *       .AND.IDIFF.LE.2) ITTYPE(I,J)=2
C  M1:
          IF(SALLOW .AND. (.NOT. PALLOW) .AND. ISUMM.NE.0 
     *       .AND. IDIFF.LE.1) ITTYPE(I,J)=-1
C  E1 BUT SPIN CHANGING
          IF((.NOT. SALLOW) .AND. PALLOW .AND. ISUMM.NE.0 
     *        .AND. IDIFF.LE.1) ITTYPE(I,J)=3
C  E1-FORBIDDEN BUT SPIN CHANGING
          IF((.NOT. SALLOW) .AND. (.NOT. PALLOW) .AND. ISUMM.NE.0 
     *        .AND. IDIFF.LE.2) ITTYPE(I,J)=-3
          ITTYPE(J,I)=ITTYPE(I,J)
  110   CONTINUE
  120 CONTINUE
      IF(JMX.GT.MJMAX)       CALL STOP('ATOM: MAX(J).GT.MJMAX')
C
C  BOUND-BOUND TRANSITIONS IN DETAIL
C  CALCULATE LAMBDA, A AND B
C  IF QMAX OR Q0.LT.0 FREQUENCY POINTS IN DOPPLER UNITS ARE READ
C
      KT=0
      DO 200 KR=1,NLINE
        READ(LDUMS,*) J,I,F(KR),NQ(KR),QMAX(KR),Q0(KR),IO,
     *   GA(KR),GW(KR),GQ(KR)
c Note this was introduced with 6jul22
        IF(NQ(KR).LT.3) CALL STOP('ATOM: NQ.LT.3 NEED MORE FREQUENCIES')
        IF(NQ(KR).GT.MQ) CALL STOP('ATOM: NQ.GT.MQ')
C note this next line was LT not LE pre 6jul22
        IF(QMAX(KR).LE.0.0 .OR. Q0(KR).LT.0.0) THEN
          READ(LDUMS,*) (Q(NY,KR),NY=1,NQ(KR))
          IF(ABS(Q(2,KR)).LT.ABS(Q(1,KR)) .AND.
     *       ABS(Q(NQ(KR),KR)).GT.ABS(Q(NQ(KR)-1,KR))) IND(KR)=2
          DO 150 NY=2,NQ(KR)
            IF(Q(NY,KR).LT.Q(NY-1,KR)) THEN
              CALL STOP('ATOM: Q NOT MONOTONICALLY INCREASING')
            ENDIF
  150     CONTINUE
        ENDIF
C
C SET IWIDE = 1 FOR ALL LINES (I.E. DO FULL PROFILES)
C 
C        IWIDE(KR)=IO.EQ.1
        IWIDE(KR)=.TRUE.
        IF(IWIDE(KR)) THEN
          KT=KT+1
          KTRANS(KR)=KT
          IND(KR)=2
        ENDIF
        KRAD(I,J)=KR
        KRAD(J,I)=KR
        IRAD(KR)=I
        JRAD(KR)=J
        ALAMB(KR)=HCE/(EV(J)-EV(I))
        A(KR)=F(KR)*6.671E15*G(I)/G(J)/ALAMB(KR)/ALAMB(KR)
        B(J,I)=ALAMB(KR)**3/HC2*A(KR)
        B(I,J)=G(J)/G(I)*B(J,I)
  200 CONTINUE
      IF(KT+NRAD-NLINE.GT.MWIDE) CALL STOP('ATOM: NWIDE.GT.MWIDE')
C
C  BOUND-FREE TRANSITIONS IN DETAIL
C  IF QMAX.LT.0.0 FREQUENCY POINTS IN ANGSTROM (STARTING WITH
C  THRESHOLD AND DECREASING) AND CROSSECTIONS IN CM2 ARE READ.
C  UNIT CONVERSION IN  ROUTINE  FREQC
C
      DO 250 KR=NLINE+1,NRAD
         READ(LDUMS,*) J,I,F(KR),NQ(KR),QMAX(KR)
         IF(NQ(KR).GT.MQ) CALL STOP('ATOM: NQ.GT.MQ')
         IF(QMAX(KR).LT.0.0) THEN
            READ(LDUMS,*) (Q(NY,KR),ALFAC(NY,KR-NLINE),NY=1,NQ(KR))
            DO 230 NY=2,NQ(KR)
               IF(Q(NY,KR).GT.Q(NY-1,KR)) THEN
                  WRITE(LJOBLO,220) KR-NLINE
 220              FORMAT(' ATOM: CONTINUUM TRANSITION NR',I3/
     *                 '  WAVELENGTHS NOT DECREASING')
                  CALL STOP(' ')
               ENDIF
 230        CONTINUE
         ENDIF
         KTRANS(KR)=KR-NLINE+KT
         IRAD(KR)=I
         JRAD(KR)=J
         KRAD(I,J)=KR
         KRAD(J,I)=KR
         GA(KR)=0.
         GW(KR)=0.
         GQ(KR)=0.
         IWIDE(KR)=.TRUE.
         IND(KR)=1
         ALAMB(KR)=HCE/(EV(J)-EV(I))
 250  CONTINUE
C     
C     READ CHOICE OF COLLISIONAL SUBROUTINE
C     
      READ(LDUMS,40) TEXT
      CALL LJUST(TEXT)
      CROUT=TEXT(1:6)
C     
      RETURN
      END
C
C***********************************************************************
C

C
C PURPOSE: WRITES ATMOSPHERIC PARAMETERS TO OUTPUT LISTING
C
C INPUTS: IX, IY, IZ: INDICES OF POINTS IN X Y Z GRID
C         IGNORE- SKIP THIS POINT UNLESS IWATMO=2
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE WATMOS(IX,IY,IZ,IGNORE)
C
C  
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CINPUT'
      INCLUDE 'CGRID'
      INCLUDE 'CATMOS'
      INCLUDE 'CATMO2'
      INCLUDE 'CATOM'
      INCLUDE 'CLU'
      COMMON /WATM/BX,BY,BZ
      LOGICAL IGNORE, PRI
C
      PRI=.FALSE.
      IF (IWATMO .EQ. 2) THEN 
         PRI=.TRUE.
      ELSE IF(IWATMO .EQ. 1) THEN
         IF (.NOT. IGNORE) PRI=.TRUE.
      ENDIF
      IF(PRI) THEN 
        WRITE(LATMOS) IX,IY,IZ
        WRITE(LATMOS) BX,BY,BZ,ED,TEMP,VEL*QNORM,VTURB*QNORM
      ENDIF
      RETURN
      END
C
C****************************************************************
C

C
C PURPOSE: MAIN PROGRAM TO COMPUTE EMISSION COEFFS OF M1 CORONAL LINES
C          INTEGRATED ALONG THE LOS, FOR A SET OF LOS'S IN AN 
C          ASSIGNED GRID OF CARTESIAN COORDINATES.
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: AUGUST 9, 2000 P. JUDGE
C 
      PROGRAM CLE
C
C  MAIN PROGRAM
C
C  CALCULATES THE EMISSION COEFFICIENTS OF FORBIDDEN CORONAL
C  LINES, INTEGRATED ALONG THE LOS, FOR A SET OF LOS'S IN AN 
C  ASSIGNED GRID OF CARTESIAN COORDINATES.
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CGRID'
      INCLUDE 'CCONST'
      INCLUDE 'CBCNST'
      CALL CPTIME('TOTAL ',0,0,5)
C
      CALL START
C
C  LOOP ON THE LOS DISTRIBUTION
C
      GYSTEP=0.
      IF(NGY .NE. 1) GYSTEP=(GYMAX-GYMIN)/FLOAT(NGY-1)
      GZSTEP=(GZMAX-GZMIN)/FLOAT(NGZ-1)
      DO J=1,NGY
         WRITE(*,*)'DOING COLUMN Y=',J,'/',NGY,'...'
         CALL CPTIME('CLECOL',0,0,4)
         GY=FLOAT(J-1)*GYSTEP+GYMIN
         DO K=1,NGZ
            GZ=FLOAT(K-1)*GZSTEP+GZMIN
            CALL M1SYNTH(J,K)
            CALL OUTS(J,K)
         END DO
         CALL CPTIME('CLECOL',0,1,4)
      END DO
      CALL CPTIME('TOTAL ',0,1,5)
      CALL STOP('NORMAL END')
      END
      

C
C PURPOSE: CALCULATES LIMB DARKENING COEFFICIENTS
C
C INPUTS:
C       WL WAVELENGTH IN MICRONS
C OUTPUTS:
C       U,V COEFFICIENTS U2 AND V2 OF ALLEN (1973, P171)
C COMMON:
C
C RESTRICTIONS:
C       OUTSIDE OF WAVELENGTH RANGE EXTREME VALUES ARE USED.
C COMMENTS: JANUARY 11, 2006 P. JUDGE
C 
	SUBROUTINE UV(WL,U0,V0)
C
C  THIS FUNCTION CALCULATES ALLEN U AND V COEFFICIENTS FOR
C  LIMB DARKENING, SEE ALLEN (AQ 1973, SECTION 81)
C	
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      DIMENSION REFLAM(22),U(22),V(22)
C
      DATA REFLAM/.2,.22,.245,.265,.28,.30,.32,.35,.37,.38,
     /     .40,.45,.5,.55,.6,.8,1.,1.5,2.,3.,5.,10./
      DATA U/.12,-1.3,-.1,-.1,.38,.74,.88,.98,1.03,.92,
     /     .91,.99,.97,.93,.88,.73,.64,.57,.48,.35,.22,.15/
      DATA V/.33,1.6,.85,.9,.57,.2,.03,-.1,-.16,-.05,
     /     -.05,-.17,-.22,-.23,-.23,-.22,-.2,-.21,-.18,-.12,
     /     -.07,-.07/
C     
      IF (WL.LT.REFLAM(1)) THEN
         U0=U(1)
         V0=V(1)
         RETURN
      END IF
C     
      IF (WL.GT.REFLAM(22)) THEN
         U0=U(22)
         V0=V(22)
         RETURN
      END IF
      I=0
 1    I=I+1
      I1=I+1
      IF ((WL.GE.REFLAM(I)).AND.(WL.LT.REFLAM(I1))) THEN
         DL=(WL-REFLAM(I))/(REFLAM(I1)-REFLAM(I))
         U0=U(I)+(U(I1)-U(I))*DL
         V0=V(I)+(V(I1)-V(I))*DL
      ELSE
         GOTO 1
      END IF
      RETURN
      END

C
C PURPOSE: STRIP COMMENT LINES (LINES WITH * IN POSITION 1) FROM INPUT FILE
C
C INPUTS:
C     IUNIT   LOGICAL UNIT NUMBER OF INPUT FILE
C     FILE    FILENAME
C OUTPUTS:
C
C COMMON:
C     CLU
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C  THE FILE IS OPENED AND THE NON-COMMENT LINES ARE
C  WRITTEN TO UNIT LDUMS
C 
      SUBROUTINE CSTRIP(IUNIT,FILE)
      INCLUDE 'PREC'
      INCLUDE 'CLU'
C
      CHARACTER*132 TEXT
      CHARACTER*(*) FILE
      DATA ISTAT /1/
C
      CALL OPEN(IUNIT,FILE,ISTAT,'OLD')
      CALL REWIND(LDUMS)
  100 CONTINUE
        READ(IUNIT,200,END=900) TEXT
        IF(TEXT(1:1).NE.'*') WRITE(LDUMS,200) TEXT
  200   FORMAT(A)
      GOTO 100
C
  900 CONTINUE
      CALL REWIND(LDUMS)
      CALL CLOSE(IUNIT)
      RETURN
      END
C
C**********************************************************************
C

C
C PURPOSE: COMPUTE RADIATIVE RATES R(6) FOR EQN (20) OF 
C          CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539
C          THE COMPLETE COEFFICIENT NEEDED FOR EQ. (20) IS 
C          BUILT BY SUMMING OUTSIDE OF THIS ROUTINE IN ROUTINE
C          SE0_BUILD
C
C INPUTS:
C       
C OUTPUTS:
C       R6COEFF
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE R6(NJ,IJ,K,K1,IQ,R6COEFF)
C  THIS SUBROUTINE CALCULATES THE RADIATIVE RATES R(6)
C
C  THE RADIATION FIELD IS ASSUMED TO BE CYLINDRICALLY
C  SYMMETRIC IN THE REFERENCE FRAME IN WHICH THE S.E.
C  EQUATIONS ARE EXPRESSED.
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'CATOM'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
	RJ=AJ(IJ)
	RK=FLOAT(K)
	RK1=FLOAT(K1)
	Q=FLOAT(IQ)
	R6TMP=ZERO
C Note - this next line from 6jul22 version-- should it be kept?
	DO K2=0,2,2 !PGJ TEST
	  IF(SG(K+K1+K2).GT.ZERO) THEN		! \ZETA+ = 1
	    RK2=FLOAT(K2)
	    R6TMP1=ZERO
	    DO IJ1=IJ+1,NJ
		KR=KRAD(IJ,IJ1)
		IF(KR.NE.0) THEN
	        RJ1=AJ(IJ1)
	        R6TMP1=SG(NINT(RJ-RJ1))*ECOEFF(IJ,IJ1)
     /	         *FUN6J(ONE,ONE,RK2,RJ,RJ,RJ1)
     /               *RADJ(K2,KR)+R6TMP1
		END IF
	    END DO
	    R6TMP=SQRT(TWO*RK2+ONE)
     /	    *FUN3J(RK,RK1,RK2,Q,-Q,ZERO)
     /	    *FUN6J(RK,RK1,RK2,RJ,RJ,RJ)*R6TMP1+R6TMP
	  END IF
	END DO
	R6COEFF=SG(K+K1-IQ+1)
     /	  * SQRT(THREE*(TWO*RK+ONE)*(TWO*RK1+ONE))
     /	  * (TWO*RJ+ONE)*R6TMP
	RETURN
	END

      INTEGER FUNCTION IATOMN(STRING)
C
C  ATOMN 94-02-22  NEW ROUTINE: (PHILIP JUDGE)
C  GIVES ATOMIC NUMBER OF ARELEMENT IF STRING IS A STRING CONTAINING
C  THE NAME OF THE ARELEMENT, E.G. IF INPUT  IS 'H ' IT WILL RETURN 1
C        
      PARAMETER (NDATA=28)
      CHARACTER*2 ARELEM(NDATA)
      CHARACTER *(*) STRING
      DATA ARELEM /'H ','HE','LI','BE','B ','C ','N ','O ','F ','NE',
     * 'NA','MG','AL','SI','P ','S ','CL','AR',
     * 'K ','CA','SC','TI','V ','CR','MN','FE','CO','NI'/
      IATOMN=-1
      DO 1 I=1,NDATA
        IF(STRING .EQ. ARELEM(I)) THEN
          IATOMN=I
          RETURN
        ENDIF
    1 CONTINUE
      END

C
C PURPOSE: GIVES QUADRATURE POINTS AND WEIGHTS FOR CONTINUA
C
C INPUTS:
C     KR  TRANSITION INDEX
C OUTPUTS:
C
C COMMON:
C     CATOM CSLINE CCONST
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE FREQC(KR)
C
C  GIVES QUADRATURE POINTS AND WEIGHTS FOR CONTINUA
C  THE POINTS ARE EQUIDISTANT IN FREQUENCY, THE WEIGHTS ARE
C  TRAPEZOIDAL
C  CALCULATES CROSSECTIONS FROM NY**-3 DEPENDENCE IF NOT GIVEN
C  EXPLICITLY
C
C  QMAX .LT. 0 : Q AND ALFAC GIVEN (FROM ATOM INPUT). ONLY
C  WEIGHTS CALCULATED AND Q TRANSFORMED FROM ANGSTROM TO DOPPLER
C  UNITS.
C
C  NQ      TOTAL NUMBER OF QUADRATURE POINTS       (IN)
C  QMAX    MINIMUM VALUE OF WAVELENGTH (ANGSTROM)  (IN)
C  FRQ     QUADRATURE POINTS (S-1)                 (OUT)
C  Q       QUADRATURE POINTS (DOPPLER UNITS)       (OUT)
C  WQ      QUADRATURE WEIGHTS                      (OUT)
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CSLINE'
      INCLUDE 'CCONST'
C
      KT=KTRANS(KR)
      FRQ(0,KT)=CC/ALAMB(KR)*1.E8
      IF(QMAX(KR).GE.0.0) THEN
        FRQ(NQ(KR),KT)=CC/QMAX(KR)*1.E8
        DFRQ=(FRQ(NQ(KR),KT)-FRQ(0,KT))/(NQ(KR)-1)
        DO 100 NY=1,NQ(KR)
          FRQ(NY,KT)=FRQ(0,KT)+(NY-1)*DFRQ
          Q(NY,KR)=CC*1.E-5/QNORM*(FRQ(NY,KT)/FRQ(0,KT)-1.0)
          ALFAC(NY,KR-NLINE)=F(KR)*(FRQ(0,KT)/FRQ(NY,KT))**3
  100   CONTINUE
      ELSE
        DO 200 NY=1,NQ(KR)
          FRQ(NY,KT)=CC/Q(NY,KR)*1.0E8
          Q(NY,KR)=CC*1.0E-5/QNORM*(FRQ(NY,KT)/FRQ(0,KT)-1.0)
  200   CONTINUE
      ENDIF
C
      WQ(1,KR)=0.5*(Q(2,KR)-Q(1,KR))
      DO 300 NY=2,NQ(KR)-1
        WQ(NY,KR)=0.5*(Q(NY+1,KR)-Q(NY-1,KR))
  300 CONTINUE
      WQ(NQ(KR),KR)=0.5*(Q(NQ(KR),KR)-Q(NQ(KR)-1,KR))
C
      RETURN
      END
C
C******************************************************************
C

C
C PURPOSE: CALCULATES A MAGNETIC FIELD ACCORDING TO FONG, FAN AND LOW
C
C INPUTS:
C       RAD    RADIUS OF POINT RELATIVE TO SUN CENTER, UNITS OF SOLAR RADII
C       THET   AZIMUTHAL ANGLE, UNITS RADIANS, IN S FRAME
C       PH     POLAR ANGLE, UNITS RADIANS, IN S FRAME
C       IPRINT SET TO 1 FOR MORE VERBOSE OUTPUT
C OUTPUTS:
C       B      MAGNITUDE OF FIELD
C       T      POLAR ANGLE
C       P      AZIMUTHAL ANGLE
C       EDENS  ELECTRON DENSITY /CM3
C       HDENS  HYDROGEN NUCLEI DENSITY /CM3 
C       TEMP   ELECTRON TEMPERATURE K
C       VEL    FLOW VELOCITY ALONG LINE OF SIGHT (+VE MEANS TOWARDS OBSERVER)
C       TURBV  MICROTURBULENCE KM/S (CONTRIBUTES TO LINE PROFILE WIDTHS)
C
C COMMON:
C
C COMMENTS: AUGUST 24, 2000, P. JUDGE
C
C NOTES:    USER-SUPPLIED ROUTINE
C 
	SUBROUTINE FFL(RAD,THET,PH,BMAG,T,P,EDENS,HDENS,
     *    TEMP,VEL,TURBV,IPRINT)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	PARAMETER(MAXD=10,MAXLEG=200)
        INCLUDE 'CCONST'
	INCLUDE 'CGRID'
	INCLUDE 'CINPUT'
	INCLUDE 'CLU'
	INCLUDE 'CINTS'
	COMMON /CFFL/ ACONST,B0,B1, ALPHAX, ALPHAY,P0,T0,ALEG(0:MAXLEG),NLEG
	COMMON /WATM/BX,BY,BZ
        DIMENSION PM(0:MAXLEG,0:MAXLEG),PD(0:MAXLEG,0:MAXLEG)
        DIMENSION PM2(0:MAXLEG,0:MAXLEG),PD2(0:MAXLEG,0:MAXLEG)
	DATA KCALL /0/
	DATA EPSILON, ZER, SMALL /1.E-3,0.,1.E-20/
	SAVE KCALL
C
	IF (KCALL .EQ. 0) THEN 
	   CALL CSTRIP(LDIP,'FFL.DAT')
           READ(LDUMS,*) ACONST
	   READ(LDUMS,*) B0
	   READ(LDUMS,*) B1
	   READ(LDUMS,*) ALPHAY, ALPHAX
	   READ(LDUMS,*) P0
	   READ(LDUMS,*) T0
	   READ(LDUMS,*) NLEG
	   IF(NLEG .GT. MAXLEG) CALL STOP('NLEG > MAXLEG')
	   READ(LDUMS,*)(ALEG(J),J=0,NLEG)
	   WRITE(LOUT,4001) ACONST,B0,B1,ALPHAY,ALPHAX,P0,T0,NLEG
 4001	   FORMAT('1 CORONAL ROUTINE IS FFL'/
     *     'A= ',F11.6,' B0= ',F10.4,' B1= ',F10.4,' ALPHAY= ',F10.4,
     *     ' ALPHAX= ',F10.4/'P0= ',F10.4,' T0=',1P,E10.3,0P/
     *     'NLEG= ',I4/'ALEG:')
	   WRITE(LOUT,4002)(ALEG(J),J=0,NLEG)
 4002	   FORMAT(1P,8(E9.2,1X),0P)
	   CALL CLOSE(LDUMS)
	   KCALL=KCALL+1
	ENDIF
C
C  CALCULATE CARTESIAN COORDINATES OF THE POINT RAD,THET,PH
C  X IS LOS
C
	X=RAD*SIN(THET)*COS(PH)
	Y=RAD*SIN(THET)*SIN(PH)
	Z=RAD*COS(THET)
        R=RAD
C
C ROTATE TO (R,THETA) PLANE IN WHICH FFL SOLUTION IS GIVEN IN TERMS
C OF STREAM FUNCTION. 
C	
C ROTATION ABOUT Y AXIS, AND THEN X-AXIS
C
	X1=X
	Y1=Y
	Z1=Z
	CALL ROT(X1,Z1,ALPHAY)
	CALL ROT(Y1,Z1,ALPHAX)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C ROTATED FRAME:
C  CALCULATE THE (R,THETA) COMPONENTS OF THE MAGNETIC FIELD IN THE ROTATED 
C  REFERENCE FRAME. 
C    - THIS IS THE FORMALISM HANDED TO PGJ BY B.C. LOW NOVEMBER 14, 2002
C
	COSTH=Z1/R
	sign=1.
	if(z1 .lt. 0.) sign=-1.
	SINTH=SQRT(1.-COSTH*COSTH)
	TH=ATAN2(SINTH,COSTH)
	TANTH=SINTH/COSTH
C
	FF = (1.-R*R/ACONST/ACONST)
	GG = SQRT(FF*FF + 4.*R*R/ACONST/ACONST*COSTH*COSTH)
	XI =  SQRT(0.5*(-FF + GG))
	ETA = SQRT(0.5*( FF + GG))*SIGN
C	AT=ATAN(1./XI)
	AT=PI/2.0 - ATAN(XI) 
	BR0=B1*4./(ACONST*R*(XI*XI+ETA*ETA+EPSILON))
	BR1=-3.*XI*(5.*XI*XI+3.)*AT + 15.*XI*XI +4. 
	BR2=-3.*(1.+XI*XI)*(1.+5.*XI*XI)*AT + 15.*XI*XI*XI + 13.*XI
	BR= 2.*B0*COSTH/R/R/R - BR0*ETA*((1.-ETA*ETA)*(5.*ETA*ETA-1)*BR1 
     *      + XI*(3.-5.*ETA*ETA)*BR2)
        BTH= B0*SINTH/R/R/R - BR0*SQRT((1.-ETA*ETA)/SQRT(1.+XI*XI))
     *       * (XI*SQRT(1.+XI*XI)*(5.*ETA*ETA-1.)*BR1
     *       - ETA*ETA*(3.-5.*ETA*ETA)*BR2)
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  ADD IN LEGENDRE EXPANSION OF IMAGE POTENTIAL
C
	IONE=1
	CALL PNL(MAXLEG,IONE,NLEG,COSTH,PM,PD)
	SUMR=ZERO
	SUMTH=ZERO
	RVAR=ONE/R/R
	DO 101 N=1,NLEG
           RVAR=RVAR/R
	   DELR=ALEG(N)*RVAR*(PM(1,N)/TANTH-PD(1,N)*SINTH)
	   DELTH=ALEG(N)*N*RVAR*PM(1,N)*SINTH
	   SUMR=SUMR+DELR
	   SUMTH=SUMTH+DELTH
 101	CONTINUE
C	IF((0.99 .LT. R) .AND. (1.01 .GT. R)) THEN 
C     	   WRITE(LOUT,2007) BR, SUMR,DELR/SUMR
C 2007	   FORMAT('BR SUMR DELR/SUMR'/3(F11.5,1X))
C	ENDIF
	BR=BR+SUMR
 	BTH=BTH+SUMTH
C
C END OF LEGENDRE EXPANSION
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C 
C CARTESIAN COMPONENTS IN THIS ROTATED REFERENCE FRAME
C
	BMAG=SQRT(BR*BR+BTH*BTH)
	V=SQRT(X1*X1+Y1*Y1)
	COSPH=X1/V
	SINPH=Y1/V
        BZ=  BR*COSTH - BTH*SINTH
	BX= (BR*SINTH + BTH*COSTH)*COSPH
	BY= (BR*SINTH + BTH*COSTH)*SINPH
C
C DENSITY RESTRICTION AROUND CURRENT SHEET, NARROWING WITH R
C NOT IN PRESSURE EQUILIBRIUM 
C BEGIN
C	THICK=0.1/R/R
C	TH1=ACOS(COSTH)
C       DELTA=(PI/2.-TH1)/THICK
C END
C ROTATED FRAME END
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C TRANSFORM BACK, ROTATE ABOUT X AND Y AXES
C
	BX1=BX
	BY1=BY
	BZ1=BZ
	CALL ROT(BY1,BZ1,-ALPHAX)
	CALL ROT(BX1,BZ1,-ALPHAY)
C  RE-ASSIGN
	BX=BX1
	BY=BY1
	BZ=BZ1
C
C  RETURN VALUES OF B,T,P
C
	BMAG=SQRT(BX*BX+BY*BY+BZ*BZ)
	T=ACOS(BZ/BMAG)
	P=ATAN2(BY,BX)
C
C THERMAL PARAMETERS
C
C
C  ELECTRON DENSITY AND TEMPERATURE.
C
	VEL=0.
	TURBV=15.
C	DELTA=0.
C	GFAC=EXP(-DELTA*DELTA)
	GRAV=2.7398E4
	TEMP=T0
C	EDENS=P0/BK/T0/1.88*GFAC
	EDENS=P0/BK/T0/1.88
	RHO=1.3625*0.8*UU
	PTOT=BK*TEMP*1.88 + 0.5* RHO*(TURBV*TURBV)*1.E10
	HSCALE = PTOT/RHO/GRAV
	HSCALE=HSCALE/RSUNCM
	FFAC= MAX((R-1.),ZER)
	FFAC=EXP(-FFAC/HSCALE)
	EDENS=EDENS*FFAC
	HDENS=0.8*EDENS
	RETURN
	END
C
C**********************************************************************
C

C
C PURPOSE: COMPUTE ELASTIC MULTIPOLAR COLLISIONAL RATE
C
C INPUTS:
C       IJ   LEVEL INDEX
C       K    MULTIPOLAR COMPONENT
C OUTPUTS:
C
C COMMON:
C
C RESTRICTIONS:  
C
C UPDATED:  18 JAN 2014 RC/PGJ. REMOVED THE INCORRECT CECOFF CODE.
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
C EDITED: JUNE 6 2019 P. JUDGE
C INTEGER DO-LOOP VARIABLES
C FIXED ERRONEOUS DENOMINATOR IN GAMMAS
C ---Sept 2022 replaced pre 6jul22 version
C	
	FUNCTION GAMMAE(IJ,K)
C
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'CLU'
	INCLUDE 'CATMOS'
	INCLUDE 'CATOM'
	INCLUDE 'CINPUT'
	INCLUDE 'CINTS'
C
	GAMMAE=ZERO
	IF(ICOLL .EQ. 0 .OR. ICOLLMM .EQ. 0) RETURN
C
C EQ BEFORE (A4.10B) OF LANDI'S BOOK:
C
	AA=AJ(IJ) 
	NJ=INT(AA)
	FK=FLOAT(K)
        DO N=-NJ,NJ
	   DO NP=-NJ,NJ
	      DO M=0,K,2
		 P=FLOAT(M)
		 F3=FUN3J(AA,AA,FK,-AN,ANP,P)
		 GAMMAE=GAMMAE + CMM(IJ,IJ,N,NP)*F3*F3
     *            *(TWO*FK+ONE)/(TWO*AA+ONE)
	     ENDDO
	  ENDDO
	ENDDO
	RETURN
	END

C
C PURPOSE: GET CORONAL THERMAL AND MAGNETIC DATA FOR EACH GRID POINT
C
C INPUTS: NONE
C
C OUTPUTS:
C
C COMMON:
C     CATOM,CGRID,CATMOS,CATMO2,CCONST,CORON
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C
C  FOUR DIFFERENT REFERENCE FRAMES ARE NEEDED (SEE NOTES):
C
C	1. FRAME WITH Z-AXIS AS THE LOCAL VERTICAL AT THE OBSERVED 
C	   POINT (S)
C
C	2. FRAME WITH Z-AXIS AS THE MEDIAN OF THE LOS DISTRIBUTION,
C	   AND ORIENTED AS THE REFERENCE DIR. OF POLARIZATION (S')
C
C	3. FRAME WITH Z-AXIS AS THE SUN ROTATION AXIS (S_R)
C
C	4. FRAME WITH Z-AXIS AS THE LOCAL VERTICAL THROUGH THE
C	   REFERENCE POINT M OF THE MAGNETIC-SOURCE DISTRIBUTION (S_M)
C
      SUBROUTINE CORONAD(I)
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CGRID'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CATMO2'
      INCLUDE 'CCONST'
      INCLUDE 'CORON'
      INCLUDE 'CLU'
      INCLUDE 'CINPUT'
      include 'CDOVE'
C
C  SET UP PARAMETERS FOR THE GEOMETRY. ALL GEOMETRY IS SPECIFIED ON
C  INPUT IN GX, GY, GZ WHICH ARE CARTESIAN (X,Y,Z) COORDINATES IN S FRAME
C
      GX2=GX*GX
      GY2=GY*GY
      GZ2=GZ*GZ
C     
      ALPHA=-ATAN2(GX,SQRT(GY2+GZ2))
C     
      SALPHA=SIN(ALPHA)
      CALPHA=COS(ALPHA)
C     
      BETA=ATAN2(GY,GZ)
C     
      SBETA=SIN(BETA)
      CBETA=COS(BETA)
C     
C     OBSERVER'S GEOMETRY IN THE "S-FRAME" (PHI=0), 
C     WITH REFERENCE DIRECTION ALWAYS PARALLEL TO Z
C 	(comment rewrite MAR 2014)
C	Calculate parameters to express Stokes vector
C	at point GX,GY,GZ
C	in the S' frame.  If we wanted to have reference
C 	direction along Z
C 	i.e., atomic frame S (local vertical/radial)
C 	we could just change PGAMMA=0
C     
       THETA=0.5*PI+ALPHA
       PGAMMA=BETA
C      PGAMMA=0.d0
C     
C     TRANSFORM TO POLAR COORDINATES FOR B-FIELD CALCULATION
C     
      RB=SQRT(GX2+GY2+GZ2)
      TB=ATAN2(SQRT(GX2+GY2),GZ)
      PB=ATAN2(GY,GX)
C     
C     COMPUTE MAGNETIC PARAMETERS
C     inputs here are from Jim Dove's file.
C     convert his inputs to bs,bt,bp
      Bx= Br3d(i)*sin(theta3D(i))*cos(phi3D(i))+
     *     Bth3d(i)*cos(theta3D(i))*cos(phi3D(i))-
     *     Bph3d(i)*sin(phi3D(i))
C                      
      By= Br3d(i)*sin(theta3D(i))*sin(phi3D(i))+
     * Bth3d(i)*cos(theta3D(i))*sin(phi3D(i))+
     * Bph3d(i)*cos(phi3D(i))
C
      Bz=  Br3d(i)*cos(theta3D(i)) - Bth3d(i)*sin(theta3D(i))
      bs=sqrt(Bx*Bx+By*By+Bz*Bz)
C
C
C watch out for null points
C (sg edit nov 2012)
C
C also see below adjust to thetab, phib
C to make field radial if B is small
C (sg edit aug 2015)

      if(bs.eq.0d0) then
C       print *,'WARNING - NULL PT'
         ts=0.d0
         ps=0.d0
      else 
        ps=atan2(by,bx)
        ts=acos(bz/bs)
      endif
C     end of Dove's input
C
      BFIELD=BS
      BTHETA=TS
      BPHI=PS
C     
      XB=SIN(BTHETA)*COS(BPHI)
      YB=SIN(BTHETA)*SIN(BPHI)
      ZB=COS(BTHETA)
C     
      YZB=SBETA*YB+CBETA*ZB
C     
      XXB=CALPHA*XB+SALPHA*YZB
      YYB=CBETA*YB-SBETA*ZB
      ZZB=-SALPHA*XB+CALPHA*YZB
C     
C     COMPUTE POLAR ANGLES OF B IN THE "S'-FRAME"
C     (VAN VLECK ANGLE = 54.7356103173)
C     
      THETAB=ATAN2(SQRT(XXB*XXB+YYB*YYB),ZZB)	
      PHIB=ATAN2(YYB,XXB)
C
C make field radial if B very small
C (sg edit aug 2015)
C
      if(bs.lt.1d-3)then
        thetab=0.d0
        phib=0.d0
      endif

C     
C     HEIGHT ABOVE LIMB
C     
      H=RB-1.0
C     
C     LARMOR FREQUENCY 
C     
      ALARMOR=(1.0E-8*(0.25E0/PI)*(EE/EM)*BFIELD)/QNORM
C     
C     THERMAL PARAMETERS
C     
      TEMP=temp3d(i)
      ED=dens3d(i)
      toth=0.8*ed
C     
      VTURB=10./QNORM
C
C changed VTURB to 20 from 0 Dec-20-2013 SG
C  later changed to 10
C
      VEL=VEL3d(i)/QNORM 
C       WRITE(*,*) 'VEL,VTURB,QNORM',VEL,VTURB,QNORM
C
C  NORMALIZE ATOMIC POPULATIONS
C
C       WRITE(*,*)'TEMP',TEMP
C       WRITE(*,*)'ABND',ABND
C       WRITE(*,*)'TOTH',TOTH
C       WRITE(*,*)'EQION',EQION(TEMP)
      TOTN=10.**(ABND-12.)*TOTH*EQION(TEMP)
C       WRITE(*,*),'TEMP,ABND,TOTH,EQION',TEMP,ABND,TOTH,EQION(TEMP)

C HYDROGEN POPULATIONS: ZERO IF NEUTRAL, TOTH FOR PROTONS
      DO II=1,5
         HD(II)=0.
      ENDDO
      HD(6)=TOTH
C
      RETURN
      END

C
C PURPOSE: CALCULATES LTE POPULATIONS
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C     CATOM CATMOS CCONST CLU
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE LTEPOP
C
C  CALCULATES LTE POPULATIONS
C:
C: LTEPOP 87-04-07  MODIFICATIONS: (PHILIP JUDGE)
C:        A DANGER SIGN IS OUTPUT WHEN ZERO POPULATIONS ARE FOUND.
C:
C:        88-02-01  MODIFICATIONS: (MATS CARLSSON)
C:        PROVISION FOR MOLECULES ADDED
C:
C:        88-07-01  MODIFICATIONS: (MATS CARLSSON)
C:        DEBYE LOWERING OF IONIZATION POTENTIAL TAKEN INTO ACCOUNT
C:
C:        92-03-19  MODIFICATIONS: (PHILIP JUDGE)
C:        ZERO SET TO 0. INSTEAD OF 1.E-37 IN DANGER CHECK
C:        
C:        00-08-10  MODIFICATIONS: (PHILIP JUDGE)
C:        REMOVED MOLECULAR PROVISION
C:        
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CCONST'
      INCLUDE 'CLU'
C
      DIMENSION TNS(MK),NDXI(20)
C*
C* 88-07-01 MATS CARLSSON
C* THE ENERGIES OF IONIZATION ARE REDUCED BY ION*DXI, FOLLOWING BASCHEK ET
C* AL., ABH. HAMB. VIII, 26 EQ. (10). 
C* SINCE ALL EV REFERS TO THE LOWEST LEVEL, IT IS NECESSARY TO SUBTRACT
C* FROM THE ENERGY OF A LEVEL ALL DXI EXPERIENCED BY LOWER IONIZATION
C* STAGES. THIS NUMBER IS STORED IN NDXI(ION)
C*
      NDXI(1)=0
      DO 50 I=2,20
        NDXI(I)=NDXI(I-1)+(I-1)
   50 CONTINUE
      DO 60 I=1,20
        NDXI(I)=NDXI(I)-NDXI(ION(1))
   60 CONTINUE
C
      CCON=0.5*(HH/SQRT(2.*PI*EM)/SQRT(BK))**3
      T=TEMP
      CONL=LOG(CCON*ED)-1.5*LOG(T)
      DXI=4.98E-4*5040./T*SQRT(ED*BK*T)
      SUMN=1.
      DO 300 I=2,NK
         EVI=EV(I)-DXI*NDXI(ION(I))
         TNSL=LOG(G(I))-LOG(G(1))-EK/T*EVI
         IF(ION(I).LE.ION(1)) GOTO 100
         L=ION(I)-ION(1)
         TNSL=TNSL-FLOAT(L)*CONL
 100     TNS(I)=EXP(TNSL)
         SUMN=SUMN+TNS(I)
 300  CONTINUE 
      PSTAR(1)=TOTN/SUMN
      DO 400 I=2,NK
         PSTAR(I)=TNS(I)*PSTAR(1)
         IF(PSTAR(I) .LE. 0.)WRITE(LJOBLO,1000)I
 1000    FORMAT(' LTEPOP: LEVEL ',I3,' HAS ZERO
     *        LTE POPULATION')
 400  CONTINUE
C      WRITE(LOUT,1003)(PSTAR(I),I=1,NK)
C      WRITE(LOUT,1004)(PSTAR(I)/TOTN,I=1,NK)
C 1003 FORMAT(1X/1X,'LTE POPULATIONS, ABSOLUTE, NORMALIZED'/1P,8(E10.3))
C 1004 FORMAT(1P,8(E10.3))
      RETURN
      END

C
C PURPOSE: STORE COLLISIONAL DATA FOR USE WITH COLCAL
C          AND INITIALIZE COLLISIONAL DATA TO ZERO
C INPUTS:
C     (READ FROM FILE 'ATOM')
C OUTPUTS:
C     KEYWORDS AND DATA ARE STORED IN COMMON BLOCK  COLL
C COMMON:
C     CATOM COLL CATMOS CATMO2 CCONST CINPUT CLU
C RESTRICTIONS:  ONLY BOUND-BOUND COLLISIONS ARE TREATED. 
C     ELASTIC COLLISIONS ARE NOT YET INCLUDED BUT CAN 
C     EASILY BE SET USING THE DIAGONAL COMPONENTS
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C
C
C 6 JUNE 2019  ADD FLAG FOR M TO MPRIME COLLISIONS FOR EFFICIENCY IN GAMMA ROUTINES
C
      SUBROUTINE COLRD
C
C  GENERAL ROUTINE FOR READING COLLISIONAL RATES 
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'COLL'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CATMO2'
      INCLUDE 'CCONST'
      INCLUDE 'CINPUT'
      INCLUDE 'CLU'
      DIMENSION TGRID(MTGRD),CGRID(MTGRD)
      CHARACTER *20 KEY
C
C 6 JUNE 2019 FLAG FOR M TO MPRIME COLLISIONS FOR EFFICIENCY IN GAMMA ROUTINES
C
      DATA IL,IH /0,0/
C     
C     ASSUME INITIALLY THAT DATA ARE GIVEN INDEPENDENT OF TEMPERATURE:
C     I.E. THAT NTEMP IS ORIGINALLY SET = 1
C     
      NCOL=0
      NTEMP=1
C note added 6jul22
      ICOLLMM=0
      IF(IWATOM .GT. 1) WRITE(LOUT,1005)
 1005 FORMAT(' COLLISIONAL DATA')
C     
C     READ THE KEYWORD 'KEY' AND ASSOCIATED PARAMETERS
C     
 50   CONTINUE
      READ(LDUMS,100,END=301)KEY
      NCOL=NCOL+1
 100  FORMAT(A)
      CALL LJUST(KEY)
      IF(KEY(1:1) .EQ. ' ') THEN
         NCOL=NCOL-1
         GOTO 50
      ENDIF
      IF (KEY(1:3) .EQ. 'END') THEN
         NCOL=NCOL-1
         GOTO 300
      ELSE IF (KEY(1:4) .EQ. 'TEMP') THEN
         NCOL=NCOL-1
         READ(LDUMS,*)NTEMP,(TGRID(JT),JT=1,MIN(NTEMP,MTGRD))
         IF(NTEMP .GT. MTGRD)THEN
            CALL STOP(' COLRD: WORK ARRAYS (TGRID) TOO SMALL')
         ENDIF
         IF (IWATOM .GT. 1) THEN
            WRITE(LOUT,803)KEY(1:4),(TGRID(JT),JT=1,NTEMP)
 803        FORMAT(1X,A,8X,10(1P,1X,E10.3))
         ENDIF
         GOTO 50
      ELSE IF (KEY(1:3) .EQ. 'OHM' .OR. KEY(1:3) .EQ. 'CP ' ) THEN
         CKEY(NCOL)=KEY
         READ(LDUMS,*)IL,IH,(CGRID(JT),JT=1,NTEMP)
         ILC(NCOL)=IL
         IHC(NCOL)=IH
         NTC(NCOL)=NTEMP
         DO JT=1,NTEMP
            CTEMP(JT,NCOL)=TGRID(JT)
            CDATA(JT,NCOL)=CGRID(JT)
         ENDDO
         IF(IWATOM .GT. 1)THEN
            WRITE(LOUT,802)KEY(1:4), IL, IH, (CGRID(JT),JT=1,NTEMP)
 802        FORMAT(1X,A,2(2X,I2),10(1P,1X,E10.3))
         ENDIF
      ELSE IF (KEY(1:4) .EQ. 'CPMM') THEN
C note added 6jul22
         ICOLLMM = 1
         CKEY(NCOL)=KEY
         NTEMP=NTEMP
         READ(LDUMS,*)IL,IH,(CGRID(JT),JT=1,NTEMP+2)
         ILC(NCOL)=IL
         IHC(NCOL)=IH
         NTC(NCOL)=NTEMP
         DO JT=1,NTC(NCOL)+2
            CTEMP(JT,NCOL)=TGRID(JT)
            CDATA(JT,NCOL)=CGRID(JT)
         ENDDO
         IF(IWATOM .GT. 1)THEN
            WRITE(LOUT,802)KEY(1:4), IL, IH, (CGRID(JT),JT=1,NTEMP+2)
         ENDIF
      ELSE
         WRITE(LJOBLO,191)KEY(1:4)
 191     FORMAT('  COLRD: KEYWORD(1:4) IS  (',A,')')
         CALL STOP(' COLRD:  UNKNOWN KEYWORD IN ATOMIC DATA')
      ENDIF
C     
C     CHECK TO SEE THAT THE LEVELS ARE BETWEEN 1 AND NK
C     
      ILO=MIN( IL, IH )
      IHI=MAX( IL, IH )
      IF(ILO .LT. 1 .OR. IHI .GT. NK) THEN 
         WRITE(LJOBLO,1003)ILO,IHI,NK
 1003    FORMAT('ILO IHI NK',3(1X,I6))
         CALL STOP(' COLRD:  LEVEL INDEX OUTSIDE RANGE (1,NK)')
      ENDIF
C     
C     CHECK TO SEE IF THERE ARE LEVELS WITH ENERGIES NOT INCREASING WITH
C     THE LEVEL LABEL (THIS AFFECTS CI ETC.)
C     
      IF(EV(IHI) .LT. EV(ILO) )THEN
         WRITE(LJOBLO,1001)KEY(1:4),IHI,ILO
 1001    FORMAT('  COLRD:  WARNING- KEYWORD ',A,2(2X,I2),
     *        ' ENERGY OF UPPER LEVEL IS .LT. LOWER LEVEL'/
     *        '           WARNING- CHECK RESULTS CAREFULLY')
      ENDIF
      GOTO 50
C     
 301  CALL STOP(' COLRD: KEYWORD ''END'' NOT FOUND IN COLLISION FILE')
 300  CONTINUE
C
C  INITIALIZE COLLISIONAL RATES TO ZERO
C
      DO 309 J=1,NK
         DO 400 I=1,NK
            C(I,J)=0.0
            DO 401 L=-MJMAX,MJMAX
               DO 402 M=-MJMAX,MJMAX
                  CMM(I,J,L,M)=0.0
 402           CONTINUE
 401        CONTINUE
 400     CONTINUE
 309  CONTINUE
C note added 6jul22
      IF(IWATOM .GT. 1 .AND. ICOLLMM .EQ. 1) WRITE(LOUT,*) " M TO M' COLLISIONS INCLUDED "
      END

C
C PURPOSE: INITIALIZE COLLISIONAL RATES C AND 
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: October 6, 1999, P. JUDGE
C 
      subroutine colrat

c  Chooses collisional routine. In FIXRAD fixed rates are added into C. 
c  Collision part is therefore stored to enable separation in routine WRATE

      include 'PREC'
      include 'PARAM'
      include 'CINPUT'
      include 'CATOM'
      include 'CLU'

c  initialize collisional rates to zero

      do j=1,nk
        do i=1,nk
          c(i,j)=.0d0
	  end do
	end do

      if (icoll.eq.1) call gencol

c      write(lout,*) 'COLLISIONAL RATES'
c      write(lout,1) (i,i=1,nk)

1	format(3x,6(2x,4x,i6))

      return
      end

C
C PURPOSE: CALCULATES THE S-FRAME IRRED. TENSOR COMPONENTS OF AVG RADN FIELD
C
C  THIS SUBROUTINE CALCULATES THE IRREDUCIBLE TENSOR COMPONENTS
C  OF THE AVERAGE RADIATION FIELD FROM THE PHOTOSPHERE IN THE
C  S FRAME, GIVEN THE LIMB-DARKENING FUNCTION, AND ASSUMING
C  CYLINDRICAL SYMMETRY OF THE RADIATION FIELD. 
C
C  AN 8-POINT GAUSSIAN QUADRATURE FORMULA IS ADOPTED FOR THE 
C  CALCULATION OF THE WEIGHTED INTEGRALS. THE INTEGRAL IN 
C  (Y;AMU_M,1) IS TRANSFORMED INTO AN INTEGRAL IN (X;-1,1) FOR 
C  THE PURPOSE OF GAUSSIAN INTEGRATION
C
C  H IS THE HEIGHT OF THE OBSERVED POINT OVER THE LIMB, EXPRESSED
C  IN SOLAR RADII
C
C INPUTS:
C       KR    INDEX OF THE TRANSITION
C       (FLIMB EXTERNAL  FUNCTION THAT HAS TO BE DEFINED)
C
C OUTPUTS:
C       RJ0   K=0 TENSOR COMPONENT OF THE RADIATION FIELD
C       RJ1   K=1 TENSOR COMPONENT OF THE RADIATION FIELD
C                 (THIS IS ZERO IN CYLINDRICAL SYMMETRY)
C       RJ2   K=2 TENSOR COMPONENT OF THE RADIATION FIELD
C             SEE EQUATIONS 22 AND 23 OF 
C             CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539
C
C COMMON:
C       CORON
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE FIELD_INT(KR,RJ0,RJ1,RJ2)
	INCLUDE 'PREC'
	INCLUDE 'CORON'
	INCLUDE 'CINTS'
	DIMENSION X(4),W(4)
	DATA X/.183434642495650,.525532409916329,
     /	 .796666477413627,.960289856497536/
	DATA W/.362683783378362,.313706645877887,
     /	 .222381034453374,.101228536290376/
	EXTERNAL FLIMB
C  STATEMENT FUNCTION
	T2_0(X1)=(.5/SQRT(TWO))*(THREE*X1*X1-ONE)
	AMU_M=SQRT(H*(H+TWO))/(H+ONE)
	FACTOR1=.5*(ONE-AMU_M)			
	FACTOR2=FACTOR1+AMU_M
C  INITIALIZE
	RJ0=ZERO
	RJ2=ZERO
	DO I=1,4
	  YPOS=FACTOR1*X(I)+FACTOR2
	  YNEG=-YPOS+TWO*FACTOR2
	  TMP0POS=FLIMB(KR,YPOS,AMU_M)
	  TMP2POS=T2_0(YPOS)*TMP0POS
	  TMP0NEG=FLIMB(KR,YNEG,AMU_M)
	  TMP2NEG=T2_0(YNEG)*TMP0NEG
	  RJ0=W(I)*(TMP0POS+TMP0NEG)+RJ0
	  RJ2=W(I)*(TMP2POS+TMP2NEG)+RJ2
	END DO
	RJ0=.5*FACTOR1*RJ0
	RJ1=ZERO
	RJ2=.5*FACTOR1*RJ2
	RETURN
	END
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
C PURPOSE: CALCULATES RADIATION FIELD INTENSITY IN THE DIRECTION THETA=ARCOS(X)
C
C INPUTS:
C       KR  TRANSITION INDEX
C	X   COS THETA
C       XM  COS THETAM
C           YMU IS MU= COS ZETA IN EQUATION 29 OF CASINI & JUDGE 1999
C OUTPUTS:
C       FLIMB
C COMMON:
C
C RESTRICTIONS:
C       
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	FUNCTION FLIMB(KR,X,XM)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CATOM'
	INCLUDE 'CCONST'
	INCLUDE 'CINTS'
	YMU=SQRT((X+XM)*(X-XM)/(ONE-XM*XM))
C
C  LAMBDA IS IN ANGSTROMS
C  XNU IS ANGULAR FREQUENCY OF TRANSITION
C
	WL=ALAMB(KR)
	WM=WL/1.E4
	XNU=1.E8*(TWO*PI)*(CC/WL)
C
C XT IS DISK CENTER RADIATION TEMPERATURE FOR I (ALLEN 1973, SEC 80)
C
	XT=6050.
C
C ALLEN'S (1973) LIMB DARKENING (P 170, TOP)
C
	CALL UV(WM,U,V)
	FLIMB=PLANCK(XNU,XT)*(ONE-U-V+(U+V*YMU)*YMU)
	RETURN
	END

C
C PURPOSE: COMPUTE RATE FOR COLLISIONAL IONIZATION BY AUTOIONIZATION
C          USING FORMALISMS OF ARNAUD AND ROTHENFLUG 1985
C          LIMITED TO CORONAL APPLICATIONS
C
C INPUTS:
C          ILO  index of lower level of the atom
C          IHI  index of upper level of the atom
C
C OUTPUTS:
C          CEA  collisional transition probability between levels ILO IHI
C COMMON:
C
C COMMENTS: October 6, 1999, P. JUDGE
C           THIS CONTAINS SEVERAL SELF-CONTAINED ROUTINES IN ONE PACKAGE
C
      SUBROUTINE AR85CEA(ILO,IHI,CEA)
C
C  NEW ROUTINE FOR COMPUTING COLLISIONAL AUTOIONIZATION 
C  RATES USING FORMALISM AND FORMULAE FROM ARNAUD AND ROTHENFLUG 1985
C
C
C AR85CEA 94-02-22  NEW ROUTINE: (PHILIP JUDGE)
C        
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CCONST'
      INCLUDE 'CLU'
      CHARACTER*2 CSEQ, ARELEM, ATOMNM
      LOGICAL DEBUG
      DATA DEBUG /.FALSE./
C  INITIALIZE OUTPUT TO ZERO
      CEA=0.0
C
C
C  FIND ELEMENT
C
      ARELEM = ATOMID(1:2)
      IZ=IATOMN(ARELEM)   
      ZZ=0.0 + IZ
      IF (IZ .LT. 1 .OR. IZ .GT. 92) THEN 
        WRITE(LJOBLO,*)'AR85-CEA:  ATOMIC NUMBER = ',IZ, ' FOR ',ARELEM
        WRITE(LJOBLO,*)'AR85-CEA:  NO AUTOIONIZATION INCLUDED'
        RETURN
      ELSE IF(DEBUG) THEN
        WRITE(LJOBLO,*)'AR85-CEA: ',ARELEM, ' CHARGE ',ION(ILO)-1
      ENDIF
C
C  FIND ISO-ELECTRONIC SEQUENCE
C
      ICHRGE=ION(ILO)-1
      ISOSEQ=IZ-ICHRGE
      CSEQ=ATOMNM(ISOSEQ)  
      BKT=BK*TEMP/EE
C
C*********************************************************************
C LITHIUM SEQUENCE
C*********************************************************************
C
        IF (CSEQ .EQ. 'LI') THEN 
          CEAB=1. / (1. + 2.E-4*ZZ*ZZ*ZZ)
          CEAZEFF=(ZZ-1.3)
          CEAIEA=13.6*((ZZ-0.835)*(ZZ-0.835) - 0.25*(ZZ-1.62)*(ZZ-1.62))
          Y=CEAIEA/BKT
          F1Y=FONE(Y)
CPREPRINT          CUP= 8.0E+10 * CEAB /CEAZEFF/CEAZEFF/SQRT(BKT) 
CPREPRINT     *   * EXP(-Y)*(2.22*F1Y+0.67*(1.-Y*F1Y)+0.49*Y*F1Y+1.2*(Y-F1Y))
          CUP=1.60E-07*1.2*CEAB/CEAZEFF/CEAZEFF/SQRT(BKT)*EXP(-Y)*
     *     (2.22*F1Y+0.67*(1.-Y*F1Y)+0.49*Y*F1Y+1.2*Y*(1.-Y*F1Y))
C
C  TWO SPECIAL CASES:
C
C C IV - APP A AR85
          IF(ARELEM .EQ. 'C ') CUP = CUP*0.6
C N V  - APP A AR85
          IF(ARELEM .EQ. 'N ') CUP = CUP*0.8
C O VI - APP A AR85
          IF(ARELEM .EQ. 'O ') CUP = CUP*1.25  
C
C*********************************************************************
C SODIUM SEQUENCE
C*********************************************************************
C
        ELSE IF (CSEQ .EQ. 'NA') THEN 
          IF (IZ .LE. 16) THEN 
            CEAA=2.8E-17*(ZZ-11.)**(-0.7)
            CEAIEA=26.*(ZZ-10.)
            Y=CEAIEA/BKT
            F1Y=FONE(Y)
            CUP= 6.69E+7 * CEAA *CEAIEA/SQRT(BKT) * EXP(-Y)*(1. - Y*F1Y)
          ELSE IF (IZ .GE. 18 .AND.  IZ .LE. 28) THEN 
            CEAA=1.3E-14*(ZZ-10.)**(-3.73)
            CEAIEA=11.*(ZZ-10.)*SQRT(ZZ-10.)
            Y=CEAIEA/BKT
            F1Y=FONE(Y)
            CUP= 6.69E+7 * CEAA *CEAIEA/SQRT(BKT) * EXP(-Y)  
     *      *(1. - 0.5*(Y -Y*Y + Y*Y*Y*F1Y))
          ELSE 
            RETURN
          ENDIF
        ENDIF
C
C*********************************************************************
C MAGNESIUM-SULFUR SEQUENCES
C*********************************************************************
C
        IF(CSEQ .EQ. 'MG' .OR. CSEQ .EQ. 'AL' 
     *   .OR. CSEQ .EQ. 'SI' .OR. 
     *   CSEQ .EQ. 'P ' .OR. CSEQ .EQ. 'S ') THEN 
          IF(CSEQ .EQ. 'MG') CEAIEA=10.3*(ZZ-10.)**1.52
          IF(CSEQ .EQ. 'AL') CEAIEA=18.0*(ZZ-11.)**1.33
          IF(CSEQ .EQ. 'SI') CEAIEA=18.4*(ZZ-12.)**1.36
          IF(CSEQ .EQ. 'P ' ) CEAIEA=23.7*(ZZ-13.)**1.29
          IF(CSEQ .EQ. 'S ' ) CEAIEA=40.1*(ZZ-14.)**1.1
          CEAA=4.0E-13/ZZ/ZZ/CEAIEA
          Y=CEAIEA/BKT
          F1Y=FONE(Y)
          CUP= 6.69E+7 * CEAA *CEAIEA/SQRT(BKT) * EXP(-Y)  
     *    *(1. - 0.5*(Y -Y*Y + Y*Y*Y*F1Y))
        ENDIF
C
C
C*********************************************************************
C  SPECIAL CASES
C*********************************************************************
C
C
        IF(ARELEM .EQ. 'CA' .AND.  (ICHRGE .EQ. 0)) THEN 
          CEAA = 9.8E-17
          CEAIEA= 25.
          CEAB=1.12         
          CUP=6.69E+7*CEAA *CEAIEA/SQRT(BKT) * EXP(-Y)*(1. + CEAB*F1Y)
          WRITE(LJOBLO,*)'AR85-CEA SPECIAL CASE ',ARELEM, 
     *     ' ION ICHRGE ',ICHRGE
        ELSE IF(ARELEM .EQ. 'CA' .AND.  (ICHRGE .EQ. 1)) THEN 
          CEAA = 6.0E-17
          CEAIEA= 25.
          CEAB=1.12         
          CUP=6.69E+7*CEAA *CEAIEA/SQRT(BKT) * EXP(-Y)*(1. + CEAB*F1Y)
        ELSE IF(ARELEM .EQ. 'FE' .AND.  (ICHRGE .EQ. 3)) THEN 
          CEAA = 1.8E-17
          CEAIEA= 60.
          CEAB=1.0         
          CUP=6.69E+7*CEAA *CEAIEA/SQRT(BKT) * EXP(-Y)*(1. + CEAB*F1Y)
        ELSE IF(ARELEM .EQ. 'FE' .AND.  (ICHRGE .EQ. 4)) THEN 
         CEAA = 5.0E-17
         CEAIEA= 73.
         CEAB=1.0         
         CUP=6.69E+7*CEAA *CEAIEA/SQRT(BKT) * EXP(-Y)*(1. + CEAB*F1Y)
        ENDIF
      CEA=CUP
      RETURN
      END
C
C*********************************************************************
C
C
C*********************************************************************
C
       CHARACTER*2 FUNCTION ATOMNM(I)
C
C  ATOMNM 94-02-22  NEW ROUTINE: (PHILIP JUDGE)
C  GIVES ATOMIC NAME OF ARELEMENT IF I IS AN INTEGER CONTAINING
C  E.G. IF INPUT  IS 'H ' IT WILL RETURN 1, 'HE', IT WILL RETURN 2, ETC.
C
      PARAMETER (NDATA=28)
      CHARACTER*2 ARELEM(NDATA)
      DATA ARELEM /'H ','HE','LI','BE','B ','C ','N ','O ','F ','NE',
     * 'NA','MG','AL','SI','P ','S ','CL','AR',
     * 'K ','CA','SC','TI','V ','CR','MN','FE','CO','NI'/
      IF(I .LE. NDATA .AND.  I .GE. 1) THEN 
        ATOMNM= ARELEM(I)
      ELSE
        ATOMNM='  '
      ENDIF
      RETURN
      END

C
C***********************************************************************
C
      FUNCTION FONE(X)
C
C NEW ROUTINE 24-JAN-1994
C CALCULATES F1(X) NEEDED FOR COLLISIONAL RATES OF ARNAUD AND ROTHENFLUG 
C MODIFIED BY P. JUDGE 15-MAR-1994 
C FOR LARGE VALUES OF X, USE ASYMPTOTIC LIMIT
C 
      INCLUDE 'PREC'
      DATA SPLIT /50.0/
      IF(X .LE. SPLIT) THEN 
        FONE = EXP(X)*EXPINT(1,X,EX)
      ELSE
        FONE= 1./X
      ENDIF
      RETURN
      END
C
C**********************************************************************
C
      FUNCTION FTWO(X)
C
C NEW ROUTINE 24-JAN-1994  P. JUDGE
C CALCULATES F2(X) NEEDED FOR COLLISIONAL RATES OF ARNAUD AND ROTHENFLUG 
C IF ARGUMENT X IS < BREAK, THEN USE THE EQNS 5 AND 6 OF HUMMER (1983, JQSRT, 30 281)
C BREAK GIVEN BY HUMMER AS 4.0
C
C NOTE THAT THE SUGGESTED POLYNOMIAL EXPANSION OF ARNAUD AND ROTHENFLUG
C FAILS FOR ARGUMENTS < BREAK- SEE HUMMER'S ORIGINAL PAPER.
C IT IS UNCLEAR IF THE TABULATED IONIZATION FRACTIONS OF ARNAUD AND ROTHENFLUG
C CONTAIN THIS ERROR.   
C 
      INCLUDE 'PREC'
      INCLUDE 'CCONST'
      DIMENSION P(15), Q(15)
      DATA BREAK /4.0/
      DATA P /1.0,2.1658E+02,2.0336E+04,1.0911E+06,3.7114E+07,
     * 8.3963E+08,1.2889E+10,1.3449E+11,9.4002E+11,4.2571E+12,
     * 1.1743E+13,1.7549E+13,1.0806E+13,4.9776E+11,0.0000/,
     *     Q /1.0,2.1958E+02,2.0984E+04,1.1517E+06,4.0349E+07,
     * 9.4900E+08,1.5345E+10,1.7182E+11,1.3249E+12,6.9071E+12,
     * 2.3531E+13,4.9432E+13,5.7760E+13,3.0225E+13, 3.3641E+12/
      IF(X .GE. BREAK) THEN 
        PX=P(1)
        XFACT=1.0
        DO 1 I=2,15
          XFACT = XFACT/X
          PX=PX+ P(I)*XFACT
    1   CONTINUE
C        PX = P(1) + XI*(P(2) + (XI*P(3) +(XI*P(4) + (XI*P(5) + (XI*P(6) 
C     *   + (XI*P(7) + (XI*P(8) +(XI*P(9) + (XI*P(10) + (XI*P(11) +
C     *   (XI*P(12) + (XI*P(13) +(XI*P(14)+XI*P(15))))))))))))))
C        QX = Q(1) + XI*(Q(2) + (XI*Q(3) +(XI*Q(4) + (XI*Q(5) + (XI*Q(6) 
C     *   + (XI*Q(7) + (XI*Q(8) +(XI*Q(9) + (XI*Q(10) + (XI*Q(11) +
C     *   (XI*Q(12) + (XI*Q(13) +(XI*Q(14)+XI*Q(15))))))))))))))
        QX=Q(1)
        XFACT=1.0
        DO 2 I=2,15
          XFACT = XFACT/X
          QX=QX+ Q(I)*XFACT
    2   CONTINUE
        FTWO=PX/QX/X/X
      ELSE
C
C  HUMMER'S EQUNS 5 AND 6
C  GAMMA IS EULER'S CONSTANT (ABRAMOVICZ+STEGUN)
C
        GAMMA=0.5772156649  
        F0X = PI*PI/12.
        TERM=1.0
        COUNT=0.0
        FACT=1.0
        XFACT=1.0
        DO WHILE (ABS(TERM/F0X) .GT. 1.E-8)
          COUNT=COUNT+1.0
          FACT = FACT*COUNT
          XFACT=XFACT*(-X)
          TERM = XFACT/COUNT/COUNT/FACT
          F0X=F0X+TERM
          IF(COUNT .GT. 100.) CALL STOP('FTWO: TOO MANY ITERATIONS')
        ENDDO
        FTWO=EXP(X)*((LOG(X)+GAMMA)*(LOG(X)+GAMMA)*0.5 + F0X)
      ENDIF
      RETURN
      END

C
C PURPOSE: CALCULATES THE S-FRAME IRRED. TENSOR COMPONENTS OF AVG RADN FIELD
C
C  THIS SUBROUTINE CALCULATES THE IRREDUCIBLE TENSOR COMPONENTS
C  OF THE AVERAGE RADIATION FIELD FROM THE PHOTOSPHERE IN THE
C  S FRAME, GIVEN THE LIMB-DARKENING FUNCTION, AND ASSUMING
C  CYLINDRICAL SYMMETRY OF THE RADIATION FIELD. 
C
C  H IS THE HEIGHT OF THE OBSERVED POINT OVER THE LIMB, EXPRESSED
C  IN SOLAR RADII
C
C INPUTS:
C       KR    INDEX OF THE TRANSITION
C       (FLIMB EXTERNAL  FUNCTION THAT HAS TO BE DEFINED)
C
C OUTPUTS:
C       RJ0   K=0 TENSOR COMPONENT OF THE RADIATION FIELD
C       RJ1   K=1 TENSOR COMPONENT OF THE RADIATION FIELD
C                 (THIS IS ZERO IN CYLINDRICAL SYMMETRY)
C       RJ2   K=2 TENSOR COMPONENT OF THE RADIATION FIELD
C             SEE EQUATIONS 22 AND 23 OF 
C             CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539
C
C COMMON:
C       CORON
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
	SUBROUTINE FIELD_INT(KR,RJ0,RJ1,RJ2)
C
C
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CATOM'
	INCLUDE 'CORON'
	INCLUDE 'CCONST'
	INCLUDE 'CINTS'
C
	SM=ONE/(H+ONE)
	SM2=SM*SM
	CM2=ONE-SM2
	CM=SQRT(CM2)
C
	RLN=ZERO
	IF (CM2.NE.ZERO) RLN=LOG((ONE+SM)/CM)
C
	A1=ONE-CM
	A2=.5*(ONE-RLN*CM2/SM)-A1
	A3=(CM*(THREE-CM2)-TWO)/(THREE*SM2)
C
	B1=CM*SM2
	B2=.125*(THREE*SM2+RLN*CM2*(THREE*SM2+ONE)/SM-ONE)-B1
	B3=((CM2*(20.-9.*CM2)-15.)*CM+FOUR)/(15.*SM2)
C
	WL=ALAMB(KR)
	WM=WL/1.E4
	CALL UV(WM,U,V)
	XNU=1.E8*(TWO*PI)*(CC/WL)
C
C NOW ADD THE ABSOLUTE INTENSITY FACTOR PINT
C XT IS DISK CENTER RADIATION TEMPERATURE FOR I (ALLEN 1973, SEC 80)
C
	XT=6050.
	PINT=PLANCK(XNU,XT)
C
C	PRINT *,'NO LIMB DARKENING'
C	U=ZERO
C	V=ZERO
C
	RJ0=.5*(A1+A2*U+A3*V)*PINT
	RJ1=ZERO
	RJ2=.25*(B1+B2*U+B3*V)/SQRT(TWO)*PINT
	RETURN
	END

C
C PURPOSE: CALCULATES LINE PROFILE 
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C ---Sept 2022 replaced pre 6jul22 version
C 
      SUBROUTINE PROFIL
C
C  
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CATMO2'
      INCLUDE 'CSLINE'
      INCLUDE 'CLU'
      INCLUDE 'CINPUT'
      INCLUDE 'CCONST'
C
      SQRTPI=SQRT(PI)
C
C  CALCULATE DOPPLER WIDTH DYND IN UNITS OF QNORM
C
       DNYD=SQRT(2.*BK*TEMP/AWGT)*1.E-5/QNORM
C
C  INCLUDE MICROTURBULENCE
C
      DNYD=SQRT(DNYD*DNYD+VTURB*VTURB)
      DO KR=1,NLINE
        DO NY=1,NQ(KR)
          IF (IND(KR).EQ.2) THEN 
            V=(Q(NY,KR)-VEL)/DNYD
            PHI(KR,NY)=EXP(-V*V)/SQRTPI
            PHIP(KR,NY)=(-2.0*V)*PHI(KR,NY) 
          ENDIF
       END DO
      IF(IDEBUG .NE. 0) WRITE(LOUT,1001) 'PROFIL: PHI(KR,*)',
     *  (PHI(KR,NY),NY=1,NQ(KR))
      END DO
 1001 FORMAT(A/10(1X,E9.2))
      RETURN
      END

C
C PURPOSE: CALCULATE EMISSION COEFFICIENTS FOR STOKES VECTOR 
C
C INPUTS:
C       KR   TRANSITION INDEX (1=FIRST TRANSITION, ETC)
C       T0   GEOMETRIC TENSOR (TABLE 1 OF
C            CASINI, R. & JUDGE, P. G., 1999. AP J 522, 524-539)
C OUTPUTS:
C   EMISS(KR,I,NY)  EMISSION COEFFICIENT IN PH/CM2/S/SR/ANGSTROM 
C   WHERE  KR IS THE LINE INDEX
C          I IS THE STOKES INDEX (0=INTENSITY, 1=Q, ETC.)
C          NU IS THE FREQUENCY INDEX
C
C COMMON:
C       CSE CSLINE CATOM CORON SGNM CLU
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
C       4TH NOVEMBER 2019
C	ADDED WHITE LIGHT EMISSION TO EMISSIVITY
C	22 JULY 2022 COMMENTED OUT UNTIL FULLY TESTED
C
C	JULY 1 2022
C	PGJ FIX PROFILE NORMALIZATION BUG
C	THE ORIGINAL VERSION RETURNED IQUV VALUES
C       LARGER BY AN ERRONEOUS FACTOR OF 3.155 * (QNORM/10)	
C
	SUBROUTINE EMISSION(KR,T0)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	INCLUDE 'CSLINE'
	INCLUDE 'CCONST'
	INCLUDE 'CATOM'
	INCLUDE 'CORON'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
	INCLUDE 'CLU'
C
	PARAMETER (SQRT2=.14142135623730950488E1)
	PARAMETER (SQRT3=.17320508075688772935E1)
C
	DIMENSION T0(0:3,0:2)
	DIMENSION EM_FACT(0:4)
C
	IJ0=IRAD(KR)
	IJ1=JRAD(KR)
	RJ0=AJ(IJ0)
	RJ1=AJ(IJ1)
C
C CALCULATE C_COEFF
C
	HNU=HH*CC / (ALAMB(KR)/1.E8)
	C_COEFF=TOTN*SQRT(TWO*RJ1+ONE)*RHO(IJ1,0)*A(KR)
     *         *HNU/FOUR/PI
C
C       diagnostic output
C
C 	WRITE(*,*) 'KR,IJ1,C_COEFF,TOTN,RJ1,RHO(IJ1,0),A(KR)',
C     *     KR,IJ1,C_COEFF,TOTN,RJ1,RHO(IJ1,0),A(KR)
C
C  	write(*,*) kr, alamb(kr),label(ij1),rho(ij1,0)
	G0=GLAND(IJ0)
	G1=GLAND(IJ1)
	GEFF=0.5*(G0+G1)+0.25*(G0-G1)*(RJ0*(RJ0+ONE)-RJ1*(RJ1+ONE))
	SIGMA=RHO(IJ1,2)/RHO(IJ1,0)
C
C       diagnostic output
C        WRITE(*,*) RHO(IJ1,2),RHO(IJ1,0)
C
C   CALCULATE DCOEFF AND ECOEFF
C
	D_COEFF=-SG(NINT(RJ0+RJ1))*SQRT(THREE*(TWO*RJ1+1))
     /	 *FUN6J(ONE,ONE,TWO,RJ1,RJ1,RJ0)
C
C ORIGINAL 2006 CODE
C      E_COEFF=THREE*SQRT(TWO*RJ1+ONE)
C     /	 *(SG(NINT(RJ1-RJ0))*G1*SQRT(RJ1*(RJ1+ONE)*(TWO*RJ1+ONE))
C    /	 *FUN6J(ONE,TWO,ONE,RJ1,RJ1,RJ1)
C     /	 *FUN6J(ONE,ONE,ONE,RJ1,RJ1,RJ0)
C     /	 -G0*SQRT(RJ0*(RJ0+ONE)*(TWO*RJ0+ONE))
C     /	 *FUN9J(ONE,TWO,ONE,RJ0,RJ1,ONE,RJ0,RJ1,ONE))
c
c       ALTERNATE CALCULATION OF E GIVEN D AND GEFF
c	
	F_COEFF=3./4. * (RJ1*(RJ1+ONE) - RJ0*(RJ0+ONE) -2.)*(G1-G0)
	E_COEFF=D_COEFF/SQRT2*(F_COEFF+GEFF)
C
C   CALCULATE EMISSION COEFFICIENTS
C
C       PGJ 9 JUNE 2022 BEGIN
C      OLD;
C      ALARMOR=(1.0E-8*(0.25E0/PI)*(EE/EM)*BFIELD)/QNORM
C
C       NEW:
C       FLARMOR LARMOR FREQUENCY UNITS OF HZ
C
	FLARMOR = 1.E-8 * EE * BFIELD / EM / 4./ PI
C
C       PGJ 9 JUNE 2022 END
C	
C       LINE WIDTH IN DOPPLER UNITS CM/S
C	
	WCGS=DNYD*QNORM*1.E5
C
C       IN FREQUENCY UNITS HZ
C
	WHZ = WCGS * 1.E8 / ALAMB(KR)
	EM_FACT(0)=ONE+D_COEFF*SIGMA*T0(0,2)
	EM_FACT(1)=D_COEFF*SIGMA*T0(1,2)
	EM_FACT(2)=D_COEFF*SIGMA*T0(2,2)
	EM_FACT(3)=-(SQRT2/SQRT3)*FLARMOR/WHZ * (GEFF+E_COEFF*SIGMA)*T0(3,1) 
	EM_FACT(4)=-(SQRT2/SQRT3)*FLARMOR/WHZ *  GEFF*T0(3,1)
C       diagnostic output
C	write(*,*) em_fact(0),em_fact(1),em_fact(2),em_fact(3),em_fact(4)
C
C EMISS(*,4,*): MAGNETOGRAM STOKES V
C
C	SI=0.
C	SQ=0.
C	SU=0.
C	
C       4TH NOVEMBER 2019
C	CALL KCOR(KR, SI, SQ, SU)
C       4TH NOVEMBER 2019
C  	SG: note-- SCL below not in PGJ version
C         I am keeping in (commented)
C          because it is in commented lines below
C         Although no longer used in EMISS definitions
C	SCL=C_COEFF*1.E-13*ALAMB(KR)
C	DO NY=1,NQ(KR)
C	  EMISS(KR,0,NY)=EM_FACT(0)*PHI(KR,NY)*C_COEFF + SI
C	  EMISS(KR,1,NY)=EM_FACT(1)*PHI(KR,NY)*C_COEFF + SQ
C	  EMISS(KR,2,NY)=EM_FACT(2)*PHI(KR,NY)*C_COEFF + SU
C	  EMISS(KR,3,NY)=-EM_FACT(3)*PHIP(KR,NY)*SCL
C	  EMISS(KR,4,NY)=-EM_FACT(4)*PHIP(KR,NY)*SCL
C	END DO
C	write(lout,*) 'EMISSION: ',EM_FACT(0)*C_COEFF
C
	DO NY=1,NQ(KR)
	   P=PHI(KR,NY)*C_COEFF 
	   EMISS(KR,0,NY)=EM_FACT(0)*P
	   EMISS(KR,1,NY)=EM_FACT(1)*P
	   EMISS(KR,2,NY)=EM_FACT(2)*P
	   P=PHIP(KR,NY)*C_COEFF 
	   EMISS(KR,3,NY)=-EM_FACT(3)*P
	   EMISS(KR,4,NY)=-EM_FACT(4)*P
	END DO
C  	Diagnostic output
C	WRITE(*,*) EMISS(1,0,1),EMISS(1,1,1),EMISS(1,2,1),EMISS(1,3,1),EMISS(1,4,1)
C	WRITE(*,*) EM_FACT(0),EM_FACT(1),EM_FACT(2),EM_FACT(3),EM_FACT(4)
C	WRITE(*,*) D_COEFF,SIGMA,T0(0,2),T0(1,2),T0(2,2),T0(3,1),FLARMOR,GEFF,E_COEFF
C	WRITE(*,*) SIGMA
	RETURN
	END

	SUBROUTINE KCOR(KR,EI,EQ,EU)
	INCLUDE 'PREC'
	INCLUDE 'PARAM'
	INCLUDE 'CSE'
	include 'CGRID'
	INCLUDE 'CSLINE'
	INCLUDE 'CCONST'
	INCLUDE 'CATMOS'
	INCLUDE 'CATOM'
	INCLUDE 'CORON'
	INCLUDE 'SGNM'
	INCLUDE 'CINTS'
	INCLUDE 'CLU'
C
C NEW ROUTINE OCTOBER 2019 PGJ 
C
C RETURNS K-CORONAL EMISSION COEFFICIENTS 
C
	RRR=SQRT(GX*GX+GY*GY+GZ*GZ)
	ROTANG=ATAN(GZ,GY)
	SGG=1./RRR
	CGG=SQRT(1.-SGG*SGG)
	QQ=ZERO
C	write(*,*) "RRR, ROTANG, SGG, CGG, QQ"
C	write(*,*) RRR, ROTANG, SGG, CGG, QQ
C      
C   EQUATIONS (11) AND (12) OF VANDEHULST 1950
C
        TAPB = (1.-QQ)/(1.-QQ/3.) * 2.*(1.-CGG) + 
     *           QQ/(1.-QQ/3.)      * (1.-CGG*CGG/SGG * LOG((1.+SGG)/CGG) )

	TAMB = (1.-QQ)/(1.-QQ/3.) *  2./3.*(1.-CGG**3) + 
     *       QQ/(1.-QQ/3.)       *  .25* (1.+SGG*SGG - CGG**4/SGG * 
     *                                 LOG((1.+SGG)/CGG) )

	AAA=(TAPB+TAMB)/2.
	BBB=(TAPB-TAMB)/2.
C   
C EQUATION (13) VDH 1950
C
	SIGMAT=6.6524587E-25   
	FF=CC*1.E8/ALAMB(KR)
	TR=5900.
	BETA=HH*FF/BK/TR
	B0= 2.*HH*FF * (FF/CC)**2. / (EXP(BETA) -1.)
C
C       WE NEED INTENSITY PER ANGSTROM FOR OUTPUT

C
	WWW=ALAMB(KR)
	B0 = B0 * CC*1.E8/WWW/WWW
C      
	ST=GY/SQRT(GY*GY+GX*GX)   
	CT=SQRT(1.-ST*ST)
C
C EQUATIONS (14) AND (15) VDH WHICH GIVE (16) AND (17) INTEGRANDS
C
	TTK=3./8. * B0 * SIGMAT * AAA * ED
	RRK=3./8. * B0 * SIGMAT * (AAA * CT*CT + BBB *ST*ST) *ED
	EI=TTK+RRK
	EQQ=TTK-RRK
	EUU=0.
C	WRITE(*,*)"B0,TTK,RRK, ED", B0,TTK,RRK, ED

C
C POS ROTATION  
C
	ROTANG=-2*ROTANG
	EQ=EQQ*COS(ROTANG) - EUU*SIN(ROTANG)
	EU=EQQ*SIN(ROTANG) + EUU*COS(ROTANG)

	RETURN
	END

C
C PURPOSE: STORES COLLISION RATES BETWEEN BOUND LEVELS ONLY IN C(I,J)
C
C INPUTS:
C
C OUTPUTS:
C     C(I,J)    INELASTIC COLLISION RATES BETWEEN LEVELS I AND J
C               CONVENTION IS C(I,J) IS COLLISION RATE FROM LEVEL J TO I
C               (SAME AS LANDI AND LANDOLFI, OPPOSITE OF MIHALAS)
C     
C COMMON:
C        CATOM COLL CATMOS CATMO2 CCONST CINPUT CLU
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C
C MODIFICATIONS: PGJ JANUARY 11, 2006. CORRECTED RELATIONSHIP BETWEEN 
C                UPWARD AND DOWNWARD RATES FOR CPMM DATA.
C                PGJ JANUARY 18, 2006, REMOVED CP AND CH KEYWORDS (NOT NEEDED).
C
C COMMENTS:  JULY 26 2019 CONVENTION SWAPPED
C            AUG 19 2019.  CPMM CODE CORRECTED FOR INPUT OF UPWARD COLLISIONS
C	     DEC 20 2022 FIXED BUG IN CMM MP TO M SWITCH -- SG
C*********************************************************************
C
      SUBROUTINE COLCAL
C
C  GENERAL ROUTINE FOR COMPUTING COLLISIONAL RATES 
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'COLL'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CATMO2'
      INCLUDE 'CCONST'
      INCLUDE 'CINPUT'
      INCLUDE 'CLU'
C
C  LOCAL VARIABLES: UP TO MTGRD POINTS IN TEMPERATURE GRID ALLOWED
C
      DIMENSION TGRID(MTGRD),CGRID(MTGRD)
      CHARACTER *20 KEY
C
C  INITIALIZE COLLISIONAL RATES TO ZERO
C
      DO 300 J=1,NK
         DO 400 I=1,NK
            C(I,J)=0.0
            DO 401 L=-MJMAX,MJMAX
               DO 402 M=-MJMAX,MJMAX
                  CMM(I,J,L,M)=0.0
 402           CONTINUE
 401        CONTINUE
 400     CONTINUE
 300  CONTINUE
C
C  LOOP OVER COLLISIONS
C
      DO 100 ICOL=1,NCOL
C
C  IDENTIFY THE UPPER AND LOWER LEVELS:
C
         KEY=CKEY(ICOL)
         IL=ILC(ICOL)
         IH=IHC(ICOL)
         NTEMP=NTC(ICOL)
         NINTEP=NTEMP
         DO 200 IT=1,NTEMP
            TGRID(IT)=CTEMP(IT,ICOL)
            CGRID(IT)=CDATA(IT,ICOL)
 200     CONTINUE
         NINTEP=MIN(ISPLIN,NINTEP) 
         ILO=MIN( IL, IH )
         IHI=MAX( IL, IH )
C
C  OMEGAS ARE GIVEN (+VE IONS)
C
         IF(KEY(1:3) .EQ. 'OHM') THEN
            CT=SPLIN(TEMP,TGRID,CGRID,NTEMP,NINTEP)
            CDN = 8.63E-06 * CT * ED / ( G(IHI)*SQRT(TEMP) )
            CUP = CDN * PSTAR(IHI) / PSTAR(ILO)
C (Note these were swapped in 6jul22)
            C(ILO,IHI) = CDN + C(IHI,ILO)
            C(IHI,ILO) = CUP + C(ILO,IHI)
C     
C     CPMM VALUES ARE GIVEN (M-M' COLLISIONS WITH PROTONS)
C     
         ELSE IF (KEY(1:4) .EQ. 'CPMM')THEN
            DO 201 IT=1,NTEMP
               CGRID(IT)=CDATA(IT+2,ICOL)
 201        CONTINUE
            M=INT(CDATA(1,ICOL))
            MP=INT(CDATA(2,ICOL))
            TTP=TEMP*TP2TE
            CT=SPLIN(TTP,TGRID,CGRID,NTEMP,NINTEP)
C (note also swapped 7jul22)
            CUP = HD(6) * CT 
            CDN= CUP * (PSTAR(ILO)/G(ILO)) / (PSTAR(IHI)/G(IHI)) 
C (note pre 7jul22 MP,M order reversed in next line
            CMM(IHI,ILO,MP,M) = CDN + CMM(IHI,ILO,MP,M)
C (note should it be swapped here too? asked PGJ)
            CMM(ILO,IHI,M,MP) = CUP + CMM(ILO,IHI,M,MP)
C     
C     RECIPROCAL RELATION (EQ 7A OF LANDMAN 1975 A+A 43, 285)
C     
C (note pre 7jul22 MP,M order reversed in next lines
            CMM(IHI,ILO,-MP,-M) = CDN + CMM(IHI,ILO,-MP,-M)
            CMM(ILO,IHI,-M,-MP) = CUP + CMM(ILO,IHI,-M,-MP)
         ENDIF
 100  CONTINUE
      RETURN
      END
      

C
C PURPOSE: GENERAL ROUTINE FOR COMPUTING COLLISIONAL RATES
C     IN THE SYSNTHESIS CODE FOR M1 LINES, THIS SHOULD BE USED 
C     ONLY FOR DETERMINING IONIZATION BALANCE
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C     CATOM CATMOS CATMO2 CCONST CINPUT CLU
C COMMENTS: October 6, 1999, P. JUDGE
C 
C
C*********************************************************************
C
      SUBROUTINE GENCOL
C
C  GENERAL ROUTINE FOR COMPUTING COLLISIONAL RATES (VERSION MAR '89)
C  FORMAT IS EITHER GIVEN IN TERMS OF A COLLISION STRENGTH OMEGA
C         OR                          A CE(TE) RATE
C
C  OMEGAS ARE USED FOR CHARGED IONS IN GENERAL, 
C  SINCE THEY REMAIN ROUGHLY CONSTANT WITH TEMPERATURE.  
C  RATE IS PROP. TO 1/SQRT(TE) * EXP(DELTA-E)
C
C  CE(TE) VALUES ARE USED LARGELY FOR NEUTRALS FOR SAME REASON.
C  RATE IS PROP. TO SQRT(TE) * EXP(DELTA-E)
C
C  CI(TE) VALUES ARE USED FOR IONIZATION RATES: THESE HAVE A
C         SQRT(TE) * EXP(DELTA-E) DEPENDENCE AS FOR CE(TE)
C
C  ORIGINALLY CODED BY P.G. JUDGE,  APRIL 2ND, 1987
C  MODIFIED FOR FORTRAN-77 STANDARD BY P.G. JUDGE, MAY 21ST 1987
C:
C: GENCOL 87-05-21  NEW ROUTINE: (PHILIP JUDGE)
C:        GENERAL COLLISONAL ROUTINE READING TABLES
C:
C:        89-03-24  MODFICATIONS: (PHILIP JUDGE)
C:        NEW INPUT 'CP' AND 'CH' ADDED FOR INELASTIC COLLISIONS
C:        WITH NEUTRAL AND IONIZED HYDROGEN.
C:        'SEMI ' CHANGED SO THAT THE ABSORPTION OSCILLATOR STRENGTH 
C:        IS REQUIRED FOR INPUT.
C:
C:        89-06-07  MODIFICATIONS: (MATS CARLSSON)
C:        DO LOOP VARIABLE IT CHANGED TO JT IN ORDER NOT TO CONFLICT
C:        WITH THE MAIN ITERATION VARIABLE IT IN ITER
C:
C:        90-04-10  MODIFICATIONS: (PHILIP JUDGE)
C:        LOW TEMPERATURE DIELECTRONIC RECOMBINATION OPTION ADDED
C:        FOLLOWING NUSSBAUMER AND STOREY (A+A  )
C:        NOTE THAT ONLY THE RATE DOWNWARD IS ADDED TO THE FIXED RATE
C:
C:        90-08-27  MODIFICATIONS: (MATS CARLSSON)
C:        DO LOOP 1 REPLACED BY A GOTO TO REMOVE RESTRICTION ON
C:        NUMBER OF LINES WITH COLLISIONAL DATA
C:
C:        92-08-10  MODIFICATIONS (MATS CARLSSON)
C:        INTEGER ARRAYS WITH ELEMENT NAME CHANGED TO CHARACTER ARRAYS
C:
C:        92-09-07  MODIFICATIONS (MATS CARLSSON)
C:        ADDED OPTIONS RECOMB AND ALPHA
C:
C:        94-01-24  MODIFICATIONS (PHILIP JUDGE)
C:        AR85 OPTIONS ADDED.  ARNAUD AND ROTHENFLUG 1985
C:        94-02-22  MODIFICATIONS (PHILIP JUDGE)
C:        AR85-CEA FORMALISM ADDED
C:        94-03-08  MODIFICATIONS (PHILIP JUDGE)
C:        AR85-CH, AR85-CH+, AR85-CHE, AR85-CHE+, FORMALISM ADDED
C
      INCLUDE 'PREC'
      PARAMETER (MTGRD=50,MSHELL=5)
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CATMO2'
      INCLUDE 'CCONST'
      INCLUDE 'CINPUT'
      INCLUDE 'CLU'
C
C  LOCAL VARIABLES: UP TO MTGRD POINTS IN TEMPERATURE GRID ALLOWED
C  THIS CAN BE INCREASED
C
      DIMENSION TGRID(MTGRD),CGRID(MTGRD)
      DIMENSION CDI(5,MSHELL)
      CHARACTER *20 KEY
      CNST=0.0
C
C  OUTPUT FOR IWATOM .GT. 1
C
      IF(IWATOM .GT. 1)WRITE(LOUT,800)
  800   FORMAT('1 COLLISION RATES FROM SUBROUTINE  G E N C O L'//
     *  1X,'PARAMETERS ARE AS FOLLOWS:'//
     *  1X,'TEMP -   TEMPERATURE GRID GIVEN IN FILE ATOM'/
     *  1X,'         (SPLINE INTEPOLATIONS ARE MADE)'//
     *  1X,'CE   -   NEUTRAL B-B COLLISION RATE WHERE'/
     *  1X,'         R(U-L) = CE * NE * G(L) * SQRT(TEMP) / G(U)'//
     *  1X,'OHM  -   ION B-B COLLISION RATE WHERE'/
     *  1X,'         R(U-L) = OHM * NE * 8.63E-6 / SQRT(TEMP) / G(U)'//
     *  1X,'SEMI -   B-B COLLISIONAL RATE USING THE SEMI-EMPIRICAL')
      IF(IWATOM .GT. 1) WRITE(LOUT,801)
  801   FORMAT(1X,'         FORMULAE OF VAN REGEMORTER AND SHEVELKO'//
     *  1X,'CP   -   B-B COLLISIONAL RATE WITH PROTONS WHERE'/
     *  1X,'         R(U-L) = CP * NP '//
     *  1X,'CH   -   B-B COLLISIONAL RATE WITH NEUTRAL HYDROGEN WHERE'/
     *  1X,'         R(U-L) = CH * N(H I) '//
     *  1X,'CI   -   B-F IONIZATION RATE WHERE'/
     *  1X,'         R(L-U) = CI * NE * EXP(-DELTAE/KT) * SQRT(T)'//
     *  1X,'CALP -   COLLISIONS WITH ALPHA PARTICLES'/
     *  1X,'         R(I-J) = CALP * N(NK)'///
     *  1X,'***********************************************'/
     *  1X,'*** ALL THE ABOVE HAVE REVERSE RATES IN LTE ***'/
     *  1X,'*** THE FOLLOWING HAVE ZERO REVERSE RATES   ***'/
     *  1X,'*** UNLESS SPECIFIED EXPLICITLY             ***'/
     *  1X,'***********************************************'//
     *  1X,'CH0  -   CHARGE TRANSFER RATE WITH NEUTRAL HYDROGEN'/
     *  1X,'         R(I-J) = CH0 * NH(LEVEL1)'//
     *  1X,'CH+  -   CHARGE TRANSFER RATE WITH IONIZED HYDROGEN'/
     *  1X,'         R(I-J) = CH+ * N(H II)'///
     *  1X,'RECO -   RECOMBINATION RATE'/
     *  1X,'         R(J-I) = RECO * NE'///
     *  1X,'CONS -   CONSTANT RATE'/
     *  1X,'         R(J-I) = CONST '///
     *  1X,'KEY ','FROM  TO  PARAMETERS... '/)
C
C  ASSUME INITIALLY THAT DATA ARE GIVEN INDEPENDENT OF TEMPERATURE:
C  I.E. THAT NTEMP IS ORIGINALLY SET = 1
C
      NTEMP=1
C
C  READ THE KEYWORD 'KEY' AND ASSOCIATED PARAMETERS
C
   50 CONTINUE
        READ(LDUMS,100,END=301)KEY
  100   FORMAT(A)
        CALL LJUST(KEY)
        IF(KEY(1:1) .EQ. ' ') GOTO 50
        IF (KEY(1:3) .EQ. 'END')THEN
          GOTO 300
        ELSE IF (KEY(1:4) .EQ. 'TEMP')THEN
          READ(LDUMS,*)NTEMP,(TGRID(JT),JT=1,MIN(NTEMP,MTGRD))
          IF(NTEMP .GT. MTGRD)THEN
            CALL STOP(' GENCOL: WORK ARRAYS (TGRID) TOO SMALL')
          ENDIF
          IF (IWATOM .GT. 1)THEN
            WRITE(LOUT,803)KEY(1:4),(TGRID(JT),JT=1,NTEMP)
  803       FORMAT(1X,A,8X,10(1P,1X,E10.3))
          ENDIF
          GOTO 50
        ELSE IF (KEY(1:4) .EQ. 'SEMI') THEN
          READ(LDUMS, *) IL,IH, FAB
          IF(IWATOM .GT. 1)WRITE(LOUT,8004)KEY(1:4),IL,IH
 8004     FORMAT(1X,A,2(2X,I2))
        ELSE IF (KEY(1:4) .EQ. 'LTDR') THEN
          READ(LDUMS, *) IL,IH, ALTDR,BLTDR,CLTDR,DLTDR,FLTDR
          IF(IWATOM .GT. 1)WRITE(LOUT,8005)KEY(1:4),IL,IH,ALTDR,
     *      BLTDR,CLTDR,DLTDR,FLTDR
 8005     FORMAT(1X,A,2(2X,I2),5(2X,F11.4))
C
C  ADDITION P. JUDGE 24-JAN-1994: BEGIN
C
        ELSE IF (KEY(1:7) .EQ. 'AR85-RR') THEN
          READ(LDUMS, *) IL,IH,ARADAR,ETAAR
        ELSE IF (KEY(1:8) .EQ. 'AR85-CDI') THEN
          READ(LDUMS, *) IL,IH,NCDI
          IF(NCDI .GT. MSHELL) CALL STOP('GENCOL: NCDI .GT. MSHELL')
          READ(LDUMS,*) ((CDI(J,I),J=1,5),I=1,NCDI)
C
C  ADDITION P. JUDGE 24-JAN-1994: END
C
C:
C: 22-FEB-1994 P.G.JUDGE MODIFICATIONS START:
C:
        ELSE IF (KEY(1:8) .EQ. 'AR85-CEA') THEN
          READ(LDUMS, *) IL,IH,CEAFAK
          ILO=MIN( IL, IH )
          IHI=MAX( IL, IH )
          CALL AR85CEA(ILO,IHI,CEA)
            CEA=CEA*CEAFAK
C:
C: 22-FEB-1994 P.G.JUDGE MODIFICATIONS END:
C:
C:
C: 08-MAR-1994 P.G.JUDGE MODIFICATIONS START:
C:  ALL FOUR CHARGE TRANSFER KEYWORDS HERE
        ELSE IF (KEY(1:7) .EQ. 'AR85-CH') THEN
          READ(LDUMS, *) IL,IH
          READ(LDUMS,*) AR85T1,AR85T2,AR85A,AR85B,AR85C,AR85D
C:
C: 08-MAR-1994 P.G.JUDGE MODIFICATIONS END:
C:
        ELSE IF (KEY(1:7) .EQ. 'SHULL82') THEN
          READ(LDUMS, *) IL,IH,ACOLSH,TCOLSH,ARADSH,XRADSH,ADISH,
     *      BDISH,T0SH,T1SH
          IF(IWATOM .GT. 1)WRITE(LOUT,8006)KEY(1:6),IL,IH,ACOLSH,
     *    TCOLSH,ARADSH,XRADSH,ADISH,BDISH,T0SH,T1SH
 8006     FORMAT(1X,A,2(2X,I2),8(2X,1P,E11.4))
        ELSE IF (KEY(1:6) .EQ. 'CORONA') THEN
          READ(LDUMS, *) IL,IH
          IF(IWATOM .GT. 1)WRITE(LOUT,8004)KEY(1:6),IL,IH
        ELSE IF (KEY(1:8) .EQ. 'CONSTANT') THEN
          READ(LDUMS, *) IL,IH, CNST
          IF(IWATOM .GT. 1)WRITE(LOUT,8014)KEY(1:4),IL,IH, CT
 8014     FORMAT(1X,A,2(2X,I2),2X,1P,E11.4)
        ELSE IF (KEY(1:3) .EQ. 'OHM'
     *  .OR.     KEY(1:2) .EQ. 'CE'
     *  .OR.     KEY(1:2) .EQ. 'CP'
     *  .OR.     KEY(1:2) .EQ. 'CH'
     *  .OR.     KEY(1:4) .EQ. 'CALP'
     *  .OR.     KEY(1:4) .EQ. 'RECO'
     *  .OR.     KEY(1:3) .EQ. 'CH0'
     *  .OR.     KEY(1:3) .EQ. 'CH+'
     *  .OR.     KEY(1:2) .EQ. 'CI'  )THEN
          READ(LDUMS,*)IL,IH,(CGRID(JT),JT=1,NTEMP)
          NINTEP=NTEMP
C:
C: 23-FEB-1994 P.G.JUDGE MODIFICATIONS START:
C: SPECIAL CASE OF RAPID TE DEPENDENCE- INTERPOLATE LINEARLY
          IF(KEY(1:3) .EQ. 'CH+' .OR. KEY(1:3) .EQ. 'CH0') THEN
            NINTEP=2
c            WRITE(LJOBLO,*)'LINEAR INTERPOLATION OF LOG10 ',KEY(1:3)
c     *      ,  ' BETWEEN LEVELS', IL, IH
            DO 333 JT=1,NTEMP
              CGRID(JT)=LOG10(CGRID(JT))
  333       CONTINUE
          ENDIF
C:
C: 23-FEB-1994 P.G.JUDGE MODIFICATIONS END:
C:
          IF(IWATOM .GT. 1)THEN
            WRITE(LOUT,802)KEY(1:4), IL, IH, (CGRID(JT),JT=1,NTEMP)
  802       FORMAT(1X,A,2(2X,I2),10(1P,1X,E10.3))
          ENDIF
        ELSE
          WRITE(LJOBLO,191)KEY(1:4)
  191     FORMAT('  GENCOL: KEYWORD(1:4) IS  (',A,')')
          CALL STOP(' GENCOL:  UNKNOWN KEYWORD IN ATOMIC DATA')
        ENDIF
C
C  IDENTIFY THE UPPER AND LOWER LEVELS:
C
        ILO=MIN( IL, IH )
        IHI=MAX( IL, IH )
C
C  CHECK TO SEE THAT THE LEVELS ARE BETWEEN 1 AND NK
C
        IF(ILO .LT. 1 .OR. IHI .GT. NK)
     *  CALL STOP(' GENCOL:  LEVEL INDEX OUTSIDE RANGE (1,NK)')
C
C  CHECK TO SEE IF THERE ARE LEVELS WITH ENERGIES NOT INCREASING WITH
C  THE LEVEL LABEL (THIS AFFECTS CI ETC.)
C
        IF(EV(IHI) .LT. EV(ILO) )THEN
          WRITE(LJOBLO,1001)KEY(1:4),IHI,ILO
 1001     FORMAT('  GENCOL:  WARNING- KEYWORD ',A,2(2X,I2),
     *           ' ENERGY OF UPPER LEVEL IS .LT. LOWER LEVEL'/
     *           '           WARNING- CHECK RESULTS CAREFULLY')
        ENDIF
C
C  DEPTH DO-LOOP:
C
C
C  SEMI-EMPIRICAL COLLISIONS
C
          IF (KEY(1:4)  .EQ.  'SEMI')THEN
            EUPCM=EV(IHI)*EE/CC/HH
            ELOCM=EV(ILO)*EE/CC/HH
            FEM = FAB*G(ILO)/G(IHI)
            CT=SEMIC(ION(ILO),EUPCM,ELOCM,FEM,TEMP,III)
            CDN=CT*NE
            CUP = CDN * NSTAR(IHI) / NSTAR(ILO)
            C(IHI,ILO) = CDN + C(IHI,ILO)
            C(ILO,IHI) = CUP + C(ILO,IHI)
C
C  CORONAL ION BALANCE DATA (FROM DATA READ IN OPACITY PACKAGE)
C
          ELSE IF (KEY(1:6)  .EQ.  'CORONA')THEN
            PE=BK*NE*TEMP
            CALL CORONR(ATOMID(1:3),ION(ILO),TEMP,PE,RECRAT,RIRAT)
            C(IHI,ILO) =  C(IHI,ILO) + RECRAT*NE
            C(ILO,IHI) =  C(ILO,IHI) + RIRAT*NE
          ELSE
            IF(TEMP .LT. TGRID(1)) THEN
              CT=CGRID(1)
            ELSE IF (TEMP .GT. TGRID(NTEMP)) THEN
              CT=CGRID(NTEMP)
            ELSE
              CT=SPLIN(TEMP,TGRID,CGRID,NTEMP,NINTEP)
            ENDIF
          ENDIF
          IF(KEY(1:3) .EQ. 'CH+' .OR. KEY(1:3) .EQ. 'CH0') CT=10.**CT
          IF(CT .LT. 0.) THEN
            WRITE(LJOBLO,*)'INTERPOLATED COLLISION PARAMETER < 0.',
     *        ' AT TEMPERATURE ', TEMP
            WRITE(LJOBLO,*)'FOR TRANSITION ', KEY,' ',IL,' ', IH
            WRITE(LJOBLO,*)(TGRID(JT),JT=1,NTEMP)
            WRITE(LJOBLO,*)(CGRID(JT),JT=1,NTEMP)
            CALL STOP('NEGATIVE COLLISION RATES ENCOUNTERED')
          ENDIF
C
C  OMEGAS ARE GIVEN (+VE IONS)
C
          IF(KEY(1:3) .EQ. 'OHM') THEN
            CDN = 8.63E-06 * CT * NE / ( G(IHI)*SQRT(TEMP) )
            CUP = CDN * NSTAR(IHI) / NSTAR(ILO)
            C(IHI,ILO) = CDN + C(IHI,ILO)
            C(ILO,IHI) = CUP + C(ILO,IHI)
C
C  CE VALUES ARE GIVEN (NEUTRALS)
C
          ELSE IF (KEY(1:2) .EQ. 'CE')THEN
            CDN = NE * CT * G(ILO) * SQRT(TEMP) / G(IHI)
            CUP= CDN * NSTAR(IHI) / NSTAR(ILO)
            C(IHI,ILO) = CDN + C(IHI,ILO)
            C(ILO,IHI) = CUP + C(ILO,IHI)
C
C  CP VALUES ARE GIVEN (B-B COLLISIONS WITH PROTONS)
C
          ELSE IF (KEY(1:2) .EQ. 'CP')THEN
            CDN = NH(6) * CT
            CUP= CDN * NSTAR(IHI) / NSTAR(ILO)
            C(IHI,ILO) = CDN + C(IHI,ILO)
            C(ILO,IHI) = CUP + C(ILO,IHI)
C
C  CH VALUES ARE GIVEN (COLLISIONS WITH NEUTRAL HYDROGEN)
C
          ELSE IF (KEY(1:3) .EQ. 'CH ')THEN
            CDN = NH(1) * CT 
            CUP= CDN * NSTAR(IHI) / NSTAR(ILO)
            C(IHI,ILO) = CDN + C(IHI,ILO)
            C(ILO,IHI) = CUP + C(ILO,IHI)
C
C  CI VALUES ARE GIVEN
C
          ELSE IF (KEY(1:2) .EQ. 'CI')THEN
            DEKT=  (EV(IHI)-EV(ILO)) * EK / TEMP
            CUP = NE * CT * EXP(-DEKT) * SQRT(TEMP)
            CDN = CUP * NSTAR(ILO) / NSTAR(IHI)
            C(IHI,ILO) = CDN + C(IHI,ILO)
            C(ILO,IHI) = CUP + C(ILO,IHI)
C
C  CH OR CH+ VALUES GIVEN:  CHARGE TRANSFER COLLISIONS WITH 
C            HYDROGEN ATOMS/IONS  NB:  ORDERING IMPORTANT HERE
C  EXAMPLE INPUT:
C
C  CH0
C  1  2  1.E-9 1.E-9 1.E-9
C
C  THIS ASSUMES THAT THE RATE 1.E-9*NH(1) WILL BE ADDED TO THE
C  COLLISION RATE FROM LEVEL 1 TO LEVEL 2
C
          ELSE IF (KEY(1:3) .EQ. 'CH0')  THEN
            C(IL,IH)= NH(1) * CT  + C(IL,IH)
          ELSE IF (KEY(1:3) .EQ. 'CH+') THEN
            C(IL,IH)= NH(6) * CT  + C(IL,IH)
C
C  LOW-TEMPERATURE DIELECTRONIC RECOMBINATION COEFFS. ARE GIVEN
C  FORMULA (9) OF NUSSBAUMER AND STOREY (A+A PAPER II)
C
          ELSE IF(KEY(1:4) .EQ. 'LTDR') THEN
            T4LTDR=TEMP/1.E4
            CDN = 1.E-12*NE* (ALTDR/T4LTDR + BLTDR +
     *             CLTDR*T4LTDR +DLTDR*T4LTDR*T4LTDR) *
     *             EXP(-FLTDR/T4LTDR)/T4LTDR/SQRT(T4LTDR)
            C(IHI,ILO) = CDN + C(IHI,ILO)
C
C  ADDITION P. JUDGE 24-JAN-1994: BEGIN
C
C  PARAMETRIC FITS TO DATA OF ARNAUD AND ROTHENFLUG 1985,
C  APJS 60, 425.
C  CDI IS 5 BY MSHELL ELEMENT ARRAY, CONTAINING PARAMETERS
C  I, A,B,C,D OF TABLE 1 OF ARNAUD AND ROTHENFLUG
          ELSE IF(KEY(1:7) .EQ. 'AR85-RR') THEN
            CDN= ARADAR*(TEMP/1.E4)**ETAAR
            C(IHI,ILO) = CDN + C(IHI,ILO)
          ELSE IF(KEY(1:8) .EQ. 'AR85-CDI') THEN
            CUP=0.
            DO 321 J=1,NCDI
              XJ=CDI(1,J)*EE/BK/TEMP
              FXJ=EXP(-XJ)*SQRT(XJ) *(CDI(2,J)+CDI(3,J)*(1.+XJ) +
     *         (CDI(4,J)-XJ*(CDI(2,J)+CDI(3,J)*(2.+XJ)))*FONE(XJ) +
     *         CDI(5,J)*XJ*FTWO(XJ))
              CUP = CUP+ 6.69E-07 / CDI(1,J) / SQRT(CDI(1,J))*FXJ
  321       CONTINUE
            IF(CUP .LT. 0.) CALL STOP('GENCOL: CDI-CUP .LT.0')
            C(ILO,IHI) = CUP*NE + C(ILO,IHI)
            C(IHI,ILO) = CUP*NE*NSTAR(ILO)/NSTAR(IHI)
     *          + C(IHI,ILO)
C
C  ADDITION P. JUDGE 24-JAN-1994: END
C
C:
C: 22-FEB-1994 P.G.JUDGE MODIFICATIONS START:
C:
          ELSE IF(KEY(1:8) .EQ. 'AR85-CEA') THEN
            C(ILO,IHI) = CEA*NE + C(ILO,IHI)
C
C  THIS IS INCORRECT SINCE POPULATION OF UPPER LEVEL IS THE UPPER LEVEL
C  OF THE DOUBLY EXCITED STATE, **, I.E. THIS SHOULD BE MULTIPLIED BY 
C  G(**)/G(IHI) EXP(E(**) - E(IHI)).  A BETTER APPROXIMATION WOULD SEEM TO
C  BE 0. TIMES THIS TO AVOID PROBLEMS. HENCE COMMENT THIS LINE OUT
C  
C            C(IHI,ILO) = CEA*NE*NSTAR(ILO)/NSTAR(IHI)
C     *          + C(IHI,ILO)
C:
C: 22-FEB-1994 P.G.JUDGE MODIFICATIONS END:
C:
C:
C: 08-MAR-1994 P.G.JUDGE MODIFICATIONS START:
C:
C:  AR85-CH    CHARGE TRANSFER RECOMBINATION WITH NEUTRAL HYDROGEN
C:
          ELSE IF(KEY(1:7) .EQ. 'AR85-CH' .AND. KEY(1:8) .NE. 
     *  'AR85-CH+' .AND. KEY(1:8) .NE. 'AR85-CHE') THEN
            IF(TEMP .GE. AR85T1 .AND. TEMP .LE. AR85T2) THEN 
              T4=TEMP/1.E4
              CUP = AR85A * 1.E-9 * T4**AR85B * (1. + AR85C 
     *               * EXP(AR85D*T4))*NH(1)           
              C(IL,IH) = CUP + C(IL,IH)
            ENDIF
C:
C:  AR85-CH+   CHARGE TRANSFER WITH IONIZED HYDROGEN
C:
          ELSE IF(KEY(1:8) .EQ. 'AR85-CH+') THEN 
            IF(TEMP .GE. AR85T1 .AND. TEMP .LE. AR85T2) THEN 
              T4=TEMP/1.E4
              CUP = AR85A * 1.E-9 * T4**AR85B * EXP(-AR85C*T4) 
     *               * EXP(-AR85D*EE/BK/TEMP)*NH(6) 
              C(IL,IH) = CUP + C(IL,IH)
            ENDIF
C: 
C:  AR85-CHE   CHARGE TRANSFER WITH NEUTRAL HELIUM
C:
C:
C: 08-MAR-1994 P.G.JUDGE MODIFICATIONS END:
C:
C
C  COMPUTATIONS FROM TABLES OF SHULL & VAN STEENBERG, 
C  AP J SUPPL  48 P95
C
          ELSE IF(KEY(1:7) .EQ. 'SHULL82') THEN
            CDN=ARADSH*(TEMP/1.E4)**(-XRADSH)  +  
     *        ADISH /TEMP/SQRT(TEMP) * EXP(-T0SH/TEMP)*  
     *        (1.E0+BDISH * (EXP(- T1SH/TEMP)))
         CDN=CDN*NE
         CUP=ACOLSH * SQRT(TEMP) * EXP( -TCOLSH / TEMP) 
     *         / (1.E0 + 0.1 * TEMP / TCOLSH) 
         CUP=CUP*NE
C*
C*  3-BODY RECOMBINATION (HIGH DENSITY LIMIT)
C*
         CDN=CDN+CUP*NSTAR(ILO)/NSTAR(IHI)
C*  
         C(IHI,ILO) = CDN + C(IHI,ILO)
         C(ILO,IHI) = CUP + C(ILO,IHI)
C
C  CALP VALUES ARE GIVEN (COLLISIONS WITH ALPHA PARTICLES)
C  ATOM HAS TO BE HE
C  INITIA IS CALLED FOR FIRST RATE TO READ POPULATIONS
C  FROM RSTRT
C
C  RECOMBINATION COEFFICIENTS ARE GIVEN
C  C(J-I)=NE*CT
C
          ELSE IF (KEY(1:4) .EQ. 'RECO') THEN
            C(IHI,ILO)= NE*CT + C(IHI,ILO)
C
C  SIMPLE ADDITION OF CONSTANT, FOR EXAMPLE FOR PHOTOIONIZATION
C  C(J-I)=CT
C
          ELSE IF (KEY(1:8) .EQ. 'CONSTANT') THEN
            C(IL,IH)= CNST + C(IL,IH)
C
C  MORE KEYWORDS CAN BE ADDED HERE
C
          ENDIF
      GOTO 50
C
 301  CALL STOP(' GENCOL: KEYWORD ''END'' NOT FOUND IN COLLISION FILE')
 300  CONTINUE
      RETURN
      END
C
C***********************************************************************
C
      FUNCTION SEMIC(Z,EUP,ELO,FEM,TEMP,IFLAG)
C
C  RETURNS COLLISION RATE DOWNWARDS USING SEMI-EMPIRICAL GF'S
C
C  P.G. JUDGE, NOVEMBER 1987.
C
C  INPUT:
C         Z      - CHARGE OF ION+1 (E.G. FOR C II Z=2)
C         EUP    - ENERGY OF UPPER LEVEL IN CM-1
C         ELO    - ENERGY OF LOWER LEVEL IN CM-1
C         FEM    - EMISSION OSCILLATOR STRENGTH ( = GF/G(UPPER))
C         TEMP   - TEMPERATURE IN DEGREES KELVIN
C
C  OUTPUT:
C         IFLAG  -  = 1 FOR VAN REGEMORTER APPROXIMATION
C         IFLAG  -  = 2 FOR SHEVELKO       APPROXIMATION
C         SEMIC-  DOWNWARD COLLISION RATE IN CM3 /S
C
      INCLUDE 'PREC'
      INTEGER Z
      DATA C1,RY /1.43882,109737.312/
C
C INITIALIZE
C
      DELTE=EUP-ELO
      BETA=DELTE*C1/TEMP
      SEMIC=0.0
C
C  IFLAG=1 => VAN REGEMORTER APPROXN.
C
      IF(BETA .GE. 0.01)THEN
        IFLAG=1
        SEMIC = 3.2E-7*FEM*(RY/DELTE)**1.5*SQRT(BETA)*P(Z,BETA)
C
C  IFLAG=2 => SHEVELKO APPROX
C
      ELSE IF(BETA .LT. 0.01)THEN
        IFLAG=2
        SEMIC=1.74E-07*FEM*EXP(BETA)/SQRT(BETA*DELTE/RY)
     +  *LOG( ELO / DELTE * SQRT(RY / C1 / TEMP))
      ENDIF
C
      RETURN
      END
C
C **********************************************************************
C
      FUNCTION P(Z,B)
C
C  THERMAL P-FUNCTION FOR SEMIC EMPIRICAL COLLISION RATES
C  REFERENCE: SOBEL'MAN - 'ATOMIC PHYSICS II.  '
C
      INCLUDE 'PREC'
      PARAMETER (N1=10)
      DIMENSION  BETREF(N1),PNREF(N1),PCREF(N1)
      INTEGER Z
      DATA BETREF/-2.0,-1.699,-1.398,-1.0,-0.699,-0.398,0.0
     +  ,0.301,0.602,1.0/
      DATA PNREF/1.160,0.956,0.758,0.493,0.331,0.209
     +  ,0.100,0.063,0.040,0.023/
      DATA PCREF/1.160,0.977,0.788,0.554,0.403
     +  ,0.290,0.214,0.201,0.200,0.200/
C
C  LIMIT OF HIGH TEMPERATURE: KT >> E
C
      IF (B .LT. 0.01)THEN
        P = 0.27566 * (0.577 + LOG(B))
      RETURN
C
C  INTERMEDIATE TEMPS (MOST IMPORTANT FOR EQM PLASMAS)
C  SPLINE INTERPOLATION ONTO LOGB GRID:
C
      ELSE IF(B .GT. 0.01 .AND. B .LT. 10.0)THEN
        BB=LOG10(B)
        IF (Z .EQ. 1)P = SPLIN(BB,BETREF,PNREF,N1,N1)
        IF (Z .GT. 1)P = SPLIN(BB,BETREF,PCREF,N1,N1)
      RETURN
C
C  LIMIT OF LOW TEMPERATURE: KT << E
C
      ELSE  IF(B .GT. 10.0)THEN
        IF(Z .EQ. 1)P = 0.066 / SQRT(B)
        IF(Z .GT. 1)P = 0.200
        RETURN
      ENDIF
      END
C
C **********************************************************************
C
      SUBROUTINE CORONR(CEL,ION,TEMP,PRESS,RRATE,RIRATE)
C
C  CORONAL ION BALANCE CALCULATION
C  NEW ROUTINE FOR USE WITH V2.0 OPACITY PACKAGE AND GENCOL
C
C  INPUT:  ELEMENT IDENTIFIER    CEL (CHARACTER)
C          ION STAGE IDENTIFIER  ION (INTEGER)
C          TEMP   (ELECTRON TEMPERATURE IN K       (RL)
C          PRESS  (ELECTRON PRESSURE IN DYNE/CM2)  (RL)
C
C  OUTPUT: RRATE    RECOMBINATION RATE (CM3/S)
C          RIRATE   IONIZATION RATE    (CM3/S)
C  
C  EXAMPLE:
C          CEL='C  ', ION=1, WILL RETURN 
C          THE RECOMBINATION RATE PER C II ATOM PER ELECTRON
C          AND THE IONIZATION RATE PER C I ATOM PER ELECTRON
C
C  NOTES:
C          COMPUTATIONS FROM TABLES OF SHULL & VAN STEENBERG, 
C          AP J SUPPL  48 P95
C          NO PE-DEPENDENCE, THIS COULD BE ADDED WHEN COMPUTATIONS BECOME
C          AVAILABLE
C          IF THE ION FRACTION IS NOT FOUND THEN THE ROUTINE WILL STOP
C          
C  89-03-28 NEW ROUTINE (PHILIP JUDGE)
C
C: CORONR 92-08-10  MODIFICATIONS (MATS CARLSSON)
C:        INTEGER ARRAYS WITH ELEMENT NAME CHANGED TO CHARACTER ARRAYS
C:
C:        92-09-09  MODIFICATIONS (MATS CARLSSON)
C:        INTEGER IEL IN WRITE STATEMENT CHANGED TO CHARACTER
C:
      INCLUDE 'PREC'
      PARAMETER (MCOR=30)
      INTEGER NCOR,IONCOR(MCOR)
      DOUBLE PRECISION ARADC(MCOR),XRADC(MCOR),ADIC(MCOR),T0C(MCOR),
     * BDIC(MCOR),T1C(MCOR),ACOLC(MCOR),TCOLC(MCOR),TECOR,DECOR
      COMMON /CCORON/ TECOR,DECOR,
     * ARADC,XRADC,ADIC,T0C,BDIC,T1C,ACOLC,TCOLC,NCOR,IONCOR
      CHARACTER*3 CCOR
      COMMON /CCCOR/ CCOR(MCOR)
      COMMON /CLU/ LINPUT,LATOM,LATOM2,LATMOS,LDSCAL,LABUND,LOUT,
     * LTIME,LRSTRT,LDSCA2,LWMAT,LNIIT,LDUMS,LDUMI,LDUMC,LOPC,
     * LJNY,LINIT,LPHI,LJOBLO,LATHSE
      CHARACTER*(*) CEL
C
C  IDENTIFY THE ELEMENT AND IONIZATION STAGE TO BE COMPUTED
C
      DO 100 N=1,NCOR
        IF( CEL .EQ. CCOR(N) .AND. ION .EQ. IONCOR(N) )GOTO 99
  100 CONTINUE
      WRITE(LJOBLO,1024) CEL,ION
 1024  FORMAT(' CORONR: SPECIES',A3,I3,' NOT FOUND IN ABSDAT FILE')
      CALL STOP(' ')
C
C  ELEMENT HAS BEEN COMPUTED- NOW RETURN THE RATES
C
   99 RRATE=ARADC(N)*(TEMP/1.E4)**(-XRADC(N))  +     
     *  ADIC(N) * (TEMP**(-1.5)) * EXP(-T0C(N)/TEMP)*
     *  (1.E0+BDIC(N) * (EXP(- T1C(N)/TEMP)))
      RIRATE=ACOLC(N) * SQRT(TEMP) * EXP( -TCOLC(N) / TEMP)
     *    / (1.E0 + 0.1 * TEMP / TCOLC(N))
      RETURN
      END

C
C PURPOSE: SETS CONSTANT PHYSICAL DATA
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      BLOCK DATA SCONST
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CCONST'
      INCLUDE 'CBCNST'
      INCLUDE 'CINTS'
      DATA EE/1.602189E-12/,HH/6.626176E-27/,CC/2.99792458E10/,
     * EM/9.109534E-28/,UU/1.6605655E-24/,BK/1.380662E-16/,
     * PI/3.14159265359/,RSUNCM/6.9599E10/
      DATA ZERO/0./,ONE/1./,TWO/2./,THREE/3./,FOUR/4./,
     * FIVE/5./,SIX/6./,SEVEN/7./,EIGHT/8./,ZNINE/9./,TEN/10./
C
C  MACHINE DEPENDENT DATA:
C  NEWSTA   ACTUAL STATUS USED IN OPEN WHEN ASKED FOR STATUS='NEW'
C           RECOMMENDED VALUES:
C           VMS    'NEW'     GIVES A NEW VERSION
C           UNIX   'UNKNOWN' PREVENTS CRASH IF FILE ALREADY EXISTS
C  IRC      RECORD LENGTH OF DIRECT ACCESS FILES IS SET TO THE
C           NUMBER OF WORDS*IRC. IF THE RECORD LENGTH IS 
C           TO BE GIVEN IN 4 BYTE WORDS, IRC SHOULD BE 1 IN SINGLE
C           PRECISION, 2 IN DOUBLE PRECISION (EXAMPLES: VAX, DEC ULTRIX)
C           IF THE RECORD LENGTH IS TO BE GIVEN IN BYTES, IRC SHOULD BE
C           4 FOR 32 BIT PRECISION, 8 FOR 64 BIT PRECISION RUNS.
C
C PGJ  12-APRIL-1991  8 FOR DOUBLE PRECISION, 4 FOR SINGLE ON SUN IPC
C Note switched to 4 to be consistent with 6jul22 version
      DATA NEWSTA,IRC/'UNKNOWN',4/
C       DATA NEWSTA,IRC/'UNKNOWN',1/
C END PGJ 
C
      END
C
C***********************************************************************
C

C
C PURPOSE: INITIALIZE VARIABLES.  SOME SHOULD BE RELACED BY INPUT FILE
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE START
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CATMOS'
      INCLUDE 'CSLINE'
      INCLUDE 'CCONST'
      INCLUDE 'CINPUT'
      INCLUDE 'CLU'
      INCLUDE 'COPCL'
C
C  OPEN GLOBAL FILES ALWAYS NEEDED
C
      I=1
      CALL OPEN(LOUT,'OUT',I,'NEW')
      I=1
      CALL OPEN(LTIME,'TIME',I,'NEW')
      I=1
      CALL OPEN(LJOBLO,'JOBLOG',I,'NEW')
      I=1
      CALL OPEN(LDUMS,'DUMS',I,'NEW')
C
C SOME CONSTANTS, THAT COULD BE REPLACED BY READING INPUTS
C
      CALL RINPUT

      IF(IWATMO .NE. 0) THEN 
        I=0
        CALL OPEN(LATMOS,'ATMOS',I,'NEW')
        WRITE(LATMOS) CRTN
      ENDIF
      
C     
C  NEEDED FOR RACAH ALGEBRA
C
      CALL FCTSG
C
C  READ ATOMIC PARAMETERS
C
      CALL ATOM
      CALL WATOM(1)
      CALL ATOM1
      CALL COLRD
      CALL FREQ
      CALL GRID
      RETURN
      END

C
C PURPOSE: WRITES FREQUENCY QUADRATURE TO OUTPUT LISTING
C
C INPUTS:
C
C OUTPUTS:
C
C COMMON:
C
C COMMENTS: OCTOBER 6, 1999, P. JUDGE
C 
      SUBROUTINE WFREQ
C
C  
C
      INCLUDE 'PREC'
      INCLUDE 'PARAM'
      INCLUDE 'CATOM'
      INCLUDE 'CSLINE'
      INCLUDE 'CINPUT'
      INCLUDE 'CLU'
C
      IF(IWLINE.EQ.0) RETURN
C
      DO 10 KR=1,NLINE
         J=JRAD(KR)
         I=IRAD(KR)
         WRITE(LOUT,100) CONVL(ALAMB(KR)),J,I,LABEL(J),LABEL(I),
     *        Q(NQ(KR),KR)
 100     FORMAT(///'  LINE CENTER, LAMBDA=',F10.3,8X,I2,'-',I2,' (',
     *        A,'-',A,')',8X,'LINE WING, NY=',F10.3)
         WRITE(LOUT,310)
 310     FORMAT(//'  FREQUENCY QUADRATURE')
         DO 330 M=1,NQ(KR),10
            NYMAX=MIN(NQ(KR),M+9)
            WRITE(LOUT,320) (Q(NY,KR),NY=M,NYMAX)
            WRITE(LOUT,325) (DLAMB(Q(NY,KR),KR),NY=M,NYMAX)
 320        FORMAT(/9X,'Q',1P,10E11.3)
 325        FORMAT('  ANGSTROM',1P,10E11.3)
 330     CONTINUE
 10   CONTINUE
C     
      RETURN
      END

#!/bin/csh
# 
#
foreach f (*.f)
  echo 'doing ' $f
  if(-e a.jou) \rm a.jou
  cat $f | sed -e '/LOUT1/s/LOUT1/LOUT/' \
| sed -e '/LOUT1/s/LOUT1/LOUT/' \
| sed -e '/LOUT1/s/LOUT1/LOUT/'  > a.jou
  mv a.jou $f
end
#

#

# 
#
\rm a.jou
foreach f ( *.f ) 
    echo 'doing ' $f
    cat $f | sed  's/ZERO/0.d0/g' \
    | sed  's/TWO/2.d0/g' \
    | sed  's/ONE/1.d0/g' \
    | sed  's/THREE/3.d0/g'  \
    | sed  's/FOUR/4.d0/g'  \
    | sed  's/FLOAT/double/g'  \
    | sed  's/\.EQ\./ EQ /g'  \
    | sed  's/\.LE\./ LE /g'  \
    | sed  's/\.LT\./ LT /g'  \
    | sed  's/\.GT\./ GT /g'  \
    | sed  's/\.GE\./ GE /g'  \
    | sed  's/\.NE\./ NE /g'  \
    | sed  's/\.AND\./ and /g'  \
    | sed  's/ENDDO/ endfor /g'  \
    | sed  's/DO /FOR? /g'  \
    | sed  's/\.AND\./ and /g' > a.jou
    echo '\mv a.jou $f.new'
   \mv a.jou $f.new
# ls $f
end

#
